<?php

include("application.php");

// ---------------
//  functions
// ---------------

function ShowFormAddUrl() {

  // vars global configuration
  global $dbServer, $dbHostname, $dbUsername, $dbPassword, $dbName,
    $category_separator, $theme_path, $HTTP_POST_VARS;

  // vars url & form
  global $cat;  

  // vars messages
  global $msg;

  // vars template
  global $error_msg, $title, $url, $description, $category, $contact_name, $email, $custom_field_form;
  
  $title = $HTTP_POST_VARS['title'];

  
  if(empty($cat)) {
    DisplayTemplate($theme_path."add_error.html",
      "\$novar");
  }
  else { 
  
    // get category path
  
    $category_obj = new clsCategory;
    $category_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
    $category_obj->table_name = "idx_category";
    $category_obj->link_table_name = "idx_link";
    $category_obj->separator = $category_separator; 
    $category = $category_obj->GetCategoryPath($cat);
    $category .= "\n<input type=hidden name=cat value=$cat>";

    $title = stripslashes($title);
    $url = stripslashes($url);
    $description = stripslashes($description);
    $contact_name = stripslashes($contact_name);
    $email = stripslashes($email);

    // generate custom field
  
    $links_obj = new clsLink;
    $links_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
    $links_obj->table_name = "idx_link";
    $links_obj->category_table_name = "idx_category";

    $links_obj->autogenerate_form_text = $msg["00001"];
    $links_obj->autogenerate_form_textarea = $msg["00002"];
    $links_obj->autogenerate_form_template = $theme_path."custom_field_form_rows.html";

    $links_obj->autogenerate_form_upload_add_form = $msg["00005"];
        
    $custom_field_form = $links_obj->GenerateCustomFieldForm(false,true);
  
    DisplayTemplate($theme_path."add_form.html",
      "\$error_msg,\$title,\$url,\$description,\$category,\$contact_name,\$email,\$custom_field_form");
  }
}


function ProcessFormAddUrl() {

  // vars global configuration
  global $site_url, $dbServer, $dbHostname, $dbUsername, $dbPassword, $dbName,
    $theme_path, $category_separator, $HTTP_POST_VARS, $new_limit;
  
  // vars url & form
  global $cat;
      
  // vars messages
  global $msg;
  
  // vars template
  global $error_msg, $password, $link_id, $title, $url, $description, $contact_name, $email, $bid, $category;
  

  $title = $HTTP_POST_VARS['title'];
  
  // verify input
  
  if(empty($title)) $error_msg = $msg["10101"];
  elseif(empty($url) || $url == 'http://') $error_msg = $msg["10102"];
  elseif(empty($description)) $error_msg = $msg["10103"];
  elseif(empty($contact_name)) $error_msg = $msg["10104"];
  elseif(empty($email)) $error_msg = $msg["10105"];
  elseif (!IsEmailAddress($email)) $error_msg = $msg["10106"];
  elseif (!empty($bid) && !Ismoney($bid)) $error_msg = $msg["10107"];
  
  if(empty($error_msg)) {
    
    // get field
    $links_obj = new clsLink;
    $links_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
    $links_obj->table_name = "idx_link";
    $links_obj->category_table_name = "idx_category";
    $links_obj->editor_table_name = "idx_editor";
    $links_obj->user_table_name = "idx_users";
    $links_obj->new_limit = $new_limit;

    $add_result = $links_obj->Add();

    $category_obj = new clsCategory;
    $category_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
    $category_obj->table_name = "idx_category";
    $category_obj->separator = $category_separator; 
    $category = $category_obj->GetCategoryPath($cat);
    
    // successfully added
    
    $title = stripslashes($title);
    $description = stripslashes($description);
    $contact_name = stripslashes($contact_name);

    if($add_result==0) {
    
      // update new flag
      $links_obj->UpdateNewFlag();

      // send email submitter

      $body = EvalTemplate($theme_path."mail/add_ok.mail",$links_obj->email_template_fields);
      $from = $msg["10112"];
      mail($email,$msg["10111"],$body,
         "From: $from \nX-Mailer: INDEXU_X-Mailer/1.0");

      // send email to all editors
     
      $emails = $links_obj->GetEditorEmail($cat);
      $i=0;
      while($i<count($emails)) {
    
        $body = EvalTemplate($theme_path."mail/add_ok_editor.mail",$links_obj->email_template_fields);
        $from = $msg["10114"];
        mail($emails[$i],$msg["10113"],$body,
           "From: $from \nX-Mailer: INDEXU_X-Mailer/1.0");
        $i++;
      }

      DisplayTemplate($theme_path."add_ok.html","\$novar");
    }
    
    
    // pending
    
    elseif($add_result==1) {
    
      // send email submitter
      $body = EvalTemplate($theme_path."mail/add_pending.mail",$links_obj->email_template_fields);
      $from = $msg["10116"];
      mail($email,$msg["10115"],$body,
         "From: $from \nX-Mailer: INDEXU_X-Mailer/1.0");

      // send email to all editors
     
      $emails = $links_obj->GetEditorEmail($cat);
      $i=0;
      while($i<count($emails)) {
    
        $body = EvalTemplate($theme_path."mail/add_pending_editor.mail",$links_obj->email_template_fields.",\$site_url");
        $from = $msg["10118"];
        mail($emails[$i],$msg["10117"],$body,
           "From: $from \nX-Mailer: INDEXU_X-Mailer/1.0");
        $i++;
      }

      DisplayTemplate($theme_path."add_pending.html","\$novar");
    }    


    // not allowed
    
    elseif($add_result==2) {
      DisplayTemplate($theme_path."add_not_allowed.html","\$novar");
    }    
  }
  else {
    ShowFormAddUrl();    
  }
}



// --------------
//  main program
// --------------

$conn = ConnectDB();
$title = $titles["1104"];

$theme_name = GetTheme($COOKIE_USERNAME);
if(empty($theme_name)) $theme_name = "default";

$theme_path = $theme_path.$theme_name."/";
include($theme_path."msg.php");



DisplayTemplate($theme_path."header.html","\$title,\$cat");

if (empty($pflag)) {  
  ShowFormAddUrl();    
}
elseif($pflag=='add') {
  ProcessFormAddUrl(); 
}

DisplayTemplate($theme_path."footer.html","\$novar");

?>

