<?php

include("../application.php");

// ---------------
//  functions
// ---------------

function ShowFormAppSetup() {

  // vars global configuration
  global $dbServer, $dbHostname, $dbUsername, $dbPassword, $dbName,
    
    $site_url, $base_path, $theme_path, $admin_template_path,
    
    $new_limit, $updated_limit, $hot_limit, $top_rated_limit, $main_new_links, $main_hot_links,
    
    $cat_table_width, $cat_cellspacing, $cat_font_face, $cat_font_size, $cat_link_style, $subcat_font_face,
    $subcat_font_size, $subcat_link_style, $category_separator, $number_of_links_format, $cat_columns,
    $max_sub_cat, $cat_default_image, $cat_description_format, 
    
    $max_rows, $max_pages, $max_chapters, $rev_max_rows, $rev_max_pages, $rev_max_chapters,
    
    $spam_proof, $enable_user_validation, $bold_keyword, $bold_format, $allowed_file_extention;
    
  // vars url & form

  // vars messages

  // vars template
  
  $bold_keyword = ShowRadioButton("bold_keyword",",","1,0",$bold_keyword);
  $spam_proof = ShowRadioButton("spam_proof",",","1,0",$spam_proof);
  $enable_user_validation = ShowRadioButton("enable_user_validation",",","1,0",$enable_user_validation);

  DisplayTemplate($admin_template_path."app_setup_form.html",
    "\$dbServer,\$dbHostname,\$dbUsername,\$dbPassword,\$dbName,".
    "\$site_url,\$base_path,\$theme_path,\$admin_template_path,".
    "\$new_limit,\$updated_limit,\$hot_limit,\$top_rated_limit,\$main_new_links,\$main_hot_links,".
    "\$cat_table_width,\$cat_cellspacing,\$cat_font_face,\$cat_font_size,\$cat_link_style,\$subcat_font_face,".
    "\$subcat_font_size,\$subcat_link_style,\$category_separator,\$number_of_links_format,\$cat_columns,".
    "\$max_sub_cat,\$cat_default_image,\$cat_description_format,".
    "\$max_rows,\$max_pages,\$max_chapters,\$rev_max_rows,\$rev_max_pages,\$rev_max_chapters,".
    "\$spam_proof,\$enable_user_validation,\$bold_keyword,\$bold_format,\$allowed_file_extention");
}


function ProcessFormAppSetup() {

  // vars global configuration
  global $HTTP_POST_VARS, $dbServer, $dbHostname, $dbUsername, $dbPassword, $dbName,
    
    $site_url, $base_path, $theme_path, $admin_template_path,
    
    $new_limit, $updated_limit, $hot_limit, $top_rated_limit, $main_new_links, $main_hot_links,
    
    $cat_table_width, $cat_cellspacing, $cat_font_face, $cat_font_size, $cat_link_style, $subcat_font_face,
    $subcat_font_size, $subcat_link_style, $category_separator, $number_of_links_format, $cat_columns,
    $max_sub_cat, $cat_default_image,$cat_description_format, 
    
    $max_rows, $max_pages, $max_chapters, $rev_max_rows, $rev_max_pages, $rev_max_chapters,
    
    $spam_proof, $enable_user_validation, $bold_keyword, $bold_format, $allowed_file_extention;

  // vars url & form

  // vars messages
  global $msg;
  
  // vars template
  global $message;
  
  $found_exe = false;
  $found_adm_tpl = false;
  $found_theme = false;
    
  // check executable files inside base_path

  $handle = opendir($HTTP_POST_VARS["base_path"]);
  while ($file = readdir($handle)) {
    if ($file=="indexu_exe.idf") { $found_exe=true; }
  }
  closedir($handle);   

  // check admin template files inside admin_template_path

  $handle = opendir($HTTP_POST_VARS["admin_template_path"]);
  while ($file = readdir($handle)) {
    if ($file=="indexu_adm_tpl.idf") { $found_adm_tpl=true; }
  }
  closedir($handle);   

  // check theme files inside theme_path

  $handle = opendir($HTTP_POST_VARS["theme_path"]);
  while ($file = readdir($handle)) {
    if ($file=="indexu_theme.idf") { $found_theme=true; }
  }
  closedir($handle);   
  
  if ($found_exe==false) { $error_msg = $msg["20381"]; }
  elseif ($found_adm_tpl==false) { $error_msg = $msg["20382"]; }
  elseif ($found_theme==false) { $error_msg = $msg["20383"]; }  

  if(empty($error_msg)) {  

    // fill 
    
    $dbServer = $HTTP_POST_VARS["dbServer"]; 
    $dbHostname = $HTTP_POST_VARS["dbHostname"]; 
    $dbUsername = $HTTP_POST_VARS["dbUsername"]; 
    $dbPassword = $HTTP_POST_VARS["dbPassword"]; 
    $dbName = $HTTP_POST_VARS["dbName"];
    
    $site_url = $HTTP_POST_VARS["site_url"]; 
    $base_path = $HTTP_POST_VARS["base_path"]; 
    $theme_path = $HTTP_POST_VARS["theme_path"]; 
    $admin_template_path = $HTTP_POST_VARS["admin_template_path"];
    
    $new_limit = $HTTP_POST_VARS["new_limit"]; 
    $updated_limit = $HTTP_POST_VARS["updated_limit"]; 
    $hot_limit = $HTTP_POST_VARS["hot_limit"]; 
    $top_rated_limit = $HTTP_POST_VARS["top_rated_limit"]; 
    $main_new_links = $HTTP_POST_VARS["main_new_links"]; 
    $main_hot_links = $HTTP_POST_VARS["main_hot_links"];
    
    $cat_table_width = $HTTP_POST_VARS["cat_table_width"]; 
    $cat_cellspacing = $HTTP_POST_VARS["cat_cellspacing"]; 
    $cat_font_face = $HTTP_POST_VARS["cat_font_face"]; 
    $cat_font_size = $HTTP_POST_VARS["cat_font_size"]; 
    $cat_link_style = $HTTP_POST_VARS["cat_link_style"]; 
    $subcat_font_face = $HTTP_POST_VARS["subcat_font_face"];
    $subcat_font_size = $HTTP_POST_VARS["subcat_font_size"]; 
    $subcat_link_style = $HTTP_POST_VARS["subcat_link_style"]; 
    $category_separator = $HTTP_POST_VARS["category_separator"]; 
    $number_of_links_format = stripslashes($HTTP_POST_VARS["number_of_links_format"]);
    $cat_columns = $HTTP_POST_VARS["cat_columns"];
    $max_sub_cat = $HTTP_POST_VARS["max_sub_cat"]; 
    $cat_default_image = $HTTP_POST_VARS["cat_default_image"]; 
    $cat_description_format = stripslashes($HTTP_POST_VARS["cat_description_format"]); 
    
    $max_rows = $HTTP_POST_VARS["max_rows"]; 
    $max_pages = $HTTP_POST_VARS["max_pages"]; 
    $max_chapters = $HTTP_POST_VARS["max_chapters"]; 
    $rev_max_rows = $HTTP_POST_VARS["rev_max_rows"]; 
    $rev_max_pages = $HTTP_POST_VARS["rev_max_pages"]; 
    $rev_max_chapters = $HTTP_POST_VARS["rev_max_chapters"];
    
    $spam_proof = $HTTP_POST_VARS["spam_proof"]; 
    $enable_user_validation = $HTTP_POST_VARS["enable_user_validation"]; 

    $bold_keyword = stripslashes($HTTP_POST_VARS["bold_keyword"]); 
    $bold_format = stripslashes($HTTP_POST_VARS["bold_format"]); 
    
    $allowed_file_extention = $HTTP_POST_VARS["allowed_file_extention"];
    
    // write to file
    
    $fp = fopen($base_path.'application.php', 'w+');
    
    $content = EvalTemplate($admin_template_path."application.cfg.php",
      "\$dbServer,\$dbHostname,\$dbUsername,\$dbPassword,\$dbName,".
      "\$site_url,\$base_path,\$theme_path,\$admin_template_path,".
      "\$new_limit,\$updated_limit,\$hot_limit,\$top_rated_limit,\$main_new_links,\$main_hot_links,".
      "\$cat_table_width,\$cat_cellspacing,\$cat_font_face,\$cat_font_size,\$cat_link_style,\$subcat_font_face,".
      "\$subcat_font_size,\$subcat_link_style,\$category_separator,\$number_of_links_format,\$cat_columns,".
      "\$max_sub_cat,\$cat_default_image,\$cat_description_format,".
      "\$max_rows,\$max_pages,\$max_chapters,\$rev_max_rows,\$rev_max_pages,\$rev_max_chapters,".
      "\$spam_proof,\$enable_user_validation,\$bold_keyword,\$bold_format,\$allowed_file_extention");
    
    fwrite($fp,$content);
  

    $message = $msg["20384"];
  }
  else $message = $error_msg;
  
  
  DisplayTemplate($admin_template_path."message.html",
    "\$message");

}



// ---------------
//  main program
// ---------------

$conn = ConnectDB();

include($admin_template_path."msg.php");

$users_obj = new clsUsers;
$users_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
$users_obj->table_name = "idx_users";

if($users_obj->GetUserAuthentication(0)!=0){
  $back_url = urlencode("admin/cat_add.php");
  header("Location: ../login.php?f=1&b=$back_url");
}
else {
  DisplayTemplate($admin_template_path."header.html","\$novar");
  if (empty($pflag)) {
    ShowFormAppSetup();
  }
  elseif($pflag=='setup') {
    ProcessFormAppSetup();
  }
  DisplayTemplate($admin_template_path."footer.html","\$novar");
}
?>
