<?php

include("../application.php");

// ---------------
//  functions
// ---------------

function ShowFormAddEditor() {

  // vars global configuration
  global $dbServer, $dbHostname, $dbUsername, $dbPassword, $dbName,
    $category_separator, $admin_template_path;

  // vars url & form

  // vars messages
  global $msg;

  // vars template
  global $category;
  
  // generate category
  
  $category_obj = new clsCategory;
  $category_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
  $category_obj->table_name = "idx_category";
  $category_obj->separator = $category_separator;
  $category = $category_obj->DisplayCategoryListBox(-1);

  DisplayTemplate($admin_template_path."editor_add_form.html",
    "\$category");
}


function ProcessFormAddEditor() {

  // vars global configuration
  global $dbServer, $dbHostname, $dbUsername, $dbPassword, $dbName,
    $category_separator, $admin_template_path, $users_obj;

  // vars url & form
  global $cat, $username;

  // vars messages
  global $msg;

  // vars template
  global $message;

  // verify input

  if(empty($cat)) $error_msg = $msg["20201"];
  elseif(empty($username)) $error_msg = $msg["20202"];
  elseif($username=='admin') $error_msg = $msg["20205"];

  if(empty($error_msg)) {

    $check_result = $users_obj->CheckUsername($username);

    // if username is exist
    if($check_result==0) {

      $links_obj = new clsLink;
      $links_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
      $links_obj->table_name = "idx_link";
      $links_obj->category_table_name = "idx_category";
      $links_obj->editor_table_name = "idx_editor";
      $links_obj->user_table_name = "idx_users";

      $editor_list = $links_obj->GetEditor($cat);

      if(!is_array($editor_list)) $editor_list = array();
      
      if(in_array($username,$editor_list)) {

        // already become editor for this category
        $message = $msg["20204"];
      }
      else {
        $add_result = $links_obj->BecomeEditor("process_form",$username,$cat,true);
        $message = $msg["20211"];
      }
    }
    else $message = $msg["20203"];
  }
  else $message = $error_msg;

  DisplayTemplate($admin_template_path."message.html",
    "\$message");

}



// ---------------
//  main program
// ---------------

$conn = ConnectDB();

include($admin_template_path."msg.php");

$users_obj = new clsUsers;
$users_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
$users_obj->table_name = "idx_users";

if($users_obj->GetUserAuthentication(0)!=0){
  $back_url = urlencode("admin/cat_add.php");
  header("Location: ../login.php?f=1&b=$back_url");
}
else {
  DisplayTemplate($admin_template_path."header.html","\$novar");
  if (empty($pflag)) {
    ShowFormAddEditor();
  }
  elseif($pflag=='add') {
    ProcessFormAddEditor();
  }
  DisplayTemplate($admin_template_path."footer.html","\$novar");
}
?>
