<?php

include("../application.php");

// ---------------
//  functions
// ---------------

function ViewPendingEditor() {

  // vars global configuration
  global $conn, $dbServer, $dbHostname, $dbUsername, $dbPassword, $dbName,
    $category_separator, $admin_template_path, $max_rows, $max_pages, $max_chapters;

  // vars url & form
  global $pg_which;

  // vars messages
  global $msg;

  // vars template
  global $editor, $pagination, $chk_box, $num_rows, $param;
  
  
  $links_obj = new clsLink;
  $links_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);

  $links_obj->table_name = "idx_link";
  $links_obj->category_table_name = "idx_category";
  $links_obj->editor_table_name = "idx_editor";
  $links_obj->user_table_name = "idx_users";

  $links_obj->date_format = $msg["20231"];

  $links_obj->paging = true;
  $links_obj->pg_size = 15;
  $links_obj->cp_size = $max_pages;
  $links_obj->cp_more = $max_chapters;
  $links_obj->href = "editor_validate.php";
  $links_obj->more_param = "";
  $links_obj->category_file = "../browse.php";
  $links_obj->category_separator = $category_separator;
  $links_obj->template_file = $admin_template_path."editor_validate_rows.html";

  $param = "pg_which=$pg_which";

  $editor = $links_obj->DisplayEditor();

  $pagination = $links_obj->pagination;
  $num_rows = $links_obj->num_rows;

  DisplayTemplate($admin_template_path."editor_validate.html",
    "\$num_rows,\$pagination,\$editor,\$param");
}


function ApproveEditor() {
  // vars global configuration
  global $conn, $dbServer, $dbHostname, $dbUsername, $dbPassword, $dbName,
    $admin_template_path;

  // vars url & form
  global $num_rows;

  // vars messages
  global $msg;

  // vars template
  global $message, $title;

  $links_obj = new clsLink;
  $links_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
  $links_obj->table_name = "idx_link";
  $links_obj->editor_table_name = "idx_editor";

  $i=1;
  while($i<=$num_rows){
    $var = "chkbox_$i";
    $id = $GLOBALS["$var"];
    
    $param = split("&",$id);
    $username = $param[0];
    $cat_id = $param[1];

    if(!empty($id)) {

      $links_obj->ApproveEditor($username,$cat_id);
      
      $message .= $msg["20221"];
      $message = str_replace("<%username%>",$username,$message);

    }
    $i++;
  }

  if(empty($message)) $message = $msg["20222"];

  DisplayTemplate($admin_template_path."message.html",
    "\$message");
}


function RejectEditor() {
  // vars global configuration
  global $conn, $dbServer, $dbHostname, $dbUsername, $dbPassword, $dbName,
    $admin_template_path;

  // vars url & form
  global $num_rows;

  // vars messages
  global $msg;

  // vars template
  global $message;

  $links_obj = new clsLink;
  $links_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
  $links_obj->table_name = "idx_link";
  $links_obj->editor_table_name = "idx_editor";

  $i=1;
  while($i<=$num_rows){
    $var = "chkbox_$i";
    $id = $GLOBALS["$var"];

    $param = split("&",$id);
    $username = $param[0];
    $cat_id = $param[1];

    if(!empty($id)) {

      $links_obj->RejectEditor($username,$cat_id);

      $message .= $msg["20223"];
      $message = str_replace("<%username%>",$username,$message);
    }
    $i++;
  }

  if(empty($message)) $message = $msg["20122"];

  DisplayTemplate($admin_template_path."message.html",
    "\$message");
}


// ---------------
//  main program
// ---------------

$conn = ConnectDB();

include($admin_template_path."msg.php");

$users_obj = new clsUsers;
$users_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
$users_obj->table_name = "idx_users";

if($users_obj->GetUserAuthentication(0)!=0){
  $back_url = urlencode("admin/editor_validate.php");
  header("Location: ../login.php?f=1&b=$back_url");
}
else {
  DisplayTemplate($admin_template_path."header.html","\$novar");
  if(empty($pflag)) ViewPendingEditor();
  elseif($pflag=='validate') {
    if($op=='') ApproveEditor();
    elseif($op=='') RejectEditor();
  }
  DisplayTemplate($admin_template_path."footer.html","\$novar");
}
?>
