<?php

include("../application.php");

// ---------------
//  functions
// ---------------

function ShowFormEditLink() {

  // vars global configuration
  global $dbServer, $dbHostname, $dbUsername, $dbPassword, $dbName,
    $category_separator, $admin_template_path;

  // vars url & form
  global $id;
  
  // vars messages
  global $msg;

  // vars template


  // generate custom field

  $links_obj = new clsLink;
  $links_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
  $links_obj->table_name = "idx_link";
  $links_obj->category_table_name = "idx_category";

  $links_obj->autogenerate_form_text = $msg["30001"];
  $links_obj->autogenerate_form_textarea = $msg["30002"];
  $links_obj->autogenerate_form_upload = $msg["30004"];
  $links_obj->autogenerate_form_template = $admin_template_path."link_custom_field_form.html";

  $links_obj->header = $msg["20061"];
  $links_obj->template_file = $admin_template_path."link_edit_form.html";
  $links_obj->Modify("display_form",$id,true);

}


function ProcessFormEditLink() {

  // vars global configuration
  global $dbServer, $dbHostname, $dbUsername, $dbPassword, $dbName,
    $category_separator, $admin_template_path;

  // vars url & form
  global $id, $title, $url, $description, $cat, $contact_name, $email, $bid,
    $password;

  // vars messages
  global $msg;

  // vars template
  global $message;

  // verify input

  if(empty($title)) $error_msg = $msg["20071"];
  elseif(empty($url)) $error_msg = $msg["20072"];
  elseif(empty($cat)) $error_msg = $msg["20073"];
  elseif (!empty($email) && !IsEmailAddress($email)) $error_msg = $msg["20074"];
  elseif (!empty($bid) && !IsMoney($bid)) $error_msg = $msg["20075"];

  
  if(empty($error_msg)) {

    $links_obj = new clsLink;
    $links_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
    $links_obj->table_name = "idx_link";
    $links_obj->category_table_name = "idx_category";
    $links_obj->editor_table_name = "idx_editor";
    $links_obj->user_table_name = "idx_users";

    $modify_result = $links_obj->Modify("process_form",$id,true);

    // update updated flag
    $links_obj->UpdateUpdatedFlag();
    
    $message = $msg["20101"];
  }
  else $message = $error_msg;

  DisplayTemplate($admin_template_path."message.html",
    "\$message");

}



// ---------------
//  main program
// ---------------

$conn = ConnectDB();

include($admin_template_path."msg.php");

$users_obj = new clsUsers;
$users_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
$users_obj->table_name = "idx_users";

if($users_obj->GetUserAuthentication(0)!=0){
  $back_url = urlencode("admin/cat_add.php");
  header("Location: ../login.php?f=1&b=$back_url");
}
else {
  DisplayTemplate($admin_template_path."header.html","\$novar");
  if (empty($pflag)) {
    ShowFormEditLink();
  }
  elseif($pflag=='edit') {
    ProcessFormEditLink();
  }
  DisplayTemplate($admin_template_path."footer.html","\$novar");
}
?>
