<?php

include("../application.php");

// ---------------
//  functions
// ---------------

function ViewPendingReview() {

  // vars global configuration
  global $conn, $dbServer, $dbHostname, $dbUsername, $dbPassword, $dbName,
    $category_separator, $admin_template_path, $max_rows, $max_pages, $max_chapters;

  // vars url & form
  global $pg_which;

  // vars messages
  global $msg;

  // vars template
  global $review, $pagination, $chk_box, $num_rows, $param;
  
  
  $links_obj = new clsLink;
  $links_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);

  $links_obj->table_name = "idx_link";
  $links_obj->category_table_name = "idx_category";
  $links_obj->date_format = $msg["20144"];

  $links_obj->paging = true;
  $links_obj->pg_size = 15;
  $links_obj->cp_size = $max_pages;
  $links_obj->cp_more = $max_chapters;
  $links_obj->href = "review_validate.php";
  $links_obj->more_param = "";
  $links_obj->category_file = "../browse.php";
  $links_obj->category_separator = $category_separator;

  $param = "pg_which=$pg_which";

  //$links_obj->rev_rating_image_path = $admin_template_path."images/review/";
  $links_obj->rev_rating_image_path = "../themes/default/images/review/";
  $links_obj->template_file = $admin_template_path."review_validate_rows.html";
  $query = "select * from idx_review where status = 0";
  $review = $links_obj->DisplayReview($id,$query,true);

  $pagination = $links_obj->pagination;
  $num_rows = $links_obj->num_rows;

  DisplayTemplate($admin_template_path."review_validate.html",
    "\$num_rows,\$pagination,\$review,\$param");
}


function ApproveReview() {
  // vars global configuration
  global $conn, $dbServer, $dbHostname, $dbUsername, $dbPassword, $dbName,
    $admin_template_path;

  // vars url & form
  global $num_rows;

  // vars messages
  global $msg;

  // vars template
  global $message, $title;

  $links_obj = new clsLink;
  $links_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
  $links_obj->table_name = "idx_link";
  $links_obj->review_table_name = "idx_review";

  $i=1;
  while($i<=$num_rows){
    $var = "chkbox_$i";
    $id = $GLOBALS["$var"];

    if(!empty($id)) {

      $query = "select link_id from idx_review where review_id = $id";
      $result = $conn->Execute($query);
      $lid = $result->Fields("link_id");

      $query = "select title from idx_link where link_id = $lid";
      $result = $conn->Execute($query);
      $title = $result->Fields("title");

      $links_obj->ApproveReview($id);
      
      $message .= $msg["20141"];
      $message = str_replace("<%title%>",$title,$message);

      // recalculate avg_review
      $links_obj->UpdateAvgReview($id);
    }
    $i++;
  }

  if(empty($message)) $message = $msg["20142"];

  DisplayTemplate($admin_template_path."message.html",
    "\$message");
}


function RejectReview() {
  // vars global configuration
  global $conn, $dbServer, $dbHostname, $dbUsername, $dbPassword, $dbName,
    $admin_template_path;

  // vars url & form
  global $num_rows;

  // vars messages
  global $msg;

  // vars template
  global $message, $link_id, $title, $url, $description, $contact_name, $email, $bid, $category, $category_id;

  $links_obj = new clsLink;
  $links_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
  $links_obj->table_name = "idx_link";
  $links_obj->review_table_name = "idx_review";

  $i=1;
  while($i<=$num_rows){
    $var = "chkbox_$i";
    $id = $GLOBALS["$var"];

    if(!empty($id)) {

      $query = "select link_id from idx_review where review_id = $id";
      $result = $conn->Execute($query);
      $lid = $result->Fields("link_id");

      $query = "select title from idx_link where link_id = $lid";
      $result = $conn->Execute($query);
      $title = $result->Fields("title");

      $links_obj->RejectReview($id);

      $message .= $msg["20143"];
      $message = str_replace("<%title%>",$title,$message);
    }
    $i++;
  }

  if(empty($message)) $message = $msg["20122"];

  DisplayTemplate($admin_template_path."message.html",
    "\$message");
}


// ---------------
//  main program
// ---------------

$conn = ConnectDB();

include($admin_template_path."msg.php");

$users_obj = new clsUsers;
$users_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
$users_obj->table_name = "idx_users";

if($users_obj->GetUserAuthentication(0)!=0){
  $back_url = urlencode("admin/link_view.php");
  header("Location: ../login.php?f=1&b=$back_url");
}
else {
  DisplayTemplate($admin_template_path."header.html","\$novar");
  if(empty($pflag)) ViewPendingReview();
  elseif($pflag=='validate') {
    if($op=='') ApproveReview();
    elseif($op=='') RejectReview();
  }
  DisplayTemplate($admin_template_path."footer.html","\$novar");
}
?>
