<?php

include("application.php");

// ---------------
//  functions
// ---------------

function ShowFormBecomeEditor() {

  // vars global configuration
  global $dbServer, $dbHostname, $dbUsername, $dbPassword, $dbName,
    $category_separator, $theme_path, $COOKIE_USERNAME;

  // vars url & form
  global $cat;  

  // vars messages
  global $msg;
  
  // vars template
  global $category, $username, $error_msg;
  

  
  if(empty($cat)) {
    $error_msg = $msg["10226"];
    DisplayTemplate($theme_path."become_editor_error.html","\$error_msg");
  }
  elseif($COOKIE_USERNAME=='admin') {
    $error_msg = $msg["10227"];
    DisplayTemplate($theme_path."become_editor_error.html","\$error_msg");
  }
  else {


    // get username
    $username = $COOKIE_USERNAME;

    // get category path
    $category_obj = new clsCategory;
    $category_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
    $category_obj->table_name = "idx_category";
    $category_obj->link_table_name = "idx_link";
    $category_obj->separator = $category_separator;
    $category = $category_obj->GetCategoryPath($cat);
    $category .= "\n<input type=hidden name=cat value=$cat>";

    DisplayTemplate($theme_path."become_editor_form.html","\$username,\$category");
  }
}


function ProcessFormBecomeEditor() {

  // vars global configuration
  global $site_url, $dbServer, $dbHostname, $dbUsername, $dbPassword, $dbName,
    $theme_path;
  
  // vars url & form
  global $cat, $username;
      
  // vars messages
  global $msg;

  // vars template
  global $category, $name, $email;
  

  $category_obj = new clsCategory;
  $category_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
  $category_obj->table_name = "idx_category";
  $category_obj->separator = $category_separator;
  $category = $category_obj->GetCategoryPath($cat);
  
  // add to queue

  $links_obj = new clsLink;
  $links_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);

  $links_obj->table_name = "idx_link";
  $links_obj->category_table_name = "idx_category";
  $links_obj->user_table_name = "idx_users";
  $links_obj->editor_table_name = "idx_editor";
  $links_obj->BecomeEditor("process_form",$username,$cat);

  // send email to administrator

  $users_obj = new clsUsers;
  $users_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
  $users_obj->table_name = "idx_users";
  $admin_email = $users_obj->GetEmailAddress("admin");

  $body = EvalTemplate($theme_path."mail/become_editor_pending_admin.mail",$links_obj->email_template_fields.",\$site_url");
  $from = $msg["10222"];
  mail($admin_email,$msg["10221"],$body,
    "From: $from \nX-Mailer: INDEXU_X-Mailer/1.0");

  DisplayTemplate($theme_path."become_editor_pending.html","\$$username,\$category");
}



// --------------
//  main program
// --------------

$conn = ConnectDB();
$title = $titles["1119"];

$theme_name = GetTheme($COOKIE_USERNAME);
if(empty($theme_name)) $theme_name = "default";

$theme_path = $theme_path.$theme_name."/";
include($theme_path."msg.php");


// check user authentication

$users_obj = new clsUsers;
$users_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
$users_obj->table_name = "idx_users";

if(!$users_obj->GetUserAuthentication()==0) {
  $back_url = urlencode("become_editor.php?cat=$cat");
  header("Location: login.php?f=1&b=$back_url");
}
else {
  DisplayTemplate($theme_path."header.html","\$title,\$cat");

  if (empty($pflag)) {
    ShowFormBecomeEditor();
  }
  elseif($pflag=='editor') {
    ProcessFormBecomeEditor();
  }

  DisplayTemplate($theme_path."footer.html","\$novar");
}

?>

