<?php

include("application.php");

// ---------------
//  functions
// ---------------

function ShowCategoryPage() {

  // vars global configuration

  global $dbServer, $dbHostname, $dbUsername, $dbPassword, $dbName,
    $theme_path, $number_of_links_format, $cat_default_image,   
    $cat_columns, $main_new_links, $main_hot_links, $max_sub_cat,    
    $cat_font_face, $cat_font_size, $cat_link_style, 
    $subcat_font_face, $subcat_font_size, $subcat_link_style,
    $cat_table_width, $cat_cellspacing,
    $max_rows, $max_pages, $max_chapters, $category_separator,    
    $cache_time,$use_cache_status,$theme_name,
    $cat_description_format;  
  
  // vars url & form
  global $cat,$pg_which;
    
  // vars messages
  global $msg;
  
  // vars template
  global $category,$link,$pagination,$category_path,$content,$editor;

  
  // show category path
  
  $category_obj = new clsCategory;
  $category_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);

  $category_obj->table_name = "idx_category";
  $category_obj->link_table_name = "idx_link";
  $category_obj->separator = $category_separator; 
  $category_obj->header = $msg["10012"];

  $category_path = $category_obj->GetCategoryPath($cat,"browse.php");
  $category_path = "<a href=index.php>".$msg["10011"]."</a>".$category_obj->separator.$category_path;
  
  // show categories
  
  if ($pg_which==1 || $pg_which=="") {

    $category_obj->number_of_columns = $cat_columns;
    $category_obj->number_of_subcats = $max_sub_cat;
    //$category_obj->default_image = $theme_path.$cat_default_image;
    $category_obj->default_image = $cat_default_image;
    $category_obj->image_path = "themes/".$theme_name."/images/";
    //$category_obj->image_path = "images/";
    
    $category_obj->show_description = true;
    $category_obj->number_of_links_format = $number_of_links_format;
    $category_obj->cat_description_format = $cat_description_format;
    $category_obj->cat_font_face = $cat_font_face;
    $category_obj->cat_font_size = $cat_font_size;
    $category_obj->cat_link_style = $cat_link_style;
    $category_obj->cat_table_width = $cat_table_width;
    $category_obj->cat_cellspacing = $cat_cellspacing;
    $category_obj->show_subcat = false;
    $category_obj->parent = $cat;

    $category = $category_obj->Display();
        
    // show content
    $content = $category_obj->GetContent($cat);
  }

  
  // show links
  
  $links_obj = new clsLink;
  $links_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
  
  $links_obj->query = "select * from idx_link where category_id = '$cat' order by bid desc";
  $links_obj->table_name = "idx_link";
  $links_obj->category_table_name = "idx_category";
  $links_obj->user_table_name = "idx_users";
  $links_obj->editor_table_name = "idx_editor";
  $links_obj->template_file = $theme_path."rows.html";
  $links_obj->date_format = $msg["10014"];
    
  $links_obj->header = $msg["10013"];
  $links_obj->paging = true;
  $links_obj->pg_size = $max_rows;
  $links_obj->cp_size = $max_pages;
  $links_obj->cp_more = $max_chapters;
  $links_obj->href = "browse.php";
  $links_obj->more_param = "&cat=$cat";
  $links_obj->category_file = "browse.php";
  $links_obj->category_separator = $category_separator;    

  $links_obj->cache_time = $cache_time;
  $links_obj->enable_cache = $use_cache_status;
  
  $link = $links_obj->Display();
  $pagination = $links_obj->pagination;

  // display editors
  
  $editors = $links_obj->GetEditor($cat);
  
  $i=0;
  while($i<count($editors)) {
    $editor_username = $editors[$i]; 
    $editor_str .= "<a href=user_detail.php?u=$editor_username style='color:black; font-weight: normal;'>$editor_username</a> ";
    $i++;
  }
  if(count($editors)>0) $editor = str_replace("<%editors%>",$editor_str,$msg["10015"]);
  
    
  DisplayTemplate($theme_path."browse.html","\$category_path,\$category,".
    "\$num_rows,\$pagination,\$cat,\$link,\$content,\$start_number,\$ma,\$editor");
}

// --------------
//  main program
// --------------

$conn = ConnectDB();

$title = $titles["1102"];

$theme_name = GetTheme($COOKIE_USERNAME);
if(empty($theme_name)) $theme_name = "default";

$theme_path = $theme_path.$theme_name."/";
include($theme_path."msg.php");


if(!empty($COOKIE_USERNAME)) $max_rows = GetNOLCategory($COOKIE_USERNAME);

$category_obj = new clsCategory;
$category_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);

$category_obj->table_name = "idx_category";
$category_obj->separator = $category_separator; 
$cat_path = $msg["10011"].$category_separator.$category_obj->GetCategoryPath($cat);
$title = str_replace("<%category%>",$cat_path,$title);

$meta_keywords = $category_obj->GetMetaKeyword($cat);
$meta_description = $category_obj->GetMetaDescription($cat);

$access_permission = $category_obj->GetAccessPermission($cat);
if($access_permission==1) {
  $users_obj = new clsUsers;
  $users_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
  $users_obj->table_name = "idx_users";

  if(!$users_obj->GetUserAuthentication()==0){
    $back_url = urlencode("browse.php?cat=$cat");
    header("Location: login.php?f=1&b=$back_url");
  }
}


$ma = 1;
DisplayTemplate($theme_path."cat_header.html","\$title,\$cat,\$meta_keywords,\$meta_description");
ShowCategoryPage();
DisplayTemplate($theme_path."footer.html","\$cat,\$ma");

?>

