<?php

include("../application.php");

// ---------------
//  functions
// ---------------

function ShowFormEditLink() {

  // vars global configuration
  global $dbServer, $dbHostname, $dbUsername, $dbPassword, $dbName,
    $category_separator, $theme_path;

  // vars url & form
  global $id;
  
  // vars messages
  global $msg;

  // vars template


  // generate custom field

  $links_obj = new clsLink;
  $links_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
  $links_obj->table_name = "idx_link";
  $links_obj->category_table_name = "idx_category";
  $links_obj->editor_table_name = "idx_editor";

  $links_obj->autogenerate_form_text = $msg["00001"];
  $links_obj->autogenerate_form_textarea = $msg["00002"];
  $links_obj->autogenerate_form_upload = str_replace("src=","src=../",$msg["00004"]);
  $links_obj->autogenerate_form_template = $theme_path."custom_field_form_rows.html";

  $links_obj->upload_html = $msg["20159"];
  $links_obj->remove_img_html = $msg["20160"];
    
  $links_obj->template_file = $theme_path."cp/editor_link_edit_form.html";
  $links_obj->Modify("display_form",$id,true,true);

}


function ProcessFormEditLink() {

  // vars global configuration
  global $dbServer, $dbHostname, $dbUsername, $dbPassword, $dbName,
    $category_separator, $theme_path, $HTTP_POST_VARS;

  // vars url & form
  global $id, $link_id, $title, $url, $description, $cat, $contact_name, $email, $bid,
    $password;

  // vars messages
  global $msg;

  // vars template
  global $error_msg;

  // verify input
  
  $title = $HTTP_POST_VARS["title"];
  if(empty($id)) $id = $link_id;

  if(empty($title)) $error_msg = $msg["20151"];
  elseif(empty($url)) $error_msg = $msg["20152"];
  elseif(empty($cat)) $error_msg = $msg["20158"];
  elseif (!empty($email) && !IsEmailAddress($email)) $error_msg = $msg["20156"];
  elseif (!empty($bid) && !IsMoney($bid)) $error_msg = $msg["20157"];

  
  if(empty($error_msg)) {

    $links_obj = new clsLink;
    $links_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
    $links_obj->table_name = "idx_link";
    $links_obj->category_table_name = "idx_category";
    $links_obj->editor_table_name = "idx_editor";
    $links_obj->user_table_name = "idx_users";

    $modify_result = $links_obj->Modify("process_form",$link_id,true);

    // update updated flag
    $links_obj->UpdateUpdatedFlag();    
   
    DisplayTemplate($theme_path."cp/editor_link_edit_ok.html",
      "\$novar");
  }
  else ShowFormEditLink();
}



// ---------------
//  main program
// ---------------

$conn = ConnectDB();
$title = $titles["2014"];

$theme_name = GetTheme($cookie_username);
if(empty($theme_name)) $theme_name = "default";

$theme_path = $theme_path.$theme_name."/";
include($theme_path."msg.php");

$users_obj = new clsUsers;
$users_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
$users_obj->table_name = "idx_users";

// is he an editor

if($users_obj->GetUserAuthentication(1)!=0){
  $back_url = urlencode("cp/editor_link_edit.php");
  header("Location: ../login.php?f=1&b=$back_url");
}
else {
  DisplayTemplate($theme_path."cp/header.html","\$title");
  if (empty($pflag)) {
    ShowFormEditLink();
  }
  elseif($pflag=='modify') {
    ProcessFormEditLink();
  }
  DisplayTemplate($theme_path."cp/footer.html","\$novar");
}
?>
