<?php

include("../application.php");

// ---------------
//  functions
// ---------------

function ShowFormSearchLink() {

  // vars global configuration
  global $dbServer, $dbHostname, $dbUsername, $dbPassword, $dbName,
    $category_separator, $theme_path, $COOKIE_USERNAME;

  // vars url & form

  // vars messages
  global $msg;

  // vars template
  global $category,$custom_field_form;

  
  // generate custom field

  $links_obj = new clsLink;
  $links_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
  $links_obj->table_name = "idx_link";
  $links_obj->category_table_name = "idx_category";
  $links_obj->editor_table_name = "idx_editor";
  
  $links_obj->autogenerate_form_text = $msg["00001"];
  $links_obj->autogenerate_form_textarea = $msg["00002"];
  $links_obj->autogenerate_form_template = $theme_path."custom_field_form_rows.html";
  $custom_field_form = $links_obj->GenerateCustomFieldForm();


  // generate category
  
  $category_obj = new clsCategory;
  $category_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
  $category_obj->table_name = "idx_category";
  $category_obj->separator = $category_separator;
  
  // get editor category
  $categories = $links_obj->GetEditorCategory($COOKIE_USERNAME);
  
  // build query
  $query = "select * from idx_category where 0!=0";
  $i=0;
  while($i<count($categories)) {
    $query .= " or category_id = $categories[$i]";
    $i++;
  }
  
  $category_obj->query = $query;
  $category = $category_obj->DisplayCategoryListBox(-1);  
   
  
  DisplayTemplate($theme_path."cp/editor_link_search_form.html",
    "\$category,\$custom_field_form");
}


function ProcessFormSearchLink() {

  // vars global configuration
  global $dbServer, $dbHostname, $dbUsername, $dbPassword, $dbName, $HTTP_POST_VARS,
    $category_separator, $theme_path, $max_rows, $max_pages, $max_chapters, $COOKIE_USERNAME;

  // vars url & form
  global $title, $url, $description, $cat, $contact_name, $email, $bid,
    $password;

  // vars messages
  global $msg;

  // vars template
  global $num_rows,$pagination,$link,$param;

  $title = $HTTP_POST_VARS["title"];
  
  // get field
  $links_obj = new clsLink;
  $links_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
  $links_obj->table_name = "idx_link";
  $links_obj->category_table_name = "idx_category";
  $links_obj->editor_table_name = "idx_editor";

  $categories = $links_obj->GetEditorCategory($COOKIE_USERNAME);

  $fields = $links_obj->GetFields();


  // ----- querying -----

  $query = "select * from idx_link where 0=0 ";
  $i=0;
  while($i<count($fields)) {
    $field = $fields[$i];

    global $$field;

    if($field=='category_id' && !empty($cat)) {
      $query .= "and $field = $cat ";
    }
    elseif($field=='category_id' && empty($cat)) {

      $query .= "and (0!=0";
      $j=0;
      while($j<count($categories)) {
        $query .= " or category_id = $categories[$j]";
        $j++;
      }    
      $query .= ") ";
    }
      
    elseif(!empty($$field))
      $query .= "and $field like '%".$$field."%' ";

    $i++;
  }
  $query .= " order by bid desc";

  $links_obj->query = $query;
  $links_obj->template_file = $theme_path."cp/editor_link_search_rows.html";
  $links_obj->date_format = $msg["20081"];

  $links_obj->paging = true;
  $links_obj->pg_size = 15;
  $links_obj->cp_size = $max_pages;
  $links_obj->cp_more = $max_chapters;
  $links_obj->href = "editor_link_search.php";


  // get more param for custom fields

  $i=$links_obj->custom_field_offset;
  while($i<count($fields)) {
    $field = $fields[$i];

    global $$field;

    $custom_field_param .= "&".$field."=".$$field;
    $i++;
  }

  $links_obj->more_param = "&pflag=search&title=$title&url=$url&description=$description&cat=$cat&contact_name=$contact_name&email=$email".$custom_field_param;

  $links_obj->new_link_number=1;
  $link = $links_obj->Display();
  $pagination = $links_obj->pagination;
  $num_rows = $links_obj->new_link_number-1;
  $param = $links_obj->more_param . "&pg_which=$pg_which";


  DisplayTemplate($theme_path."cp/editor_link_search_result.html",
    "\$num_rows,\$pagination,\$link,\$param");
}



// ---------------
//  main program
// ---------------

$conn = ConnectDB();
$title = $titles["2012"];

$theme_name = GetTheme($cookie_username);
if(empty($theme_name)) $theme_name = "default";

$theme_path = $theme_path.$theme_name."/";
include($theme_path."msg.php");

$users_obj = new clsUsers;
$users_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
$users_obj->table_name = "idx_users";

// is he an editor

if($users_obj->GetUserAuthentication(1)!=0){
  $back_url = urlencode("cp/editor_link_search.php");
  header("Location: ../login.php?f=1&b=$back_url");
}
else {
  DisplayTemplate($theme_path."cp/header.html","\$title");
  if (empty($pflag)) {
    ShowFormSearchLink();
  }
  elseif($pflag=='search') {
    ProcessFormSearchLink();
  }
  DisplayTemplate($theme_path."cp/footer.html","\$novar");
}
?>
