<?php

include("../application.php");

// ---------------
//  functions
// ---------------

function ViewLink() {

  // vars global configuration
  global $conn, $dbServer, $dbHostname, $dbUsername, $dbPassword, $dbName,
    $category_separator, $theme_path, $max_rows, $max_pages, $max_chapters, $COOKIE_USERNAME;

  // vars url & form
  global $cat, $pg_which;

  // vars messages
  global $msg;

  // vars template
  global $link, $pagination, $chk_box, $num_rows, $param;
  
  
  $links_obj = new clsLink;
  $links_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
  $links_obj->table_name = "idx_link";
  $links_obj->category_table_name = "idx_category";
  $links_obj->editor_table_name = "idx_editor";

  // get editor category
  $categories = $links_obj->GetEditorCategory($COOKIE_USERNAME);
  
  // build query
  $query = "select * from idx_link_temp where 0!=0";
  $i=0;
  while($i<count($categories)) {
    $query .= " or category_id = $categories[$i]";
    $i++;
  }
  $query .= " order by date";
  
  $links_obj->template_file = $theme_path."cp/editor_link_validate_rows.html";
  $links_obj->date_format = $msg["20111"];
  $links_obj->query = $query;

  $links_obj->paging = true;
  $links_obj->pg_size = 15;
  $links_obj->cp_size = $max_pages;
  $links_obj->cp_more = $max_chapters;
  $links_obj->href = "editor_link_validate.php";
  $links_obj->more_param = "";
  $links_obj->category_file = "../browse.php";
  $links_obj->category_separator = $category_separator;

  $links_obj->new_link_number=1;
  $link = $links_obj->Display(true);
  $pagination = $links_obj->pagination;
  $num_rows = $links_obj->new_link_number-1;
  $param = "pg_which=$pg_which";


  DisplayTemplate($theme_path."cp/editor_link_validate.html",
    "\$num_rows,\$pagination,\$link,\$param");
}


function ApproveLink() {
  // vars global configuration
  global $conn, $dbServer, $dbHostname, $dbUsername, $dbPassword, $dbName,
    $theme_path, $message;

  // vars url & form
  global $num_rows;

  // vars messages
  global $msg;

  // vars template
  global $link_id, $title, $url, $description, $contact_name, $email, $bid, $category, $category_id;

  $links_obj = new clsLink;
  $links_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
  $links_obj->table_name = "idx_link";
  $links_obj->category_table_name = "idx_category";
  $links_obj->editor_table_name = "idx_editor";
  $links_obj->user_table_name = "idx_users";

  $i=1;
  while($i<=$num_rows){
    $var = "chkbox_$i";
    $id = $GLOBALS["$var"];

    if(!empty($id)) {

      $query = "select link_id, title from idx_link_temp where vid = $id";
      $result = $conn->Execute($query);
      $lid = $result->Fields("link_id");
      $title = $result->Fields("title");

      if(empty($lid)) $flag = 0;
      else $flag = 1;

      $links_obj->ApproveLink($id,$flag);
      
      $message .= $msg["20121"];
      $message = str_replace("<%title%>",$title,$message);

      // update new flag
      if($flag==0) $links_obj->UpdateNewFlag();
      
      // update updated flag
      elseif($flag==1) $links_obj->UpdateUpdatedFlag();

      // send email submitter

      $body = EvalTemplate($theme_path."mail/approved.mail",$links_obj->email_template_fields);
      $from = $msg["20132"];
      mail($email,$msg["20131"],$body,
         "From: $from \nX-Mailer: INDEXU_X-Mailer/1.0");

      // send email to all editors

      $emails = $links_obj->GetEditorEmail($category_id);
      $j=0;
      while($j<count($emails)) {

        $body = EvalTemplate($theme_path."mail/approved_editor.mail",$links_obj->email_template_fields);
        $from = $msg["20134"];
        mail($emails[$j],$msg["20133"],$body,
          "From: $from \nX-Mailer: INDEXU_X-Mailer/1.0");
        $j++;
      }
    }
    $i++;
  }
  if(empty($message)) $message = $msg["20122"];
  DisplayTemplate($theme_path."cp/editor_link_validate_result.html",
    "\$message");
}


function RejectLink() {
  // vars global configuration
  global $conn, $dbServer, $dbHostname, $dbUsername, $dbPassword, $dbName,
    $theme_path;

  // vars url & form
  global $num_rows;

  // vars messages
  global $msg;

  // vars template
  global $message, $link_id, $title, $url, $description, $contact_name, $email, $bid, $category, $category_id;

  $links_obj = new clsLink;
  $links_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
  $links_obj->table_name = "idx_link";
  $links_obj->category_table_name = "idx_category";
  $links_obj->editor_table_name = "idx_editor";
  $links_obj->user_table_name = "idx_users";

  $i=1;
  while($i<=$num_rows){
    $var = "chkbox_$i";
    $id = $GLOBALS["$var"];

    if(!empty($id)) {

      $query = "select title from idx_link_temp where vid = $id";
      $result = $conn->Execute($query);
      $title = $result->Fields("title");

      $links_obj->RejectLink($id);

      $message .= $msg["20123"];
      $message = str_replace("<%title%>",$title,$message);


      // send email submitter

      $body = EvalTemplate($theme_path."mail/rejected.mail",$links_obj->email_template_fields);
      $from = $msg["20136"];
      mail($email,$msg["20135"],$body,
         "From: $from \nX-Mailer: INDEXU_X-Mailer/1.0");

      // send email to all editors

      $emails = $links_obj->GetEditorEmail($category_id);
      $j=0;
      while($j<count($emails)) {

        $body = EvalTemplate($theme_path."mail/rejected_editor.mail",$links_obj->email_template_fields);
        $from = $msg["20138"];
        mail($emails[$j],$msg["20137"],$body,
          "From: $from \nX-Mailer: INDEXU_X-Mailer/1.0");
        $j++;
      }
    }
    $i++;
  }
  if(empty($message)) $message = $msg["20122"];
  DisplayTemplate($theme_path."cp/editor_link_validate_result.html",
    "\$message");
}


// ---------------
//  main program
// ---------------

$conn = ConnectDB();
$title = $titles["2011"];

$theme_name = GetTheme($cookie_username);
if(empty($theme_name)) $theme_name = "default";

$theme_path = $theme_path.$theme_name."/";
include($theme_path."msg.php");

$users_obj = new clsUsers;
$users_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
$users_obj->table_name = "idx_users";

// is he an editor

if($users_obj->GetUserAuthentication(1)!=0){
  $back_url = urlencode("cp/editor_link_validate.php");
  header("Location: ../login.php?f=1&b=$back_url");
}
else {

  DisplayTemplate($theme_path."cp/header.html","\$title");
  if(empty($pflag)) ViewLink();
  elseif($pflag=='validate') {
    if($op=='') ApproveLink();
    elseif($op=='') RejectLink();
  }
  DisplayTemplate($theme_path."cp/footer.html","\$novar");
}
?>
