<?php 

// --------------------------------------------------------------------------
//
// Sentraweb Application Framework 2.0
// 
// File name   : category.class.php 
// Description : Class to handle category structure of web directory
// Requirement : - PHP4 (http://www.php.net)
//               - ADODB Library (http://php.weblogs.com)
//                 by John Lim (jlim@natsoft.com.my)
//
//
// Copyright(C), Sentraweb, 2001, All Rights Reserved.
//
// This library is not free. Unauthorized use or distribution of  is strictly 
// prohibited, violators will be prosecuted. To obtain permission for using 
// this library, please contact us at Sentraweb (support@sentraweb.com)
//
// Author: Dody Rachmat Wicaksono (dody@sentraweb.com) 
// October, 2001
//
// --------------------------------------------------------------------------


class clsCategory {

  // ----------
  // attributes
  // ----------
  
  var $table_name = "category";
  var $link_table_name = "link";
  var $number_of_columns = 2;     // choose 1,2,3, and 4
  var $number_of_subcats = 3;
  var $default_image = "images/folder.gif";
  var $show_image = true;
  var $show_subcat = false;
  var $show_description = false;
  var $number_of_links_format = "";
  var $cat_description_format = "";
  var $cat_font_face = "arial";
  var $cat_font_size = 2;
  var $cat_link_style = "";
  var $subcat_font_face = "arial";
  var $subcat_font_size = 1;
  var $subcat_link_style = "";
  var $cat_cellspacing = 2;
  var $cat_table_width = 400;
  var $category_filename = "browse.php";  // browse category content
  var $parent = 0;  
  var $separator = "::";
  var $header = "";
  var $image_path = "";
  
  var $query = "";
  var $type_of_list = "STANDART_LIST";   // STANDART_LIST

  var $bold = true;                                        // SEARCH RESULT
  var $keywords = "";
  var $bold_format = "<b><%keyword%></b>";
  
  // internal use only  

  var $db_server = "mysql";
  var $db_hostname = "localhost";
  var $db_username = "";
  var $db_password = "";
  var $db_name = "";
  var $db_connect = "";

                                         
  // -------
  // methods
  // -------
  
  // InitDB($server,$host,$username,$pwd,$db)

  // Add($name, $parent_id, $description, $image, $content, $visible, $permission, $meta_keyword, $meta_description, $registered_only)
  // Edit($category_id, $name, $parent_id, $description, $image, $content, $visible, $permission, $meta_keyword, $meta_description, $registered_only)
  // Delete($cat_id)
  
  // GetInOrderCategory($categories)
  // GetNumberOfLinks($cat)
  // GetCategoryPath($cat,$file="")
  
  // DisplaySearchResult($query,$file="")
  
  // GetAccessPermission($cat)
  // GetContent($cat)
  // GetMetaKeyword($cat)
  // GetMetaDescription($cat)
  
  // Display()
  
  // UpdateNumberOfLinksInAllCategories();                                         
  // GetAddLinkPermission($cat)
  // GetCategoryName($cat)
  
  // DisplayCategoryListBox($cat,$show_main_category=false)
  
  
  
  // method to initialize database connection
  // return :   nothing
  // ----------------------------------------

  function InitDB($server,$host,$username,$pwd,$db) {

    $this->db_server = $server;
    $this->db_hostname = $host;
    $this->db_username = $username;
    $this->db_password = $pwd;
    $this->db_name = $db;
    
    ADOLoadCode($this->db_server);    
    $this->db_connect = &ADONewConnection();    
    $this->db_connect->PConnect($this->db_hostname,$this->db_username,$this->db_password,$this->db_name);  
    //$this->db_connect->debug=true;
  }



  // method to add new category
  // return :   0: success
  //            1: sql error
  // ----------------------------------------

  function Add($name, $parent_id, $description, $image, $content, $visible, $permission, $meta_keyword, $meta_description, $registered_only) {

    $query = "insert into $this->table_name
      (name, parent_id, description, image, content, visible, links, permission, meta_keyword, meta_description, registered_only)
      values ('$name', $parent_id, '$description', '$image', '$content', $visible, 0, $permission, '$meta_keyword', '$meta_description', $registered_only)";
    $result = $this->db_connect->Execute($query);
    if($result) return 0;
    else return 1;
  }
  
  // method to edit category
  // return :   0: success
  //            1: sql error
  // ----------------------------------------

  function Edit($category_id, $name, $parent_id, $description, $image, $content, $visible, $permission, $meta_keyword, $meta_description, $registered_only) {

    $query = "update $this->table_name set
      name = '$name',
      parent_id = $parent_id,
      description = '$description',
      image = '$image',
      content = '$content',
      visible = '$visible',
      permission = '$permission',
      meta_keyword = '$meta_keyword',
      meta_description = '$meta_description',
      registered_only = '$registered_only'
      where category_id = $category_id";
    $result = $this->db_connect->Execute($query);
    if($result) return 0;
    else return 1;
  }


  // method to delete category
  // return :   0: success
  //            1: category is not empty
  // ----------------------------------------

  function Delete($cat_id) {

    // do it have links
    
    $query = "select link_id from $this->link_table_name where category_id = '$cat_id'";
    $result = $this->db_connect->Execute($query);
    $total = $result->RecordCount();

    // if so, do not delete the category
    if($total!=0) return 1;
    else {

      // get the parent_id
      $query = "select parent_id from $this->table_name where category_id = '$cat_id'";
      $result = $this->db_connect->Execute($query);
      $parent_id = $result->Fields("parent_id");

      // do it has children?
      $query = "select category_id from $this->table_name where parent_id = '$cat_id'";
      $result = $this->db_connect->Execute($query);
      $total = $result->RecordCount();
      
      // if so, assign parent_id to their grandparent
      $i=0;
      while($i<$total) {
        $result->Move($i);
        $category_id = $result->Fields("category_id");
        
        $query = "update $this->table_name set
          parent_id = '$parent_id'
          where category_id = $category_id";
        $result2 = $this->db_connect->Execute($query);
        $i++;
      }

      // now delete the category
      $query = "delete from $this->table_name where category_id = '$cat_id'";
      $result = $this->db_connect->Execute($query);
      
      return 0;
    }
  }



  // method to get in ordered categories 
  // -----------------------------------
    
  function GetInOrderCategory($categories) {

    $total = count($categories);
        
    $i = 0;
    while($i<$total) {
      
      $cat_id = $categories[$i];
      
      $array["$cat_id"] = $this->GetCategoryPath($cat_id);
      asort($array); 
                         
      $i++;
    }
    
    $keys = array_keys($array);

    // return arrays of category_id 
    return $keys; 
  }



  // method to get number of links in specific category  
  // --------------------------------------------------
  
  function GetNumberOfLinks($cat) {

    $queue[] = $cat;
    while(list($key,$cat) = each($queue)) {
    
      // get children
      $query = "select category_id from $this->table_name where parent_id=$cat";
      $result = $this->db_connect->Execute($query);
      if($result) $total = $result->RecordCount(); 
     
      // put them in queue
      $j = 0;
      while($j<$total) {
      
        $result->Move($j);
        $queue[] = $result->Fields("category_id");                              
        $result->MoveNext(); 
        $j++;
      }
    }
    
    reset($queue);
    $query = "select count(link_id) as count from $this->link_table_name where 0!=0";
    while (list($key,$cat) = each($queue)) {
      $query .= " or category_id = $cat";
    }
    $result = $this->db_connect->Execute($query);
    $result->Move(0);
    $val = $result->Fields("count");                                 
    return $val;
  }


  
  // method to display the category path
  // -----------------------------------

  function GetCategoryPath($cat,$file="") { 

    $parent_id = 100;
    while($parent_id) {
      
      // read name and parent_id
      $query = "select parent_id, name from $this->table_name where category_id=$cat";
      $result = $this->db_connect->Execute($query);
      
      $parent_id = $result->Fields("parent_id");
      $name = $result->Fields("name");
      
      if(!empty($file)) { 
        $href = "<a href=$file?cat=$cat>";
        $close_href = "</a>";  
      }      

      // write path
      if(empty($path)) {
       $path = $href . $name . $close_href;
      }
      else {
       $path = $href . $name . $close_href . $this->separator . $path;    
      }
     
      // next looping
      $cat = $parent_id;
    }

    return $path . " ";
  }  


  
  // method to display search result from search category
  // ----------------------------------------------------

  function DisplaySearchResult($query,$file="") { 
  
    $parent_id = 100000;
    while($parent_id) {
      
      // read name and parent_id
      $query = "select parent_id, name from $this->table_name where category_id=$cat";
      $result = $this->db_connect->Execute($query);
      
      $parent_id = $result->Fields("parent_id");
      $name = $result->Fields("name");
      
      if(!empty($file)) { 
        $href = "<a href=$file?cat=$cat>";
        $close_href = "</a>";  
      }      

      // write path
      if(empty($path)) {
       $path = $href . $name . $close_href;
      }
      else {
       $path = $href . $name . $close_href . $this->separator . $path;    
      }
     
      // next looping
      $cat = $parent_id;
    }
    return $path . " ";
  }  


  // method to get access permission
  // -------------------------------

  function GetAccessPermission($cat) {

    // get main category

    $query = "select registered_only from $this->table_name where category_id = $cat";
    $result = $this->db_connect->Execute($query);

    return $result->Fields("registered_only");
  }

  
  // method to get content of category
  // ---------------------------------
  
  function GetContent($cat) {
  
    // get main category

    $query = "select content from $this->table_name where category_id = $cat";
    $result = $this->db_connect->Execute($query);
    
    return $result->Fields("content");    
  }



  // method to get meta keyword
  // --------------------------

  function GetMetaKeyword($cat) {

    // get main category

    $query = "select meta_keyword from $this->table_name where category_id = $cat";
    $result = $this->db_connect->Execute($query);

    return $result->Fields("meta_keyword");
  }


  // method to get meta description
  // ------------------------------

  function GetMetaDescription($cat) {

    // get main category

    $query = "select meta_description from $this->table_name where category_id = $cat";
    $result = $this->db_connect->Execute($query);

    return $result->Fields("meta_description");
  }



  // method to display categories
  // ----------------------------
  
  function Display() {
  
    // get main category

    if(empty($this->query)) 
      $query = "select * from $this->table_name where (parent_id = $this->parent and visible = 1) order by name";
    else $query = $this->query;
    
    $result = $this->db_connect->Execute($query);
    $num_cats = $result->RecordCount();  

    if($num_cats!=0) { 
      $category = $this->header; 
      $category .= "<table width=$this->cat_table_width cellspacing=$this->cat_cellspacing>\n";
      $category .= "<tr>";

        
      $st = $num_cats%$this->number_of_columns; 
      if($st==0) { 
        $col1 = floor($num_cats/$this->number_of_columns); 
        $col2 = floor($num_cats/$this->number_of_columns);  
        $col3 = floor($num_cats/$this->number_of_columns);
      }
      if($st==1) { 
        $col1 = floor($num_cats/$this->number_of_columns) + 1; 
        $col2 = floor($num_cats/$this->number_of_columns);  
        $col3 = floor($num_cats/$this->number_of_columns);      
      }
      if($st==2) { 
        $col1 = floor($num_cats/$this->number_of_columns) + 1; 
        $col2 = floor($num_cats/$this->number_of_columns) + 1; 
        $col3 = floor($num_cats/$this->number_of_columns);
      }
      if($st==3) { 
        $col1 = floor($num_cats/$this->number_of_columns) + 1; 
        $col2 = floor($num_cats/$this->number_of_columns) + 1; 
        $col3 = floor($num_cats/$this->number_of_columns) + 1; 
      }   
    
     $k=0; 
     while($k<$this->number_of_columns) { 
        $width = 100 / $this->number_of_columns;      
        $category .= "<td width=$width"."% valign=top>\n";  
   
        if($k==0) { $i=0; $max_loop = $col1; } 
    
        if($k==1) {     
          $i = $max_loop;         
          $max_loop = $max_loop+$col2; 
        } 
    
        if($k==2) { 
          $i = $max_loop;         
          $max_loop = $max_loop+$col3;
        } 
      
        if($k==3) { 
          $i=$max_loop;      
          $max_loop = $num_cats; 
        } 
    
        while($i < $max_loop){		

          $result->Move($i);
          $cat_id = $result->Fields("category_id");
          $cat_name = $result->Fields("name");
          $cat_description = $result->Fields("description");
          $cat_image = $result->Fields("image");
          $nl = $result->Fields("links");
          $result->MoveNext();
        
          if($this->show_image == false) $image = "";
          else {
            if($cat_image=="") $cat_image = $this->default_image;
            else $cat_image = $this->image_path.$cat_image;
            $image = "<img src='$cat_image'>";
          }
                   
          $number_of_links = str_replace("<%number_of_links%>",$nl,$this->number_of_links_format);
          $cat_description = str_replace("<%cat_description%>",$cat_description,$this->cat_description_format);

          $cat_url = $this->category_filename."?cat=$cat_id";
        
          if($this->type_of_list=="STANDART_LIST") { 
            $category .= "<p>";
            $category .= "$image <FONT FACE=$cat_font_face SIZE=$cat_font_size>";
            $category .= "<B><A HREF=\"$cat_url\" style=\"$this->cat_link_style\">$cat_name</A></B> $html_number_of_links \n";
            $category .= "$number_of_links\n";
            if($this->show_description) {
              $category .= "<br>";
              //$category .= "<a style='font-size: 11px; color: #567E96;'>$cat_description</a>\n";            
              $category .= "$cat_description \n";            
            }
            if($this->show_subcat) $category .= "";
          }
          
        
          if($this->type_of_list=="SEARCH_RESULT") {
            $category .= "<br>";
            $category .= $this->GetCategoryPath($cat_id,$this->category_filename);
            $category .= "$number_of_links\n";

            $this->bold_format = str_replace("<%keyword%>","\\1",$this->bold_format);
            
            if($this->bold) {
              $keywords = $this->keywords;
              $j=0;
              while($j<count($keywords)) {      
                //$category = eregi_replace("($keywords[$j])", "<b>\\1</b>", $category);
                $category = eregi_replace("($keywords[$j])", $this->bold_format, $category);
                $j++;
              }
            }            
          }
        
                  
          // get sub category
        
          if($this->show_subcat) {

            $query = "select category_id, name from $this->table_name where parent_id=\"$cat_id\" order by name";
            $result_sub = $this->db_connect->Execute($query);
            $num_subs = $result_sub->RecordCount();  

            $j = 0;	

            while(($j < $num_subs) && ($j < $this->number_of_subcats)){
              $result_sub->Move($j);
              $sub_id = $result_sub->Fields("category_id");
              $sub_name = $result_sub->Fields("name");
              $result_sub->MoveNext();

              $sub_url = $this->category_filename."?cat=$sub_id";
	            $category .= "<FONT FACE=$subcat_font_face SIZE=$subcat_font_size>\n";
	            $category .= "<A HREF=\"$sub_url\" style=\"$this->subcat_link_style\">$sub_name</A>, ";

    	        $j++;

              if(($j==$this->number_of_subcats)&&($j < $num_subs)) {
                $category .= "...\n";
              }
            }	                     
          }       
        
          $i++;    
        }    
        $k++;
        $category .= "</td>\n\n";
      }    
      $category .= "</tr></table>"; 
    }
    
    return $category;    
  }


  
  // method to update number of links in all categories
  // --------------------------------------------------

  function UpdateNumberOfLinksInAllCategories() {

    // get all categories
      
    $query = "select category_id from $this->table_name";
    $result = $this->db_connect->Execute($query);
    $total = $result->RecordCount();  

    $i = 0;	

    while(($i<$total)){
      $result->Move($i);
      $cat_id = $result->Fields("category_id");      
    
      $nl = $this->GetNumberOfLinks($cat_id);      
    
      $query = "update $this->table_name set links = $nl where category_id = $cat_id";
      $result2 = $this->db_connect->Execute($query);
      
      $i++;      
    }
  }


  
  // method to get category's add permission
  // ---------------------------------------
  
  function GetAddLinkPermission($cat) {
  
    $query = "select permission from $this->table_name where category_id = $cat";
    $result = $this->db_connect->Execute($query);
    return $result->Fields("permission");
  }


  // method to get category's name
  // -----------------------------

  function GetCategoryName($cat) {

    $query = "select name from $this->table_name where category_id = $cat";
    $result = $this->db_connect->Execute($query);
    return $result->Fields("name");
  }


  // method to display select category's list box
  // --------------------------------------------
  
  function DisplayCategoryListBox($cat,$show_main_category=false) {
  
    $category = "<select name=cat>";
    if($cat==0 || $show_main_category) $category .= "<OPTION VALUE='0'> </OPTION>";
    else $category .= "<OPTION VALUE=''></OPTION>";

    
    if(empty($this->query)) $query = "select * from $this->table_name order by name asc";
    else $query = $this->query;
    $result = $this->db_connect->Execute($query);
    $total = $result->RecordCount();  

    $i=0;
    while($i<$total) {
      $result->Move($i);
      $cat_id = $result->Fields("category_id");  
      $cat_name = $result->Fields("name");
      
      $category_list .= "<OPTION T='".$this->GetCategoryPath($cat_id)."' VALUE='$cat_id' ";
      if($cat_id == $cat) $category_list .= " SELECTED";
	    $category_list .= ">".$this->GetCategoryPath($cat_id)."</OPTION>\n";
      
      $i++;
    }
    
    $categories = explode("\n",$category_list);  
    asort($categories);
    $category .= implode("\n",$categories);

    $category .= "</select>";
    return $category;
  }  
  
  
  
  
}

?>
