<?php 

// --------------------------------------------------------------------------
//
// Sentraweb Application Framework 2.0
// 
// File name   : link.class.php 
// Description : Class to handle information node based on category structure
// Requirement : - PHP4 (http://www.php.net)
//               - ADODB Library (http://php.weblogs.com)
//                 by John Lim (jlim@natsoft.com.my)
//               - pagination.class.php (Sentraweb Application Framework 2.0)
//               - category.class.php (Sentraweb Application Framework 2.0)
//
//
// Copyright(C), Sentraweb, 2001, All Rights Reserved.
//
// This library is not free. Unauthorized use or distribution of  is strictly 
// prohibited, violators will be prosecuted. To obtain permission for using 
// this library, please contact us at Sentraweb (support@sentraweb.com)
//
// Author: Dody Rachmat Wicaksono (dody@sentraweb.com) 
// Oct, 2001
//
// --------------------------------------------------------------------------






class clsLink {

  // ----------
  // attributes
  // ----------
  
  var $table_name = "link";
  var $table_name_temp = "";
  var $query = "";
  var $date_format = "d-M-Y";
  var $max_rows = "";
  var $template = "";
  var $template_file = "";
  var $header = "";
  var $paging = false;
  var $show_number = true;
      
  var $pg_size = "10";
  var $cp_size = "10";
  var $cp_more = "10";
  var $href = "";
  var $more_param = "";

  var $icon_new = "<font size=1 color=Blue></font>";
  var $icon_updated = "<font size=1 color=Green></font>";
  var $icon_top_rated = "<font size=1 color=Maron></font>";
  var $icon_hot = "<font size=1 color=Red></font>";
  var $icon_pick = "<font size=1 color=gray></font>";
    
  var $category_table_name = "category";
  var $category_separator = " > ";
  var $category_filename = "browse.php";
  
  var $path_separator = " : ";
  var $new_title = "New";
  var $show_new_link_by_category = false;
  var $new_listing_date_format = "l, F j Y";
  var $new_link_category_path_template = "<p><b><%category_path%></b></p>";
  var $hot_link_category_path_template = "<p><b><%category_path%></b></p>";
  var $top_rated_link_category_path_template = "<p><b><%category_path%></b></p>";
  
  var $cache_time = 0;
  var $enable_cache = false;

  var $custom_field_offset = 21;      // start offset of the custom field
  var $fields_name;                   // array of db fields name
  var $fields_type;                   // array of db fields type
  var $fields_size;                   // array of db fields size
  var $autogenerate_form_text;        // template to generate input=text      
  var $autogenerate_form_textarea;    // template to generate <textarea>
  var $autogenerate_form_upload;      // template to generate upload link
  
  var $autogenerate_form_template;    // template to generate fields

  var $editor_table_name = "editor";
  var $user_table_name = "user";
  var $favorite_table_name = "favorite";
  var $favorite_detail_table_name = "favorite_detail";
  var $bad_link_table_name = "bad_link";
  
  var $votes_table_name = "votes";
  var $review_table_name = "review";

  var $rating_image_path = "";
  var $rev_rating_image_path = "";

  var $top_rated_limit = "10";
  var $hot_limit = "10";
  var $new_limit = "7";      // day
  var $updated_limit = "7";  // day

  var $curr_row = 0;
  
  var $bold = false;
  var $keywords = "";
  var $bold_format = "<b><%keyword%></b>";


  var $upload_html;
  var $remove_img_html;
  
  
  // output only
  
  var $pagination = "";  
  var $email_template_fields = "";

  var $num_rows = 0;
  var $new_link_number = 0;
  var $record_count_of_display = "";


  // internal use only  

  var $db_server = "mysql";
  var $db_hostname = "localhost";
  var $db_username = "";
  var $db_password = "";
  var $db_name = "";
  var $db_connect = "";
  
  var $new_link_number = 0;
  var $record_count_of_display = "";

  var $image_type = "251";   //varchar(251)

  var $lid;  

  

  // -------
  // methods
  // -------
  
  // InitDB($server,$host,$username,$pwd,$db)
  
  // GetFields()
  // GetTotalNewListing($st,$dt,$cat,$rev)
  // GetNewListingPath($st,$dt,$cat,$rev)
  
  // DisplayNewListing($st,$dt,$cat,$rev)
  // DisplayHotListing()
  // DisplayTopRatedListing()
  // DisplayEditorPickListing()
  // Display()
  
  // GenerateCustomFieldForm($generate_template=false,$add_form=false)
  
  // Add($pass_through_permission=false)
  // Modify($status,$id,$pass_through_all=false,$editor=false)
  // Delete(id)
  
  // ApproveLink($vid,$flag)
  // RejectLink($vid)
  
  // GetEditorEmail($cat)
  // GetEditor($cat)
  // BecomeEditor($status,$username,$cat,$admin=false)
  // DisplayEditor($query="")
  // ApproveEditor($username,$cat_id)
  // RejectEditor($username,$cat_id)
  // DeleteEditor($username,$cat_id)
  // GetEditorCategory($username)
  
  // EvalTemplate()
  
  // RateLink($id,$value)
  // Review($status,$id,$username,$rev_subject,$rev_rating,$rev_review)
  // DisplayReview($id,$query="",$show_link_detail=false)
  // ApproveReview($id)
  // RejectReview($id)
  
  // GetLinkTitle($id)
  // GetLinkCategoryId($id)
  // Go($id)

  // GetFavoritesDropDown($username)
  // AddToFavorite($favorite,$id)
  // DisplayFavorites()
  // EditFavorite($status,$username,$fav_id)
  // CreateFavorite($username,$title,$description)
  // DeleteFavorite($username,$fav_id)
  // ViewFavorite($fav_id)
  // RemoveDetailFavorite($username,$fav_id,$link_id)
  
  // BadLinkReport($status,$link_id="",$r_name="",$r_email="",$type="",$editor=false)
  // DeleteBadLinkReport($op,$id)
  
  // ViewDuplicateLinks()
  
  // UpdateNewFlag()
  // UpdateUpdatedFlag()
  // UpdateAvgReview($id)
  
  // GetAllWebmasterEmail()
  
  // ShowRadioButton($var_name,$list_text,$list_value,$checked)
  

  
  
  // method to initialize database connection
  // return :   nothing
  // ----------------------------------------

  function InitDB($server,$host,$username,$pwd,$db) {
  
    $this->db_server = $server;
    $this->db_hostname = $host;
    $this->db_username = $username;
    $this->db_password = $pwd;
    $this->db_name = $db;
    
    ADOLoadCode($this->db_server);    
    $this->db_connect = &ADONewConnection();    
    $this->db_connect->PConnect($this->db_hostname,$this->db_username,$this->db_password,$this->db_name);  
    //$this->db_connect->debug=true;
  }

    
  
  // method to get fields name
  // return :   array of field name
  // set value :  $this->fields_name
  //              $this->fields_type
  // -------------------------------

  function GetFields() {

    // get link fields information 

    $query = "select * from $this->table_name where link_id = 0";

    if($this->enable_cache) $result = $this->db_connect->CacheExecute($this->cache_time,$query);
    else $result = $this->db_connect->Execute($query);

    $num_fields = $result->FieldCount();      

    if($result) {
      $i=0;
      while($i<$num_fields) {
        $fld = $result->FetchField($i);
        $fields[] = $fld->name;
        $fields_type[] = $result->MetaType($fld->type);
        $fields_size[] = $fld->max_length;
        $i++;
      }
    }
    
    // set 
    
    $this->fields_name = $fields;
    $this->fields_type = $fields_type;
    $this->fields_size = $fields_size;
    
    // return array 
    
    return $fields;
  }



  // method to get the number of new listing
  // return :   number of new listing
  // ---------------------------------------
  
  function GetTotalNewListing($st,$dt,$cat,$rev) {
    
    $date = date("Y-m-d", $dt);        

    // get total new link
    
    if(empty($st)) { 
      $query = "select count(link_id) as nl from $this->table_name where new = 1";
      $result = $this->db_connect->Execute($query);
      $result->Move(0);
      $val = $result->Fields("nl");   
    }
    
    elseif($st=='date') {
      $query = "select count(link_id) as nl from $this->table_name where (new = 1 and (date = '$date' or last_updated = '$date'))";
      $result = $this->db_connect->Execute($query);
      $result->Move(0);
      $val = $result->Fields("nl");   
    }
    
    elseif($st=='cat') {

      $date = date("Y-m-d", $dt);        
     
      $queue[] = $cat;
      while(list($key,$cat) = each($queue)) {
    
        // get children
        $query = "select category_id from $this->category_table_name where parent_id=$cat";
        $result = $this->db_connect->Execute($query);
        if($result) $total = $result->RecordCount(); 
     
        // put them in queue
        $j = 0;
        while($j<$total) {
      
          $result->Move($j);
          $queue[] = $result->Fields("category_id");                              
          $result->MoveNext(); 
          $j++;
        }
      }
    
      $k=0;
      reset($queue);
      $query = "select count(link_id) as count from $this->table_name where (new = 1 and (date = '$date' or last_updated = '$date') ";
      while (list($key,$cat) = each($queue)) {
        if($k==0) $query .= " and (category_id = $cat";
        else $query .= " or category_id = $cat";
        $k++;
      }
      $query .= " ))";
    
      $result = $this->db_connect->Execute($query);
      $result->Move(0);
      $val = $result->Fields("count");                                    
    }
    
    return $val;    
  }



  // method to get the path of new listing
  // return :   path of new listing
  // -------------------------------------

  function GetNewListingPath($st,$dt,$cat,$rev) {
    
    $date = date($this->date_format, $dt);        
    
    // get total new link
    
    $path = " $this->path_separator <a href=$this->href>$this->new_title</a>";
    
    if(empty($st)) $path .= "";
    elseif($st=='date') $path .= " $this->path_separator $date";
    elseif($st=='cat') {    
      $query = "select name from $this->category_table_name where category_id = $cat";
      $result = $this->db_connect->Execute($query);
      $result->Move(0);
      $path .= " $this->path_separator <a href=?st=date&dt=$dt>$date</a> $this->path_separator " . $result->Fields("name");       
    }    
    
    return $path;
  }



  // method to display new listings
  // return :   html of new listing
  // ------------------------------

  function DisplayNewListing($st,$dt,$cat,$rev) {

    $this->new_link_number = 1;
    
    if(empty($st)) {
      
      // get date
    
      $query = "select distinct date, last_updated from $this->table_name where new = 1";
      $result = $this->db_connect->Execute($query);
      if($result) $num_rows = $result->RecordCount();    

      $i=0;
      while($i<$num_rows) {

        $result->Move($i);
        $date = $result->Fields("date");
        $last_updated = $result->Fields("last_updated");

        // compare which is the most recently
        $date = mktime(0,0,0,substr($date,5,2),substr($date,8,2),substr($date,0,4));
        $last_updated = mktime(0,0,0,substr($last_updated,5,2),substr($last_updated,8,2),substr($last_updated,0,4));

        if($date>$last_updated) $dates[] = $date;
        else $dates[] = $last_updated;
            
        $i++;
      }

      // remove duplicate entry
      $new_dates = array();
      $i=0;
      while($i<count($dates)) {
        $val = $dates[$i];
        if(!in_array($val,$new_dates)) $new_dates[] = $val;
        $i++;
      }
      
      $dates = $new_dates;

      // sort queue [in timestamp format]
      rsort($dates);

      // fetch by date

      $i=0;
      while($i<count($dates)) {

        $ts_date = $dates[$i];
        $date = date("Y-m-d",$ts_date);

        $query2 = "select count(link_id) as nl from $this->table_name where (new = 1 and (date = '$date' or last_updated = '$date'))";
        $result2 = $this->db_connect->Execute($query2);
        $total_by_dates[] = $result2->Fields("nl");        
      /*
        // get timestamp from Y-m-d
        
        $year     = substr($dates[$i],0,4);
        $month    = substr($dates[$i],5,2);
        $day   	  = substr($dates[$i],8,2);
        $hour	    = substr($dates[$i],11,2); 
  	    $minute   = substr($dates[$i],14,2);
   	    $second   = substr($dates[$i],17,2);

        $timestamp = mktime($hour,$minute,$second,$month,$day,$year);  
       */

        $date_ls = date($this->new_listing_date_format, $ts_date);

        $html .= "<p><a href=?st=date&dt=$ts_date>$date_ls</a> ($total_by_dates[$i])<br>";

        if($this->show_new_link_by_category) {      

          $basket = array("");
          
          // get categories for each date          
        
          $query2 = "select distinct category_id from $this->table_name where (new = 1 and (date = '$date' or last_updated = '$date'))";
          $result2 = $this->db_connect->Execute($query2);
          $num_cat = $result2->RecordCount();      
  
          if ($result2) {
            $j=0;
            while($j<$num_cat) {
  
              $result2->Move($j);
              $cat_id = $result2->Fields("category_id");

              // get the main category
    
              $parent_id = 100000;
              while($parent_id) {
      
                // read name and parent_id
                $query3 = "select parent_id, name from $this->category_table_name where category_id=$cat_id";
                $result3 = $this->db_connect->Execute($query3);
      
                $parent_id = $result3->Fields("parent_id");
                $name = $result3->Fields("name");
      
                $main_cat_id = $cat_id;                             
       
                // next looping
                $cat_id = $parent_id;      
              }    
          
              $cat_id = $main_cat_id; 
              
              if (!in_array($cat_id,$basket)) { 
              
                $basket[] = $cat_id;
             
                $cat_name = $name;
                $num_each_cat = $this->GetTotalNewListing('cat',$ts_date,$cat_id,'');

                $html .= "<a href=?st=cat&id=$cat_id&dt=$ts_date>$cat_name</a> ($num_each_cat)";
                $html .= " - ";              
              }              
              $j++;
            }
            $html = substr($html,0,strlen($html)-3); 
          }                    
        }        
        $i++;        
      } 
    }    


    if($st==date) {
      $date = date("Y-m-d", $dt);        
      
      // get categories, then save into an array
      
      $query = "select distinct category_id from $this->table_name where (new = 1 and (date = '$date' or last_updated = '$date'))";
      $result = $this->db_connect->Execute($query);
      $num_cat = $result->RecordCount();      
      
      $i=0;
      while($i<$num_cat) {      
        $result->Move($i);
        $categories[] = $result->Fields("category_id");
        $result->MoveNext();
        $i++;
      }  
      
      // get in order categories by path alphabetically

      $category_obj = new clsCategory;
      $category_obj->InitDB($this->db_server,$this->db_hostname,$this->db_username,$this->db_password,$this->db_name);

      $category_obj->table_name = $this->category_table_name;
      $category_obj->link_table_name = $this->table_name;
      $category_obj->separator = $this->category_separator;      
      
      $categories = $category_obj->GetInOrderCategory($categories);
            
      // fetch data by categories      

      $i=0;
      while($i<count($categories)) {
        
        // get category path

        $category_path = $category_obj->GetCategoryPath($categories[$i],$this->category_filename);        
        $html .= str_replace("<%category_path%>",$category_path,$this->new_link_category_path_template);
        
        $this->query = "select * from $this->table_name where (new = 1 and (date = '$date' or last_updated = '$date') and category_id = '$categories[$i]')";
        $html .= $this->Display();    
       
        $i++;
      }      
    }

    if($st==cat) {
  
      $date = date("Y-m-d", $dt);        
      
      // get categories, then save into an array
      
      $parent_cat = $cat;
      $queue[] = $cat;
      while(list($key,$cat) = each($queue)) {        
        
        // get children
        $query = "select distinct category_id from $this->category_table_name where parent_id=$cat";
        $result = $this->db_connect->Execute($query);
        if($result) $total = $result->RecordCount();         
        
        // put them in queue
        $j = 0;
        while($j<$total) {
      
          $result->Move($j);
          $cat_id = $result->Fields("category_id");                              
          
          $result->MoveNext(); 
          
          $query2 = "select count(link_id) as nl from $this->table_name where (category_id=$cat_id and new = 1 and (date = '$date' or last_updated = '$date'))";
          $result2 = $this->db_connect->Execute($query2);
          if($result2) {            
            if($result2->Fields("nl")>0) { $queue[] = $cat_id; }
          }       
          
          $j++;
        }
      }
      
      // check if the first element has new links
      
      $query = "select count(link_id) as nl from $this->table_name where (category_id=$parent_cat and new = 1 and (date = '$date' or last_updated = '$date'))";
      $result = $this->db_connect->Execute($query);
      if($result) {            
        if($result->Fields("nl")==0) { array_shift($queue); /* drop the first element */ }
      }       
      
      
      // get in order categories by path alphabetically
      
      $category_obj = new clsCategory;
      $category_obj->InitDB($this->db_server,$this->db_hostname,$this->db_username,$this->db_password,$this->db_name);

      $category_obj->table_name = $this->category_table_name;
      $category_obj->link_table_name = $this->table_name;
      $category_obj->separator = $this->category_separator;      
      
      reset($queue);
      $categories = $category_obj->GetInOrderCategory($queue);
      
      // fetch data by categories      

      $i=0;
      while($i<count($categories)) {
        

        // get category path

        $category_path = $category_obj->GetCategoryPath($categories[$i],$this->category_filename);        
        $html .= str_replace("<%category_path%>",$category_path,$this->new_link_category_path_template);
        
        $this->query = "select * from $this->table_name where (new = 1 and (date = '$date' or last_updated = '$date') and category_id = '$categories[$i]')";
        $html .= $this->Display();    
       
        $i++;
      }      
    }
    
    return $html;
  }  

    

  // method to display links
  // return :   html of hot listing
  // -------------------------------
  
  function DisplayHotListing() {

    $category_obj = new clsCategory;
    $category_obj->InitDB($this->db_server,$this->db_hostname,$this->db_username,$this->db_password,$this->db_name);

    $category_obj->table_name = $this->category_table_name;
    $category_obj->link_table_name = $this->table_name;
    $category_obj->separator = $this->category_separator;      

    // get all main category    

    $query = "select category_id from $this->category_table_name where parent_id=0";
    $result = $this->db_connect->Execute($query);
    if($result) $total_main_cat = $result->RecordCount();
    
    // put them in queue
    
    $i=0;
    while($i<$total_main_cat) {
      $result->Move($i);
      $main_categories[] = $result->Fields("category_id");                              
      $result->MoveNext(); 
      $i++;
    }
        
    // get in order categories by path alphabetically      
  
    $main_categories = $category_obj->GetInOrderCategory($main_categories);
    
    
    $i=0;
   while($i<count($main_categories)) {
      
      $main_cat_id = $main_categories[$i];                              

      // get children
      $query2 = "select distinct category_id from $this->category_table_name where parent_id=$main_cat_id";
      $result2 = $this->db_connect->Execute($query2);
      if($result2) $total = $result2->RecordCount();         
    
      // put them in queue
      
      $queue = array("");
      $queue = array_shift($queue);
      $queue[] = $main_cat_id;
      
      $j = 0;
      while($j<$total) {
      
        $result2->Move($j);
        $queue[] = $result2->Fields("category_id");                                       
        $result2->MoveNext(); 
        $result2->Fields("category_id");
        $j++;
      }     

      // fetch data by categories      

      if($total>0) {
        $this->query = "select * from $this->table_name where ((0!=0 ";
        $j=0;
        while($j<count($queue)) {        
          $cat_id = $queue[$j];
          $this->query .= "or category_id = $cat_id ";         
          $j++;
        }      
        $this->query .= ") and hot = 1) order by hits desc";
      }

      else {
        $this->query = "select * from $this->table_name where hot = 1 and category_id = $main_cat_id order by hits desc";
      }

      $html_temp = $this->Display();    
      
      if($html_temp!="") {
      
        // get category path

        $category_path = $category_obj->GetCategoryPath($main_cat_id,$this->category_filename);                
        $html .= str_replace("<%category_path%>",$category_path,$this->hot_link_category_path_template);
        $html .= $html_temp;
      }
      
      $i++;
    }       

    return $html;
  }
  


  // method to display top rated links
  // return :   html of top rated listing
  // ------------------------------------

  function DisplayTopRatedListing() {

    $category_obj = new clsCategory;
    $category_obj->InitDB($this->db_server,$this->db_hostname,$this->db_username,$this->db_password,$this->db_name);

    $category_obj->table_name = $this->category_table_name;
    $category_obj->link_table_name = $this->table_name;
    $category_obj->separator = $this->category_separator;

    // get all main category

    $query = "select category_id from $this->category_table_name where parent_id=0";
    $result = $this->db_connect->Execute($query);
    if($result) $total_main_cat = $result->RecordCount();

    // put them in queue

    $i=0;
    while($i<$total_main_cat) {
      $result->Move($i);
      $main_categories[] = $result->Fields("category_id");
      $result->MoveNext();
      $i++;
    }

    // get in order categories by path alphabetically

    $main_categories = $category_obj->GetInOrderCategory($main_categories);


    $i=0;
   while($i<count($main_categories)) {

      $main_cat_id = $main_categories[$i];

      // get children
      $query2 = "select distinct category_id from $this->category_table_name where parent_id=$main_cat_id";
      $result2 = $this->db_connect->Execute($query2);
      if($result2) $total = $result2->RecordCount();

      // put them in queue

      $queue = array("");
      $queue = array_shift($queue);
      $queue[] = $main_cat_id;
      
      $j = 0;
      while($j<$total) {

        $result2->Move($j);
        $queue[] = $result2->Fields("category_id");
        $result2->MoveNext();
        $result2->Fields("category_id");
        $j++;
      }

      // fetch data by categories

      if($total>0) {
        $this->query = "select * from $this->table_name where ((0!=0 ";
        $j=0;
        while($j<count($queue)) {
          $cat_id = $queue[$j];
          $this->query .= "or category_id = $cat_id ";
          $j++;
        }
        $this->query .= ") and top_rated = 1) order by rating desc";
      }

      else {
        $this->query = "select * from $this->table_name where top_rated = 1 and category_id = $main_cat_id order by rating desc";
      }

      $html_temp = $this->Display();

      if($html_temp!="") {

        // get category path

        $category_path = $category_obj->GetCategoryPath($main_cat_id,$this->category_filename);
        $html .= str_replace("<%category_path%>",$category_path,$this->top_rated_link_category_path_template);
        $html .= $html_temp;
      }

      $i++;
    }

    return $html;
  }

    

  // method to display editor pick links
  // return :   html of hot listing
  // -------------------------------
  
  function DisplayEditorPickListing() {

    $category_obj = new clsCategory;
    $category_obj->InitDB($this->db_server,$this->db_hostname,$this->db_username,$this->db_password,$this->db_name);

    $category_obj->table_name = $this->category_table_name;
    $category_obj->link_table_name = $this->table_name;
    $category_obj->separator = $this->category_separator;      

    // get all main category    

    $query = "select category_id from $this->category_table_name where parent_id=0";
    $result = $this->db_connect->Execute($query);
    if($result) $total_main_cat = $result->RecordCount();
    
    // put them in queue
    
    $i=0;
    while($i<$total_main_cat) {
      $result->Move($i);
      $main_categories[] = $result->Fields("category_id");                              
      $result->MoveNext(); 
      $i++;
    }
        
    // get in order categories by path alphabetically      
  
    $main_categories = $category_obj->GetInOrderCategory($main_categories);
    
    
    $i=0;
   while($i<count($main_categories)) {
      
      $main_cat_id = $main_categories[$i];                              

      // get children
      $query2 = "select distinct category_id from $this->category_table_name where parent_id=$main_cat_id";
      $result2 = $this->db_connect->Execute($query2);
      if($result2) $total = $result2->RecordCount();         
    
      // put them in queue
      
      $queue = array("");
      $queue = array_shift($queue);
      $queue[] = $main_cat_id;
      
      $j = 0;
      while($j<$total) {
      
        $result2->Move($j);
        $queue[] = $result2->Fields("category_id");                                       
        $result2->MoveNext(); 
        $result2->Fields("category_id");
        $j++;
      }     

      // fetch data by categories      

      if($total>0) {
        $this->query = "select * from $this->table_name where ((0!=0 ";
        $j=0;
        while($j<count($queue)) {        
          $cat_id = $queue[$j];
          $this->query .= "or category_id = $cat_id ";         
          $j++;
        }      
        $this->query .= ") and pick = 1) order by hits desc";
      }

      else {
        $this->query = "select * from $this->table_name where pick = 1 and category_id = $main_cat_id order by hits desc";
      }

      $html_temp = $this->Display();    
      
      if($html_temp!="") {
      
        // get category path

        $category_path = $category_obj->GetCategoryPath($main_cat_id,$this->category_filename);                
        $html .= str_replace("<%category_path%>",$category_path,$this->hot_link_category_path_template);
        $html .= $html_temp;
      }
      
      $i++;
    }       

    return $html;
  }







  
  // method to display links
  // return :   html 
  // set :      $this->record_count_of_display
  // -----------------------------------------
  
  function Display($validation=false) {

    $fields = $this->GetFields();

    if($this->enable_cache) $result = $this->db_connect->CacheExecute($this->cache_time,$this->query);
    else $result = $this->db_connect->Execute($this->query);
    
    if($result) $this->record_count_of_display = $num_rows = $result->RecordCount();      
    
    if($num_rows!=0) { $links = $this->header; }

    // pagination

    if($this->paging) {
      global $pg_which;
          
      if (empty($pg_which)) { $pg_which=1; }

      $nav = new navigator;
      $nav->pg_size = $this->pg_size;
      $nav->cp_size = $this->cp_size;
      $nav->cp_more = $this->cp_more;
      $nav->href = $this->href;
      $nav->more_param = $this->more_param;

      $nav->pg_which=$pg_which;
      $nav->rec_count=$num_rows;
      $nav->init();  
  
      $this->pagination = $nav->print_all();  

      $i = $nav->rec_start;
      $stop_loop = $nav->rec_end+1;    
      $this->max_rows = 100000;
    }
    else {
      $i = 0;
      $stop_loop = $num_rows;
    }


    $category_obj = new clsCategory;
    $category_obj->InitDB($this->db_server,$this->db_hostname,$this->db_username,$this->db_password,$this->db_name);
  
    $category_obj->table_name = $this->category_table_name;
    $category_obj->link_table_name = $this->table_name;    
    $category_obj->separator = $this->category_separator;
    
    // fetching data
    
    $number=0;
    while($i<$stop_loop && $i<$this->max_rows && $this->curr_row<$this->max_rows) {
     
      // get field's value
      
      $result->Move($i);
      $j=0;      
      while($j<count($fields)) {
        $$fields[$j] = $result->Fields("$fields[$j]");        
        $j++;
      }                      
      if($validation)
        $vid = $result->Fields("vid");

      $result->MoveNext();

      if($this->new_link_number==0) $number = $i+1;
      else {
        $this->new_link_number++;
        $number = $this->new_link_number-1;
      }
      
      $date = date($this->date_format,$result->UnixDate($date));
      
      // category's path

      $category_path = $category_obj->GetCategoryPath($category_id);
      $category_path_with_link = $category_obj->GetCategoryPath($category_id,$this->category_filename);


      // rating
      
      global $rating_image;
      
      if($rating==1) $rating_image = "<img src=".$this->rating_image_path."1.gif".">";
      elseif($rating==2) $rating_image = "<img src=".$this->rating_image_path."2.gif".">";
      elseif($rating==3) $rating_image = "<img src=".$this->rating_image_path."3.gif".">";
      elseif($rating==4) $rating_image = "<img src=".$this->rating_image_path."4.gif".">";
      elseif($rating==5) $rating_image = "<img src=".$this->rating_image_path."5.gif".">";

      
      // bold keyword
      if($this->bold) {
 
        $this->bold_format = str_replace("<%keyword%>","\\1",$this->bold_format);        
        $keywords = $this->keywords;
 
        $j=0;
        while($j<count($keywords)) {      
          $title = eregi_replace("($keywords[$j])", $this->bold_format, $title);
          $description = eregi_replace("($keywords[$j])", $this->bold_format, $description);
          $disp_url = eregi_replace("($keywords[$j])", $this->bold_format, $url);
          $j++;
        }
      }



      // write template    

      // -- template function
      
      if (empty($this->template_file)) $line = $this->template;
      else $line = implode(file($this->template_file), "");
      
      $line = str_replace("<%rating_image%>",$rating_image,$line);

      if($this->show_number) $line = str_replace("<%number%>",$number,$line);
      
      global $id;
      $line = str_replace("<%id%>",$id,$line);

      if($updated) {
        $line = str_replace("<%updated%>",$this->icon_updated,$line);
        $new = "";
      }
      elseif($new) {
        $line = str_replace("<%new%>",$this->icon_new,$line);
        $updated = "";
      }
      else {
        $updated = "";
        $new = "";
      }
      
      if($hot) $line = str_replace("<%hot%>",$this->icon_hot,$line);
      else $hot = "";
      
      if($top_rated) $line = str_replace("<%top_rated%>",$this->icon_top_rated,$line);
      else $top_rated = "";
      
      if($pick) $line = str_replace("<%pick%>",$this->icon_pick,$line);
      else $pick = "";
      


      if(empty($link_id) && $validation)
        $val_type = "<font color=green size=1>New</font>";
      elseif(!empty($link_id) && $validation)
        $val_type = "<font color=blue size=1>Modify</font>";
      if($validation)
        $line = str_replace("<%val_type%>",$val_type,$line);

      $j=0;  
      while($j<sizeof($fields)) {         

        // image
        
        if($this->fields_type[$j]=="C" && $this->fields_size[$j]==$this->image_type) 
          if($$fields[$j]=="")
            $$fields[$j] = "images/transparent.gif";
            
        $line = str_replace("<%$fields[$j]%>",$$fields[$j],$line);
        $j++;
      } 

      $chk_box = "<input type=checkbox name=chkbox_$number value=$link_id>";

      if($validation)
        $chk_box = "<input type=checkbox name=chkbox_$number value=$vid>";


      $line = str_replace("<%chk_box%>",$chk_box,$line);
      $line = str_replace("<%category_path%>",$category_path,$line);
      $line = str_replace("<%category_path_with_link%>",$category_path_with_link,$line);
      $line = str_replace("<%disp_url%>",$disp_url,$line);

      $links .= $line;
      
      
      // -- end of template function
      
      $this->curr_row++;
      $number++;
      $i++;
    }
    return $links;
  }



  // method to generate custom field form
  // return :   html of custom field
  // ------------------------------------
  
  function GenerateCustomFieldForm($generate_template=false,$add_form=false) {
  
    $fields = $this->GetFields();

    $i=$this->custom_field_offset;
    while($i<count($fields)) { 
      
      $field = $fields[$i];
      global $$field;
      
      // blob/text -> <textarea>
      if($this->fields_type[$i]=="X" || $this->fields_type[$i]=="B") 
        $form[$i] = $this->autogenerate_form_textarea;   
        
      // image
      elseif($this->fields_type[$i]=="C" && $this->fields_size[$i]==$this->image_type && !$add_form)        
        $form[$i] = $this->autogenerate_form_upload;   

      elseif($this->fields_type[$i]=="C" && $this->fields_size[$i]==$this->image_type && $add_form)        
        $form[$i] = $this->autogenerate_form_upload_add_form;
      
      // <input>
      else $form[$i] = $this->autogenerate_form_text;

      $form[$i] = str_replace("<%field_name%>",$fields[$i],$form[$i]);



      if($generate_template) 
        $form[$i] = str_replace("<%field_value%>","<%$fields[$i]%>",$form[$i]);        
      else 
        $form[$i] = str_replace("<%field_value%>",$$fields[$i],$form[$i]);
        
      $field_name = $fields[$i];   
      $form_field = stripslashes($form[$i]);
                           
      // generate output
      $line .= implode(file($this->autogenerate_form_template), "");
      $line = str_replace("<%field_name%>",$field_name,$line);
      $line = str_replace("<%form_field%>",$form_field,$line);
  
      $i++;
    }
 
    return $line;
  }


  // method to add new link
  // return :   0: success
  //            1: pending
  //            2: not allowed
  //            3: sql error
  // set var :  $email_template_fields
  // ------------------------------------------

  function Add($pass_through_permission=false) {

    global $cat;

    // get custom field
 
    $fields = $this->GetFields();
        
    $i=1;
    while($i<count($fields)) {
      $field = $fields[$i];
      global $$field;

      if($i!=1) {
        $custom_fields_name .= ",";
        $custom_fields_value .= ",";
      }
      
      $custom_fields_name .= $field;

      if($field=='date') { 
        $date = $this->db_connect->DBDate(time()); 
        $custom_fields_value .= $date;
      }
      elseif($field=='category_id') $custom_fields_value .= $cat;
      elseif($field=='hits') $custom_fields_value .= 0;
      elseif($field=='votes') $custom_fields_value .= 0;
      elseif($field=='rating') $custom_fields_value .= 0;
      elseif($field=='new') $custom_fields_value .= 0;
      elseif($field=='hot') $custom_fields_value .= 0;
      elseif($field=='top_rated') $custom_fields_value .= 0;
      elseif($field=='pick') $custom_fields_value .= 0;
      elseif($field=='updated') $custom_fields_value .= 0;

      elseif($field=='password') {

        // generate pwd
        mt_srand((double)microtime()*1000000);
        $pwd = mt_rand();
        $pwd = substr($pwd, -4, 4);

        $$field = $pwd;
        $custom_fields_value .= $pwd;
      }

      elseif($field=='bid') 
        if(empty($bid)) { $custom_fields_value .= 0; $bid = 0; }
        else $custom_fields_value .= "'".$$field."'";
      else $custom_fields_value .= "'".$$field."'";
      
      $i++;
    }
    
    $this->email_template_fields = str_replace(",",",\$",$custom_fields_name);
    $this->email_template_fields = "\$link_id,\$category,\$".$this->email_template_fields;
    
    // get category permission
    
    $category_obj = new clsCategory;
    $category_obj->InitDB($this->db_server,$this->db_hostname,$this->db_username,$this->db_password,$this->db_name);
    $category_obj->table_name = $this->category_table_name;
    $category_obj->link_table_name = $this->table_name;    
    $category_obj->separator = $this->category_separator;      
    $add_permission = $category_obj->GetAddLinkPermission($cat);    
    
    if($pass_through_permission) $add_permission=0;
    
    // no need approval

    if($add_permission==0) {
    
      //insert into db

      $query = "insert into $this->table_name ($custom_fields_name) values ($custom_fields_value)";
      $result = $this->db_connect->Execute($query);
      
      // get link_id
      
      global $link_id;
      $link_id = $this->db_connect->Insert_ID();

      if($result) return 0;
      else return 3;
    }

    // need to approve
    
    elseif($add_permission==1) {

      //insert into db
      
      $this->table_name_temp = $this->table_name . "_temp";
      
      $query = "insert into $this->table_name_temp ($custom_fields_name) values ($custom_fields_value)";
      $result = $this->db_connect->Execute($query);

      return 1;
    }
    
    // not allowed
    
    elseif($add_permission==2) return 2;
    
  }

  

  // method to display modify link 
  // input :    $status = "display_form"
  //                      "process_form"
  //                      "search"
  // return :   0: success
  //            1: pending
  //            2: incorrect password
  //            3: sql error
  // set var :  $email_template_fields
  // ------------------------------------------

  function Modify($status,$id,$pass_through_all=false,$editor=false) {

    global $cat,$pflag,$error_msg;

    // get fields
 
    $fields = $this->GetFields();

    $category_obj = new clsCategory;
    $category_obj->InitDB($this->db_server,$this->db_hostname,$this->db_username,$this->db_password,$this->db_name);
    $category_obj->table_name = $this->category_table_name;
    $category_obj->link_table_name = $this->table_name;    
    $category_obj->separator = $this->category_separator;      
 
 
    if($status=='display_form') {

      if($pflag!="modify") {
        // get values        
        $query = "select * from $this->table_name where link_id=$id";
        $result = $this->db_connect->Execute($query);
      }
      
      $i=0;     
      while($i<count($fields)) {

        $field = $fields[$i]; 
        global $$field;

        $i++;
      }    
   

      // required to generate image field
      $this->lid = $id;

      // replace strings
      
      $line = implode(file($this->template_file), "");

      $custom_field_form = $this->GenerateCustomFieldForm(true);
      if(!empty($custom_field_form)) $custom_field_form = $this->header . $custom_field_form;
      
      $line = str_replace("<%custom_field_form%>",$custom_field_form,$line);

      $i=0;  
      while($i<sizeof($fields)) {       
        
        $$fields[$i] = stripslashes($$fields[$i]);    
        
        if($pflag!="modify") {
          $$fields[$i] = $result->Fields("$fields[$i]"); 

          // image
        
          if($this->fields_type[$i]=="C" && $this->fields_size[$i]==$this->image_type) {
            if($$fields[$i]=="") {
              $$fields[$i] = "images/transparent.gif";          

              // admin cp
              if($pass_through_all && !$editor) { 
                $$fields[$i] = "images/transparent.gif"; 
                
                $upload_html = "<a href=img_upload.php?f=$fields[$i]&id=$this->lid>[Upload]</a>";
                $line = str_replace("<%".$fields[$i]."_upload%>",$upload_html,$line);              
              } 
              
              // public              
              else {

                $line = str_replace("<%".$fields[$i]."_upload%>",$this->upload_html,$line);                
                $line = str_replace("<%link_id%>",$this->lid,$line);  
                $line = str_replace("<%field_name%>",$fields[$i],$line);  
              
              }        
            }
            else {

              // admin cp
              if($pass_through_all && $$fields[$i]!="" && !$editor) {
                
                $upload_html = "<br><br> <a href=img_upload.php?f=$fields[$i]&id=$this->lid>[Upload]</a>";
                $line = str_replace("<%".$fields[$i]."_upload%>",$upload_html,$line);              

                $remove_html = " <a href=img_remove.php?f=$fields[$i]&id=$this->lid>[Remove]</a>";
                $line = str_replace("<%".$fields[$i]."_remove%>",$remove_html,$line);              
              }
              
              // editor cp
              if($editor && $$fields[$i]!="") {
              
                $line = str_replace("<%".$fields[$i]."_upload%>",$this->upload_html,$line);                
                $line = str_replace("<%link_id%>",$this->lid,$line);  
                $line = str_replace("<%field_name%>",$fields[$i],$line);         
                       
                $line = str_replace("<%".$fields[$i]."_remove%>",$this->remove_img_html,$line);                
                $line = str_replace("<%link_id%>",$this->lid,$line);  
                $line = str_replace("<%field_name%>",$fields[$i],$line);         
              }               

              // public cp
              if(!$pass_through_all && $$fields[$i]!="") {
              
                $line = str_replace("<%".$fields[$i]."_upload%>",$this->upload_html,$line);                
                $line = str_replace("<%link_id%>",$this->lid,$line);  
                $line = str_replace("<%field_name%>",$fields[$i],$line);         
                       
                $line = str_replace("<%".$fields[$i]."_remove%>",$this->remove_img_html,$line);                
                $line = str_replace("<%link_id%>",$this->lid,$line);  
                $line = str_replace("<%field_name%>",$fields[$i],$line);         

              }              
            }
          }
        }
        
        if($pass_through_all)
          if($fields[$i]=="new" || $fields[$i]=="hot" || $fields[$i]=="top_rated" || $fields[$i]=="pick" || $fields[$i]=="updated")
            $$fields[$i] = $this->ShowRadioButton($fields[$i],",","1,0",$$fields[$i]);

        $line = str_replace("<%$fields[$i]%>",$$fields[$i],$line);
        $i++;
      } 
      
      if(empty($category_id)) {
        $query = "select * from $this->table_name where link_id=$id";
        $result = $this->db_connect->Execute($query);
        $category_id = $result->Fields("category_id");       
      }
      
      if($editor) {
        // get editor category
        global $COOKIE_USERNAME;
        $categories = $this->GetEditorCategory($COOKIE_USERNAME);
  
        // build query
        $query = "select * from idx_category where 0!=0";
        $i=0;
        while($i<count($categories)) {
          $query .= " or category_id = $categories[$i]";
          $i++;
        }
  
        $category_obj->query = $query;
        $category = $category_obj->DisplayCategoryListBox($category_id);  
      }
      else  
        $category = $category_obj->DisplayCategoryListBox($category_id);
      
      $line = str_replace("<%category%>",$category,$line);
      $line = str_replace("<%error_msg%>",$error_msg,$line);
              
      print $line;
    }


    elseif($status=='process_form') {

      $i=0;
      while($i<count($fields)) {
        $field = $fields[$i];
        global $$field;

        if($i!=0 && $field!='password') {          
          $custom_fields_name .= ",";
          $custom_fields_value .= ",";
        }
      

        if($field=='date') { 
          $date = $this->db_connect->DBDate(time()); 
          $custom_fields_value .= $date;
          $custom_fields_name .= $field;
        }                                                                                                                                                                                          
        elseif($field=='category_id') { 
          $custom_fields_value .= "'$cat'";
          $custom_fields_name .= $field;
        }
        elseif($field=='password') {  }
        elseif($field=='last_updated') {
          $date = $this->db_connect->DBDate(time());
          $value = $$field = $date;
          $fields_value .= $date;
          $custom_fields_name .= $field;
          $custom_fields_value .= $value;
        }
        else {
          $custom_fields_value .= "'".$$field."'";
          $custom_fields_name .= $field;
        }
        $i++;
      }    
      
      // compare password
      
      $query = "select password from $this->table_name where link_id = $id";
      $result = $this->db_connect->Execute($query);
      $pwd = $result->Fields("password"); 
      
      if($password==$pwd || $pass_through_all) {
      
        $this->email_template_fields = str_replace(",",",\$",$custom_fields_name);
        $this->email_template_fields = "\$category,\$".$this->email_template_fields;

        // get category permission
    
        $add_permission = $category_obj->GetAddLinkPermission($cat);    

        // no need approval

        if($add_permission==0 || $pass_through_all) {
    
          // build query
        
          $query = "update $this->table_name set ";
        
          $i=1;
          while($i<count($fields)) {
            $field = $fields[$i];
            global $$field;

            if($field != "hits" && $field != "votes" && $field != "rating" &&
              $field != "hot" && $field != "new" && $field != "pick" && $field != "top_rated" &&
              $field != "password" && $field != "updated" && $field != "date") {
              
              if($field=='category_id') $value = "$cat";
              else $value = $$field;
            
              if($field=='last_updated')
                $query .= "$field = $value ";
              else
                $query .= "$field = '$value' ";

              if($i!=count($fields)-1) $query .= ", ";
            }
            
            $i++; 
          }

          $query .= "where link_id = $id";
          $result = $this->db_connect->Execute($query);
          
          if($pass_through_all) {
            $query = "update $this->table_name set
              password = '$password',
              pick = $pick
              where link_id = $id";
            $result = $this->db_connect->Execute($query);
          }
              
          if($result) return 0;
          else return 3;
        }
    
        // need to approve
    
        elseif($add_permission==1) {
        
          //insert into temp db
      
          $this->table_name_temp = $this->table_name . "_temp";
      
          $query = "insert into $this->table_name_temp ($custom_fields_name) values ($custom_fields_value)";
          $result = $this->db_connect->Execute($query);

          return 1;
        }
      
      }
      else return 2;
    
    }
  }

  

  // method to delete link
  // return :   0: success
  //            1: sql error
  // ------------------------------------------

  function Delete($id) {
    $query = "delete from $this->table_name where link_id = '$id'";
    $result = $this->db_connect->Execute($query);
    if($result) return 0;
    else return 1;
  }



  // method to approve link
  // input :    $vid : validation_id
  //            $flag : 0: new link
  //                    1: modify link
  // return :   0: success
  //            1: sql error
  // ------------------------------------------

  function ApproveLink($vid,$flag) {

    $category_obj = new clsCategory;
    $category_obj->InitDB($this->db_server,$this->db_hostname,$this->db_username,$this->db_password,$this->db_name);
    $category_obj->table_name = $this->category_table_name;
    $category_obj->link_table_name = $this->table_name;
    $category_obj->separator = $this->category_separator;

    // get field's value
    
    $fields = $this->GetFields();
    $this->table_name_temp = $this->table_name . "_temp";

    $query = "select * from $this->table_name_temp where vid = '$vid'";
    $result = $this->db_connect->Execute($query);


    // if new link
    if($flag==0) {

      $i=1;     // skip vid and link_id
      while($i<count($fields)) {

        $field = $fields[$i];
        global $$field;
        
        if($i!=1) {
          $fields_name .= ",";
          $fields_value .= ",";
        }

        if($field=='password') {

          // generate pwd
          mt_srand((double)microtime()*1000000);
          $pwd = mt_rand();
          $pwd = substr($pwd, -4, 4);

          $$field = $pwd;
          $fields_value .= "'".$pwd."'";
        }
        elseif($field=='date') {
          $date = $this->db_connect->DBDate(time());
          $$field = $date;
          $fields_value .= $date;
        }
        else {
          $$field = $result->Fields("$field");
          $fields_value .= "'".$$field."'";
        }
        
        $fields_name .= $field;

        $i++;
      }
      
      $query = "insert into $this->table_name ($fields_name) values ($fields_value)";
      $result = $this->db_connect->Execute($query);

      if($result) $return = 0;
      else $return = 1;

      // get link_id & category path
      global $link_id, $category;
      $link_id = $this->db_connect->Insert_ID();
      $category = $category_obj->GetCategoryPath($category_id);

      $this->email_template_fields = str_replace(",",",\$",$fields_name);
      $this->email_template_fields = "\$link_id,\$category,\$".$this->email_template_fields;
    }


    // if modify link
    if($flag==1) {


      // build query
      $query = "update $this->table_name set ";

      $i=0;     // skip vid and link_id
      while($i<count($fields)) {

        $field = $fields[$i];
        global $$field;

        if($i!=0) {
          $fields_name .= ",";
          $fields_value .= ",";
        }

        if($field=='last_updated') {
          $date = $this->db_connect->DBDate(time());
          $value = $$field = $date;
          $fields_value .= $date;
        }
        else {
          $value = $$field = $result->Fields("$field");
          $fields_value .= "'".$$field."'";
        }

        $fields_name .= $field;

        if($field != "link_id" && $field != "hits" && $field != "votes" && $field != "rating" &&
          $field != "hot" && $field != "new" && $field != "pick" && $field != "top_rated" &&
          $field != "password" && $field != "updated" && $field != "date" &&
          $field != "reviews" && $field != "avg_review") {

          if($field=='last_updated') $query .= "$field = ".$value;
          else $query .= "$field = '".addslashes($value)."'";

          if($i!=count($fields)-1) $query .= ", ";
        }

        $i++;
      }

      $query .= " where link_id = '$link_id'";
      $result2 = $this->db_connect->Execute($query);

      if($result) $return = 0;
      else $return = 1;

      // get category path
      global $category;
      $category = $category_obj->GetCategoryPath($category_id);

      $this->email_template_fields = str_replace(",",",\$",$fields_name);
      $this->email_template_fields = "\$link_id,\$category,\$".$this->email_template_fields;
    }

    // delete temporary record
    $query = "delete from $this->table_name_temp where vid = '$vid'";
    $result = $this->db_connect->Execute($query);

    return $return;
  }



  // method to reject link
  // input :    $vid : validation_id
  // return :   0: success
  //            1: sql error
  // ------------------------------------------

  function RejectLink($vid) {

    $category_obj = new clsCategory;
    $category_obj->InitDB($this->db_server,$this->db_hostname,$this->db_username,$this->db_password,$this->db_name);
    $category_obj->table_name = $this->category_table_name;
    $category_obj->link_table_name = $this->table_name;
    $category_obj->separator = $this->category_separator;

    // get field's value

    $fields = $this->GetFields();
    $this->table_name_temp = $this->table_name . "_temp";

    $query = "select * from $this->table_name_temp where vid = '$vid'";
    $result = $this->db_connect->Execute($query);

    // get value

    $i=1;     // skip vid and link_id
    while($i<count($fields)) {

      $field = $fields[$i];
      global $$field;

      if($i!=1) {
        $fields_name .= ",";
        $fields_value .= ",";
      }

       $$field = $result->Fields("$field");
       $fields_value .= "'".$$field."'";
       $fields_name .= $field;

       $i++;
    }

    // get category path
    global $category;
    $category = $category_obj->GetCategoryPath($category_id);

    $this->email_template_fields = str_replace(",",",\$",$fields_name);
    $this->email_template_fields = "\$link_id,\$category,\$".$this->email_template_fields;

    // delete temporary record
    $query = "delete from $this->table_name_temp where vid = '$vid'";
    $result = $this->db_connect->Execute($query);

    if($result) return 0;
    else return 1;
  }


  // method to get all editors email address 
  // input :    $cat
  // return :   array that contain email addr.
  // -----------------------------------------

  function GetEditorEmail($cat) {
  
    if($cat=='all') $query = "select distinct username from $this->editor_table_name where status = 1";
    else $query = "select username from $this->editor_table_name where category_id = $cat and status = 1";
    
    $result = $this->db_connect->Execute($query);
    $total = $result->RecordCount();   

    $user_obj = new clsUsers;
    $user_obj->InitDB($this->db_server,$this->db_hostname,$this->db_username,$this->db_password,$this->db_name);
    $user_obj->table_name = $this->user_table_name;
  
    $i=0;
    while($i<$total) {
      $result->Move($i);
      $username = $result->Fields("username");        
      $result->MoveNext();
      
      $email[] = $user_obj->GetEmailAddress($username);
     
      $i++;
    }
    return $email;
  }


  
  // method to get editors's username
  // input :    $cat
  // return :   array that contain username
  // ----------------------------------------

  function GetEditor($cat) {

    $query = "select username from $this->editor_table_name where category_id = $cat and status = 1";
    $result = $this->db_connect->Execute($query);
    $total = $result->RecordCount();

    $i=0;
    while($i<$total) {
      $result->Move($i);
      $username = $result->Fields("username");

      $editor[] = $username;
      $i++;
    }
    return $editor;
  }

  
  // method to handle new editor subscription
  // input :    $status = "process_form"
  // return :   0: success
  //            1: pending
  //            2: sql error
  // set var :  $email_template_fields
  // ------------------------------------------

  function BecomeEditor($status,$username,$cat,$admin=false) {

    $category_obj = new clsCategory;
    $category_obj->InitDB($this->db_server,$this->db_hostname,$this->db_username,$this->db_password,$this->db_name);
    $category_obj->table_name = $this->category_table_name;
    $category_obj->link_table_name = $this->table_name;
    $category_obj->separator = $this->category_separator;

    if($status=="process_form") {

      $date = $this->db_connect->DBDate(time());

      if($admin)
        $query = "insert into $this->editor_table_name
          (username,category_id,category,link,review,pick,status,date)
          values ('$username',$cat,1,1,1,1,1,$date)";

      else
        $query = "insert into $this->editor_table_name
          (username,category_id,category,link,review,pick,status,date)
          values ('$username',$cat,1,1,1,1,0,$date)";

      $result = $this->db_connect->Execute($query);

      // change group id
      if($admin) {

        $users_obj = new clsUsers;
        $users_obj->InitDB($this->db_server,$this->db_hostname,$this->db_username,$this->db_password,$this->db_name);
        $users_obj->table_name = "idx_users";
        $gid = $users_obj->GetGroupId($username);

        // if not administrator, then change to editor
        if($gid!=0) {
          $query = "update $this->user_table_name set
            group_id = 1 where username = '$username'";
          $result = $this->db_connect->Execute($query);
        }
      }


      // email
      
      global $username, $name, $email, $category;
      
      $query = "select name, email from $this->user_table_name where username='$username'";
      $result = $this->db_connect->Execute($query);
      
      $name = $result->Fields("name");
      $email = $result->Fields("email");
      
      $category = $category_obj->GetCategoryPath($cat);
      $this->email_template_fields = "\$username,\$name,\$email,\$category";

      return 1;
    }
  }



  // method to display editor
  // input :    $query
  // return :   list of editor
  // --------------------------------

  function DisplayEditor($query="") {
    global $pg_which;

    if(empty($query))
      $query = "select * from idx_editor where status = 0";

    $result = $this->db_connect->Execute($query);
    $num_rows = $result->RecordCount();

    // prepare pagination

    if (empty($pg_which)) { $pg_which=1; }

    $nav = new navigator;
    $nav->pg_size = $this->pg_size;
    $nav->cp_size = $this->cp_size;
    $nav->cp_more = $this->cp_more;
    $nav->href = $this->href;
    $nav->more_param = $this->more_param;

    $nav->pg_which=$pg_which;
    $nav->rec_count=$num_rows;
    $nav->init();

    $this->pagination = $nav->print_all();

    $i = $nav->rec_start;
    $stop_loop = $nav->rec_end+1;

    // fetch data

    $chk_num = 1;
    $this->num_rows = 0;
    while($i<$stop_loop) {

      $result->Move($i);
      $username = $result->Fields("username");
      $category_id = $result->Fields("category_id");
      $date = $result->Fields("date");

      $date = date($this->date_format,$result->UnixDate($date));
      $number = $i+1;

      $chk_box = "<input type=checkbox name=chkbox_$chk_num value=$username&$category_id>";
      $chk_num++;

      // get more info about editor

      $query = "select email, name from $this->user_table_name where username = '$username'";
      $result2 = $this->db_connect->Execute($query);

      $name = $result2->Fields("name");
      $email = $result2->Fields("email");


      $category_obj = new clsCategory;
      $category_obj->InitDB($this->db_server,$this->db_hostname,$this->db_username,$this->db_password,$this->db_name);
      $category_obj->table_name = $this->category_table_name;
      $category_obj->link_table_name = $this->table_name;
      $category_obj->separator = $this->category_separator;

      $category_path = $category_obj->GetCategoryPath($category_id);
      $category_path_with_link = $category_obj->GetCategoryPath($category_id,$this->category_filename);


      $this->num_rows++;

      // write template

      $line .= implode(file($this->template_file), "");
      $line = str_replace("<%username%>",$username,$line);
      $line = str_replace("<%date%>",$date,$line);
      $line = str_replace("<%category_path%>",$category_path,$line);
      $line = str_replace("<%category_path_with_link%>",$category_path_with_link,$line);

      $line = str_replace("<%chk_box%>",$chk_box,$line);

      $line = str_replace("<%name%>",$name,$line);
      $line = str_replace("<%email%>",$email,$line);

      $i++;
    }

    return $line;
  }



  // method to approve editor
  // input :    $username
  //            $cat_id
  // return :   0 : success
  //            1 : sql error
  // --------------------------------

  function ApproveEditor($username,$cat_id) {

    // update status to 1
    $query = "update $this->editor_table_name set status = 1 where username = '$username' and category_id = $cat_id";
    $result = $this->db_connect->Execute($query);

    if($result) return 0;
    else return 1;
  }


  // method to reject editor
  // input :    $username
  //            $cat_id
  // return :   0 : success
  //            1 : sql error
  // --------------------------------

  function RejectEditor($username,$cat_id) {

    // delete editor
    $query = "delete from $this->editor_table_name where username = '$username' and category_id = $cat_id and status = 0";
    $result = $this->db_connect->Execute($query);

    if($result) return 0;
    else return 1;
  }



  // method to delete editor
  // input :    $username
  //            $cat_id
  // return :   0 : success
  //            1 : sql error
  // --------------------------------

  function DeleteEditor($username,$cat_id) {

    // delete editor
    $query = "delete from $this->editor_table_name where username = '$username' and category_id = $cat_id and status = 1";
    $result = $this->db_connect->Execute($query);
    
    // change group_id if necessary
    
    $query = "select category_id from $this->editor_table_name where username = '$username' and status = 1";
    $result = $this->db_connect->Execute($query);
    $total = $result->RecordCount();

    if($total<1) {
      $query = "update $this->user_table_name set group_id = 2 where username = '$username' and status = 1";
      $result = $this->db_connect->Execute($query);
    }

    if($result) return 0;
    else return 1;
  }



  // method to get editor's category
  // input :    $username
  // return :   array of category
  // --------------------------------

  function GetEditorCategory($username) {

    $query = "select category_id from $this->editor_table_name where username = '$username' and status = 1";
    $result = $this->db_connect->Execute($query);
    $total = $result->RecordCount();

    $i=0;
    while($i<$total) {
      $result->Move($i);
      $category[] = $result->Fields("category_id");
      $i++;
    }

    return $category;
  }



  // method to evaluate template file
  // input :    $templatefile
  //            $vars
  // return :   html
  // --------------------------------

  function EvalTemplate($templatefile, $vars) {  
    $line=implode(file($templatefile), "");  
    eval( "global $vars;");  
    $vars = str_replace(",","",$vars);
    $var_list = explode("\$",$vars);
    $i=0;
    while($i<=sizeof($var_list)) {    
      $line = str_replace("<%$var_list[$i]%>",$$var_list[$i],$line);
      $i++;
    }   
    return $line;
  }  



  // method to rate a link
  // input :    $id
  //            $value
  // return :   0: success
  //            1: ip already exist
  //            2: sql error
  // --------------------------------

  function RateLink($id, $value) {

    global $HTTP_SERVER_VARS;

    $ip = $HTTP_SERVER_VARS["REMOTE_ADDR"];

    // is the ip already exist
    
    $query = "select ip from $this->votes_table_name where link_id = $id and ip = '$ip'";
    $result = $this->db_connect->Execute($query);
    $total = $result->RecordCount();
    
    if($total==0) {

      // insert into votes table
      $query = "insert into $this->votes_table_name values ($id,'$ip',$value)";
      $result = $this->db_connect->Execute($query);

      // get avg value
      $query = "select avg(value) as avg from $this->votes_table_name where link_id = $id";
      $result = $this->db_connect->Execute($query);
      $avg = $result->Fields("avg");

      // count votes
      $query = "select count(value) as c from $this->votes_table_name where link_id = $id";
      $result = $this->db_connect->Execute($query);
      $count = $result->Fields("c");

      // update avg value in link table
      $query = "update $this->table_name set rating = $avg, votes = $count where link_id = $id";
      $result = $this->db_connect->Execute($query);

      // reset top_rated flag
      $query = "update $this->table_name set top_rated = 0";
      $result = $this->db_connect->Execute($query);
      
      // update top_rated flag
      $query = "select * from $this->table_name where rating <> 0 order by rating desc";
      $result = $this->db_connect->Execute($query);
      $num_rows = $result->RecordCount();

      $i=0;
      while($i<$num_rows && $i<$this->top_rated_limit) {
        $result->Move($i);
        $link_id = $result->Fields("link_id");

        $query = "update $this->table_name set top_rated = 1 where link_id = '$link_id'";
        $result2 = $this->db_connect->Execute($query);
        $i++;
      }
      
      return 0;
    }
    elseif($total>0) return 1;
    else return 2;
  }


  // method to review link
  // input :    $status      = "process_form"
  //                           "validate review"
  //            $id          = link_id
  //            $username    = username
  //            $rev_subject = review's subject
  //            $rev_rating  = review's rating
  //            $rev_review  = review
  // return :   0: success
  //            1: sql error
  // set var :  $email_template_fields
  // ------------------------------------------

  function Review($status,$id,$username,$rev_subject,$rev_rating,$rev_review) {

    // get link value

    $fields = $this->GetFields();

    $query = "select * from $this->table_name where link_id=$id";
    $result = $this->db_connect->Execute($query);

    $i=0;
    while($i<count($fields)) {
      $field = $fields[$i];
      global $$field;

      $$fields[$i] = $result->Fields("$fields[$i]");
      if($i!=0) $fields_name .= ",";
      $fields_name .= $field;

      $i++;
    }

    $this->email_template_fields = str_replace(",",",\$",$fields_name);
    $this->email_template_fields = "\$category,\$username,\$rev_subject,\$rev_rating,\$rev_review,\$"
      .$this->email_template_fields;

    if($status=='process_form') {

      $date = $this->db_connect->DBDate(time());
      
      //insert into db
      $query = "insert into $this->review_table_name
        (link_id, username, subject, rating, review, date, status)
        values ($id,'$username','$rev_subject','$rev_rating','$rev_review',$date,0)";
      $result = $this->db_connect->Execute($query);

      if($result) return 0;
      else return 1;
    }
  }



  // method to display review
  // input :    $id
  //            $query
  // return :   list of review
  // --------------------------------

  function DisplayReview($id,$query="",$show_link_detail=false) {
    global $pg_which;

    if(empty($query))
      $query = "select * from $this->review_table_name where link_id = $id and status = 1 order by date desc";

    $result = $this->db_connect->Execute($query);
    $num_rows = $result->RecordCount();
    
    // prepare pagination

    if (empty($pg_which)) { $pg_which=1; }

    $nav = new navigator;
    $nav->pg_size = $this->pg_size;
    $nav->cp_size = $this->cp_size;
    $nav->cp_more = $this->cp_more;
    $nav->href = $this->href;
    $nav->more_param = $this->more_param;

    $nav->pg_which=$pg_which;
    $nav->rec_count=$num_rows;
    $nav->init();

    $this->pagination = $nav->print_all();

    $i = $nav->rec_start;
    $stop_loop = $nav->rec_end+1;
    
    
    if(!$show_link_detail) {  // not in admin area

      // get avg_review
    
      $query = "select reviews, avg_review from $this->table_name where link_id = $id";      
      $result2 = $this->db_connect->Execute($query);
      $avg_review = $result2->Fields("avg_review");
      $num_review = $result2->Fields("reviews");
    
      $avgr = $avg_review * 2;
      if(round($avgr)==1)  $avg_review_image = "<img src=".$this->rev_rating_image_path."0half.gif".">";
      elseif(round($avgr)==2)  $avg_review_image = "<img src=".$this->rev_rating_image_path."0.gif".">";
      elseif(round($avgr)==3)  $avg_review_image = "<img src=".$this->rev_rating_image_path."1half.gif".">";
      elseif(round($avgr)==4)  $avg_review_image = "<img src=".$this->rev_rating_image_path."2.gif".">";
      elseif(round($avgr)==5)  $avg_review_image = "<img src=".$this->rev_rating_image_path."2half.gif".">";
      elseif(round($avgr)==6)  $avg_review_image = "<img src=".$this->rev_rating_image_path."3.gif".">";
      elseif(round($avgr)==7)  $avg_review_image = "<img src=".$this->rev_rating_image_path."3half.gif".">";
      elseif(round($avgr)==8)  $avg_review_image = "<img src=".$this->rev_rating_image_path."4.gif".">";
      elseif(round($avgr)==9)  $avg_review_image = "<img src=".$this->rev_rating_image_path."4half.gif".">";
      elseif(round($avgr)==10) $avg_review_image = "<img src=".$this->rev_rating_image_path."5.gif".">";
    
      $line = $this->header;
      $line = str_replace("<%avg_review%>",$avg_review,$line);
      $line = str_replace("<%num_review%>",$num_review,$line);
      $line = str_replace("<%avg_review_image%>",$avg_review_image,$line);
    }
    
    
    // fetch data
    
    $chk_num = 1;
    while($i<$stop_loop) {

      $result->Move($i);
      $review_id = $result->Fields("review_id");
      $username = $result->Fields("username");
      $link_id = $result->Fields("link_id");
      $date = $result->Fields("date");
      $rating = $result->Fields("rating");
      $review = $result->Fields("review");

      $date = date($this->date_format,$result->UnixDate($date));
      $number = $i+1;
      
      global $rating_image;
      
      if($rating==1) $rating_image = "<img src=".$this->rev_rating_image_path."1.gif".">";
      elseif($rating==2) $rating_image = "<img src=".$this->rev_rating_image_path."2.gif".">";
      elseif($rating==3) $rating_image = "<img src=".$this->rev_rating_image_path."3.gif".">";
      elseif($rating==4) $rating_image = "<img src=".$this->rev_rating_image_path."4.gif".">";
      elseif($rating==5) $rating_image = "<img src=".$this->rev_rating_image_path."5.gif".">";

      $chk_box = "<input type=checkbox name=chkbox_$chk_num value=$review_id>";
      $chk_num++;
      
      if($show_link_detail) {
        $query = "select title, url, category_id from $this->table_name where link_id = $link_id";
        $result2 = $this->db_connect->Execute($query);
        $title = $result2->Fields("title");
        $url = $result2->Fields("url");
        $category_id = $result2->Fields("category_id");

        $category_obj = new clsCategory;
        $category_obj->InitDB($this->db_server,$this->db_hostname,$this->db_username,$this->db_password,$this->db_name);
        $category_obj->table_name = $this->category_table_name;
        $category_obj->link_table_name = $this->table_name;
        $category_obj->separator = $this->category_separator;

        $category_path = $category_obj->GetCategoryPath($category_id);
        $category_path_with_link = $category_obj->GetCategoryPath($category_id,$this->category_filename);
      }

      $this->num_rows++;

      // write template

      $line .= implode(file($this->template_file), "");
      $line = str_replace("<%number%>",$number,$line);
      $line = str_replace("<%username%>",$username,$line);
      $line = str_replace("<%date%>",$date,$line);
      $line = str_replace("<%rating%>",$rating,$line);
      $line = str_replace("<%rating_image%>",$rating_image,$line);
      $line = str_replace("<%review%>",$review,$line);
      
      $line = str_replace("<%chk_box%>",$chk_box,$line);

      $line = str_replace("<%title%>",$title,$line);
      $line = str_replace("<%url%>",$url,$line);
      $line = str_replace("<%category_path%>",$category_path,$line);
      $line = str_replace("<%category_path_with_link%>",$category_path_with_link,$line);

      $i++;
    }

    return $line;
  }




  // method to approve review
  // input :    $id
  // return :   0 : success
  //            1 : sql error
  // --------------------------------

  function ApproveReview($id) {

    // update status to 1
    $query = "update $this->review_table_name set status = 1 where review_id = $id";
    $result = $this->db_connect->Execute($query);

    
    // get link id
    $query = "select link_id from $this->review_table_name where review_id = $id";
    $result = $this->db_connect->Execute($query);
    $lid = $result->Fields("link_id");    
    
    // get avg review
    $query = "select avg(rating) as avg from $this->review_table_name where link_id = $lid and status = 1";
    $result = $this->db_connect->Execute($query);
    $avg = $result->Fields("avg");

    // count review
    $query = "select count(rating) as c from $this->review_table_name where link_id = $lid and status = 1";
    $result = $this->db_connect->Execute($query);
    $count = $result->Fields("c");

    // update avg value in link table
    $query = "update $this->table_name set avg_review = $avg, reviews = $count where link_id = $lid";
    $result = $this->db_connect->Execute($query);

    if($result) return 0;
    else return 1;
  }


  // method to reject review
  // input :    $id
  // return :   0 : success
  //            1 : sql error
  // --------------------------------

  function RejectReview($id) {

    // delete review
    $query = "delete from $this->review_table_name where review_id = $id";
    $result = $this->db_connect->Execute($query);

    if($result) return 0;
    else return 1;
  }


  // method to get link's title
  // input :    $id
  // return :   title
  // --------------------------------

  function GetLinkTitle($id) {
    $query = "select title from $this->table_name where link_id = $id";
    $result = $this->db_connect->Execute($query);
    return $result->Fields("title");
  }
  


  // method to get link's category_id
  // input :    $id
  // return :   category_id
  // --------------------------------

  function GetLinkCategoryId($id) {
    $query = "select category_id from $this->table_name where link_id = $id";
    $result = $this->db_connect->Execute($query);
    return $result->Fields("category_id");
  }



  // method to go to url
  // input :    $id
  // --------------------------------

  function Go($id) {

    // get current hits
    $query = "select hits, url from $this->table_name where link_id=$id";
    $result = $this->db_connect->Execute($query);
    $url = $result->Fields("url");
    $hits = $result->Fields("hits");

    // update hits
    $query = "update $this->table_name set hits = ($hits + 1) where link_id = $id";
    $result = $this->db_connect->Execute($query);
    

    // reset hot flag
    $query = "update $this->table_name set hot = 0";
    $result = $this->db_connect->Execute($query);

    // update hot flag
    $query = "select * from $this->table_name where hits <> 0 order by hits desc";
    $result = $this->db_connect->Execute($query);
    $num_rows = $result->RecordCount();

    $i=0;
    while($i<$num_rows && $i<$this->hot_limit) {
      $result->Move($i);
      $link_id = $result->Fields("link_id");

      $query = "update $this->table_name set hot = 1 where link_id = '$link_id'";
      $result2 = $this->db_connect->Execute($query);
      $i++;
    }

    header("Location: $url");
  }



  // method to display drop down menu of available favorites
  // output :    html
  // --------------------------------

  function GetFavoritesDropDown($username) {

    $fav = "<select name=favorite>\n";
    
    $query = "select * from $this->favorite_table_name where username='$username' order by title asc";
    $result = $this->db_connect->Execute($query);
    $total = $result->RecordCount();

    $i=0;
    while($i<$total) {
      $result->Move($i);
      $fav_id = $result->Fields("favorite_id");
      $title = $result->Fields("title");

      $fav .= "<OPTION VALUE='$fav_id'>$title</OPTION>\n";
      $i++;
    }

    $fav .= "</select>";
    return $fav;
  }
  
  
  
  // method to add new link into favorites
  // input :     $favorite
  //             $id
  // output :    0: success
  //             1: link already exist
  // -------------------------------------

  function AddToFavorite($favorite,$id) {
    $query = "select * from $this->favorite_detail_table_name
      where favorite_id = $favorite and link_id = $id";
    $result = $this->db_connect->Execute($query);

    if($result->RecordCount()==0) {
      $query = "insert into $this->favorite_detail_table_name
        (favorite_id,link_id) values ($favorite,$id)";
      $result = $this->db_connect->Execute($query);

      // update date
      $date = $this->db_connect->DBDate(time()); 
      $query = "update $this->favorite_table_name set date = $date where favorite_id = $favorite" ;
      $result = $this->db_connect->Execute($query);

      return 0;
    }
    else return 1;
  }



  // method to display favorites
  // input :     $username
  // output :    html
  // -------------------------------------

  function DisplayFavorites() {

    $result = $this->db_connect->Execute($this->query);
    $total = $result->RecordCount();
    
    $tpl = implode(file($this->template_file), "");

    $i=0;
    while($i<$total && $i<$this->max_rows) {
      $result->Move($i);
      $favorite_id = $result->Fields("favorite_id");
      $date = $result->Fields("date");
      $username = $result->Fields("username");
      $title = $result->Fields("title");
      $description = $result->Fields("description");

      $date = date($this->date_format,$result->UnixDate($date));

      $line .= $tpl;
      $line = str_replace("<%favorite_id%>",$favorite_id,$line);
      $line = str_replace("<%date%>",$date,$line);
      $line = str_replace("<%username%>",$username,$line);
      $line = str_replace("<%title%>",$title,$line);
      $line = str_replace("<%description%>",$description,$line);

      $i++;
    }
    
    return $line;

  }



  // method to edit favorite
  // input :    $status = "display_form"
  //                      "process_form"
  //            $username
  //            $fav_id
  // output :   0 : success
  //            1 : user is not the owner
  // ------------------------------------------

  function EditFavorite($status,$username,$fav_id) {

  global $error_msg, $pflag, $title, $description, $id, $HTTP_POST_VARS;
  
    $query = "select username from $this->favorite_table_name where favorite_id = $fav_id";
    $result = $this->db_connect->Execute($query);
    
    if($username==$result->Fields("username")) {

      $title = stripslashes($title);
      $description = stripslashes($description);
      
      if($status=='display_form') {

        if($pflag!="edit") {
          $query = "select * from $this->favorite_table_name where favorite_id = $fav_id";
          $result = $this->db_connect->Execute($query);
          if($result)  {
            $title = $result->Fields("title");
            $description = $result->Fields("description");
          }
        }
        else $title = $HTTP_POST_VARS["title"];

        // replace strings

        $line = implode(file($this->template_file), "");

        $line = str_replace("<%title%>",$title,$line);
        $line = str_replace("<%id%>",$id,$line);
        $line = str_replace("<%description%>",$description,$line);
        $line = str_replace("<%error_msg%>",$error_msg,$line);

        print $line;
        return 0;
      }

      elseif($status=='process_form') {

        $title = $HTTP_POST_VARS["title"];
        
        $query = "update $this->favorite_table_name set
          title = '$title',
          description = '$description'
          where favorite_id = $fav_id";
        $result = $this->db_connect->Execute($query);

        $line = implode(file($this->template_file), "");

        print $line;
        return 0;
      }
    }

    else return 1;

  }



  // method to create new favorite
  // input :    $username
  //            $title
  //            $description
  // output :   0 : success
  //            1 : sql error
  // ------------------------------------------

  function CreateFavorite($username,$title,$description) {

    $date = $this->db_connect->DBDate(time());

    $query = "insert into $this->favorite_table_name
      (username, title, description, date)
      values ('$username','$title','$description',$date)";
    $result = $this->db_connect->Execute($query);
    if($result) return 0;
    else return 1;
  }



  // method to delete favorite
  // input :    $username
  //            $fav_id
  // output :   0 : success
  //            1 : user is not the owner
  // ------------------------------------------

  function DeleteFavorite($username,$fav_id) {

    $query = "select username from $this->favorite_table_name where favorite_id = $fav_id";
    $result = $this->db_connect->Execute($query);

    if($username==$result->Fields("username")) {

      $query = "delete from $this->favorite_table_name where favorite_id = $fav_id";
      $result = $this->db_connect->Execute($query);

      $query = "delete from $this->favorite_detail_table_name where favorite_id = $fav_id";
      $result = $this->db_connect->Execute($query);

      return 0;
    }

    else return 1;
  }



  // method to view detail favorite
  // input :    $fav_id
  // output :   0 : success
  //            1 : there's no favorite
  // ------------------------------------------

  function ViewFavorite($fav_id) {

    $query = "select username from $this->favorite_table_name where favorite_id = $fav_id";
    $result = $this->db_connect->Execute($query);
    if($result) $username = $result->Fields("username");


    if(!empty($username)) {

      $query = "select link_id from $this->favorite_detail_table_name where favorite_id = $fav_id";
      $result = $this->db_connect->Execute($query);
      $total = $result->RecordCount();

      $this->max_rows = 100;
      if($result) {
        $i=0;
        while($i<$total) {
          $result->Move($i);
          $link_id = $result->Fields("link_id");

          $this->query = "select * from $this->table_name where link_id = $link_id";
          $line .= $this->Display();
          $i++;
        }
      }

      return $line;
    }

    else return 1;
  }



  // method to remove detail favorite
  // input :    $username
  //            $fav_id
  //            $link_id
  // output :   0 : success
  //            1 : user is not the owner
  // ------------------------------------------

  function RemoveDetailFavorite($username,$fav_id,$link_id) {

    $query = "select username from $this->favorite_table_name where favorite_id = $fav_id";
    $result = $this->db_connect->Execute($query);

    if($username==$result->Fields("username")) {

      $query = "delete from $this->favorite_detail_table_name where link_id = $link_id";
      $result = $this->db_connect->Execute($query);

      // update date
      $date = $this->db_connect->DBDate(time()); 
      $query = "update $this->favorite_table_name set date = $date where favorite_id = $fav_id" ;
      $result = $this->db_connect->Execute($query);

      return 0;
    }

    else return 1;
  }
  
  
  
  // method to report bad link
  // input :    $status      = "display_form"
  //                           "process_form"
  //                           "view_all"
  //            $link_id     = link id
  //            $r_name      = name
  //            $r_email     = email
  //            $type        = 1 DNS: Name Not Found
  //                           2 No Reply (Cannot Connect)
  //                           3 Moved
  //                           4 401 Authorization Required
  //                           5 404 Not Found
  //                           6 500 Server Error
  //                           0 Other
  //            $editor      = is in editor panel
  // return :   dispay_form = html
  //            process_form = 0: success              
  //                           1: sql error
  // set var :  $email_template_fields
  // ------------------------------------------

  function BadLinkReport($status,$link_id="",$r_name="",$r_email="",$type="",$editor=false) {

    global $error_msg, $r_name, $r_email, $category, $type_val;

    // get link value

    if(!empty($link_id)) {
      $fields = $this->GetFields();
    
      $query = "select * from $this->table_name where link_id = '$link_id'";
      $result = $this->db_connect->Execute($query);

      $i=0;
      while($i<count($fields)) {
        $field = $fields[$i];
        global $$field;

        $$fields[$i] = $result->Fields("$fields[$i]");
        if($i!=0) $fields_name .= ",";
        $fields_name .= $field;

        $i++;
      }

      $category_obj = new clsCategory;
      $category_obj->InitDB($this->db_server,$this->db_hostname,$this->db_username,$this->db_password,$this->db_name);
      $category_obj->table_name = $this->category_table_name;
      $category_obj->link_table_name = $this->table_name;
      $category_obj->separator = $this->category_separator;

      $category = $category_obj->GetCategoryPath($category_id);

      $this->email_template_fields = str_replace(",",",\$",$fields_name);
      $this->email_template_fields = "\$category,\$r_name,\$r_email,\$type_val,\$"
        .$this->email_template_fields;
    }
    
    if($type==0) $type_val = "Other";
    elseif($type==1) $type_val = "DNS: Name Not Found";
    elseif($type==2) $type_val = "No Reply (Cannot Connect)";
    elseif($type==3) $type_val = "Moved";
    elseif($type==4) $type_val = "401 Authorization Required";
    elseif($type==5) $type_val = "404 Not Found";
    elseif($type==6) $type_val = "500 Server Error";    
    

    if($status=='display_form') {
        // replace strings

        $line = implode(file($this->template_file), "");

        $line = str_replace("<%title%>",$title,$line);
        $line = str_replace("<%url%>",$url,$line);
        $line = str_replace("<%link_id%>",$link_id,$line);
        $line = str_replace("<%error_msg%>",$error_msg,$line);
        $line = str_replace("<%r_name%>",$r_name,$line);
        $line = str_replace("<%r_email%>",$r_email,$line);

        return $line;
    }
        
    elseif($status=='process_form') {

      $date = $this->db_connect->DBDate(time());

      $query = "insert into $this->bad_link_table_name (link_id, name, email, type, date)
        values ($link_id, '$r_name', '$r_email', $type, $date)";
      $result = $this->db_connect->Execute($query);

      if($result) return 0;
      else return 1;
    }

    elseif($status=='view_all') {

      global $pg_which;

      // query
      if(empty($this->query))
        $this->query = "select * from $this->bad_link_table_name order by date desc";

      $result = $this->db_connect->Execute($this->query);
      $num_rows = $result->RecordCount();
    
      // prepare pagination

      if (empty($pg_which)) { $pg_which=1; }

      $nav = new navigator;
      $nav->pg_size = $this->pg_size;
      $nav->cp_size = $this->cp_size;
      $nav->cp_more = $this->cp_more;
      $nav->href = $this->href;
      $nav->more_param = $this->more_param;

      $nav->pg_which=$pg_which;
      $nav->rec_count=$num_rows;
      $nav->init();

      $this->pagination = $nav->print_all();

      $i = $nav->rec_start;
      $stop_loop = $nav->rec_end+1;    
    
      // fetch data

      $chk_num = 1;
      while($i<$stop_loop) {

        $result->Move($i);
        $bad_link_id = $result->Fields("bad_link_id");
        $link_id = $result->Fields("link_id");
        $name = $result->Fields("name");
        $email = $result->Fields("email");
        $date = $result->Fields("date");
        $type = $result->Fields("type");

        if($type==0) $type_val = "Other";
        elseif($type==1) $type_val = "DNS: Name Not Found";
        elseif($type==2) $type_val = "No Reply (Cannot Connect)";
        elseif($type==3) $type_val = "Moved";
        elseif($type==4) $type_val = "401 Authorization Required";
        elseif($type==5) $type_val = "404 Not Found";
        elseif($type==6) $type_val = "500 Server Error";    

        $date = date($this->date_format,$result->UnixDate($date));
        $number = $i+1;

        // show link's detail
        $query = "select title, url, category_id from $this->table_name where link_id = $link_id";
        $result2 = $this->db_connect->Execute($query);
        $title = $result2->Fields("title");
        $url = $result2->Fields("url");
        $category_id = $result2->Fields("category_id");

        $category_obj = new clsCategory;
        $category_obj->InitDB($this->db_server,$this->db_hostname,$this->db_username,$this->db_password,$this->db_name);
        $category_obj->table_name = $this->category_table_name;
        $category_obj->link_table_name = $this->table_name;
        $category_obj->separator = $this->category_separator;

        $category_path = $category_obj->GetCategoryPath($category_id);
        $category_path_with_link = $category_obj->GetCategoryPath($category_id,$this->category_filename);
     
        if($editor) {   
        

          // get editor category
          global $COOKIE_USERNAME;
          $categories = $this->GetEditorCategory($COOKIE_USERNAME);

          if(in_array($category_id,$categories)) {
          
            $this->num_rows++;
            $chk_box = "<input type=checkbox name=chkbox_$chk_num value=$bad_link_id>";
            $chk_num++;
            
            // write template
  
            $line .= implode(file($this->template_file), "");
        
            $line = str_replace("<%number%>",$number,$line);
            $line = str_replace("<%link_id%>",$link_id,$line);
            $line = str_replace("<%name%>",$name,$line);
            $line = str_replace("<%date%>",$date,$line);
            $line = str_replace("<%email%>",$email,$line);
            $line = str_replace("<%type_val%>",$type_val,$line);
      
            $line = str_replace("<%chk_box%>",$chk_box,$line);

            $line = str_replace("<%title%>",$title,$line);
            $line = str_replace("<%url%>",$url,$line);
            $line = str_replace("<%category_path%>",$category_path,$line);
            $line = str_replace("<%category_path_with_link%>",$category_path_with_link,$line);
          }
        }
        
        else {
          $this->num_rows++;
          $chk_box = "<input type=checkbox name=chkbox_$chk_num value=$bad_link_id>";
          $chk_num++;
          
          // write template
  
          $line .= implode(file($this->template_file), "");
      
          $line = str_replace("<%number%>",$number,$line);
          $line = str_replace("<%link_id%>",$link_id,$line);
          $line = str_replace("<%name%>",$name,$line);
          $line = str_replace("<%date%>",$date,$line);
          $line = str_replace("<%email%>",$email,$line);
          $line = str_replace("<%type_val%>",$type_val,$line);
      
          $line = str_replace("<%chk_box%>",$chk_box,$line);

          $line = str_replace("<%title%>",$title,$line);
          $line = str_replace("<%url%>",$url,$line);
          $line = str_replace("<%category_path%>",$category_path,$line);
          $line = str_replace("<%category_path_with_link%>",$category_path_with_link,$line);
        }
        
        $i++;
      }  
      
      return $line;
    }
  }


  // method to delete broken link
  // input :    $op : "delete report"
  //                  "delete link"
  //            $id : broken_link_id
  // return :   0 : success
  //            1 : sql error
  // --------------------------------

  function DeleteBadLinkReport($op,$id) {

    if($op=="delete_report") {
    
      // delete report
      $query = "delete from $this->bad_link_table_name where bad_link_id = $id";
      $result = $this->db_connect->Execute($query);
    
      if($result) return 0;
      else return 1;
    }
    
    elseif($op=="delete_link") {
   
      // get link_id   
      $query = "select link_id from $this->bad_link_table_name where bad_link_id = $id";
      $result = $this->db_connect->Execute($query);
      $link_id = $result->Fields("link_id");
   
      // delete link
      $query = "delete from $this->table_name where link_id = $link_id";
      $result = $this->db_connect->Execute($query);
    
      // delete all report associated with link_id
      $query = "delete from $this->bad_link_table_name where link_id = $link_id";
      $result = $this->db_connect->Execute($query);
    
      if($result) return 0;
      else return 1;
    }
  }



  // method to view duplicate links
  // return :   html
  // --------------------------------

  function ViewDuplicateLinks() {

    $query = "select distinct url, count(url) as cu from $this->table_name 
      group by url order by url";
    $result = $this->db_connect->Execute($query);
    $total = $result->RecordCount();    
  
    $i=0;
    while($i<$total) {
      $result->Move($i);
      $dup_url = $result->Fields("url");
      $url_count = $result->Fields("cu");
      
      if($url_count>1) {
        $this->query = "select * from $this->table_name where url = '$dup_url'";
        $html .= $this->Display();    
      }
      $i++;      
    }
    return $html;
  }



  // method to update new flag
  // ------------------------------------------

  function UpdateNewFlag() {

    // reset new flag
    $query = "update $this->table_name set new = 0";
    $result = $this->db_connect->Execute($query);

    //update
    
    $expired_date = date("Y-m-d H:i:s",time() - (86400 * $this->new_limit));

    $query = "select link_id from $this->table_name
      where date >= '$expired_date' or last_updated >= '$expired_date'
      order by date desc";
    $result = $this->db_connect->Execute($query);
    $total = $result->RecordCount();

    $i=0;
    while($i<$total) {
      $result->Move($i);
      $link_id = $result->Fields('link_id');

      $query = "update $this->table_name set new = 1 where link_id = '$link_id'";
      $result2 = $this->db_connect->Execute($query);
      $i++;
    }
  }
  
  // method to update updated flag
  // ------------------------------------------

  function UpdateUpdatedFlag() {

    // update new flag first
    $this->UpdateNewFlag();

    // reset updated flag
    $query = "update $this->table_name set updated = 0";
    $result = $this->db_connect->Execute($query);

    //update

    $expired_date = date("Y-m-d H:i:s",time() - (86400 * $this->updated_limit));

    $query = "select link_id from $this->table_name where last_updated >= '$expired_date' order by date desc";
    $result = $this->db_connect->Execute($query);
    $total = $result->RecordCount();

    $i=0;
    while($i<$total) {
      $result->Move($i);
      $link_id = $result->Fields('link_id');

      $query = "update $this->table_name set new = 1, updated = 1 where link_id = '$link_id'";
      $result2 = $this->db_connect->Execute($query);
      $i++;
    }
  }

  

  // method to avg review
  // input : $id : link_id
  // ------------------------------------------

  function UpdateAvgReview($id) {

      // get avg value
      $query = "select avg(rating) as avg from $this->review_table_name where link_id = $id";
      $result = $this->db_connect->Execute($query);
      $avg = $result->Fields("avg");

      // update avg value in link table
      $query = "update $this->table_name set avg_review = $avg where link_id = $id";
      $result = $this->db_connect->Execute($query);
  }


  // method to get all webmaster's email address 
  // return :   array that contain email addr.
  // -------------------------------------------

  function GetAllWebmasterEmail() {
  
    $query = "select distinct email from $this->table_name";
    $result = $this->db_connect->Execute($query);
    $total = $result->RecordCount();   
  
    $i=0;
    while($i<$total) {
      $result->Move($i);
      $email[] = $result->Fields("email");        
      
      $i++;
    }
    return $email;
  }





  
// ----------------------------------------------------

// ----- show radio button -----
// $var_name = the name of form field
// $list_text = comma delimited string of text that will be displayed
// $list_value = comma delimited string of value associated with $list_text
// $checked = one of item that in $list_value that will be checked


function ShowRadioButton($var_name,$list_text,$list_value,$checked) {

  $array_text = explode(",", $list_text);
  $array_value = explode(",", $list_value);

  $i=0;
  while($i<count($array_value)) {
    $value = $array_value[$i];
    $text = $array_text[$i];
    if($value==$checked) $output .= "\n $text <input type=radio name=$var_name value=$value checked> ";
    else $output .= "\n $text <input type=radio name=$var_name value=$value> ";
    $i++;
  }

  return $output;
}


}

?>
