<?php 

// --------------------------------------------------------------------------
//
// Sentraweb Application Framework 2.0
// 
// File name   : mailing_list.class.php 
// Description : Class to handle mailing list
// Requirement : - PHP4 (http://www.php.net)
//               - ADODB Library (http://php.weblogs.com)
//                 by John Lim (jlim@natsoft.com.my)
//
//
// Copyright(C), Sentraweb, 2001, All Rights Reserved.
//
// This library is not free. Unauthorized use or distribution of  is strictly 
// prohibited, violators will be prosecuted. To obtain permission for using 
// this library, please contact us at Sentraweb (support@sentraweb.com)
//
// Author: Dody Rachmat Wicaksono (dody@sentraweb.com) 
// Oct, 2001
//
// --------------------------------------------------------------------------





class clsMailingList {


  // ----------
  // attributes
  // ----------
  
  var $table_name = "mailing_list";
  var $message_table_name = "message";
  var $query = "";
  var $date_format = "d-M-Y";
  var $max_rows = "";
  var $header = "";
  var $paging = false;
      
  var $pg_size = "10";
  var $cp_size = "10";
  var $cp_more = "10";
  var $href = "";
  var $more_param = "";

  var $template_file = "";

  var $code;
  var $email_from = "";
    
  // output only  
  var $pagination;
  var $num_rows;
  
  // internal use only  

  var $db_server = "mysql";
  var $db_hostname = "localhost";
  var $db_username = "";
  var $db_password = "";
  var $db_name = "";
  var $db_connect = "";
  
  

  // -------
  // methods
  // -------

  // InitDB($server,$host,$username,$pwd,$db)

  // GetFields()

  // Subcribe($email,$confirm)
  // Unsubscribe($email)  
  // Confirm($email,$code)
  
  // CreateMessage($subject,$body)
  // ViewMessage()
  // ViewSubscriber()
  // EditMessage($status,$message_id,$subject="",$body="")
  // DeleteMessage($message_id)
  
  // SendMessage($status,$message_id,$send_to="")
  // GetAllSubscriber()
  // DeleteSubscriber($email)
    
  
  // method to initialize database connection
  // return :   nothing
  // ----------------------------------------

  function InitDB($server,$host,$username,$pwd,$db) {
  
    $this->db_server = $server;
    $this->db_hostname = $host;
    $this->db_username = $username;
    $this->db_password = $pwd;
    $this->db_name = $db;
    
    ADOLoadCode($this->db_server);    
    $this->db_connect = &ADONewConnection();    
    $this->db_connect->PConnect($this->db_hostname,$this->db_username,$this->db_password,$this->db_name);  
    //$this->db_connect->debug=true;
  }


  
  // method to get fields name
  // return :   array of field name
  // ------------------------------

  function GetFields() {

    // get link fields information 

    $query = "select * from $this->table_name where username = ''";
    $result = $this->db_connect->Execute($query);

    $num_fields = $result->FieldCount();      

    if($result) {
      $i=0;
      while($i<$num_fields) {
        $fld = $result->FetchField($i);
        $fields[] = $fld->name;
        $i++;
      }
    }
    // return array 
    
    return $fields;
  }
  

  // method to handle subscription
  // input :    $email = email address
  //            $confirm = email address confirmation
  // return :   0: success
  //            1  pending
  //            2: email address already exist
  // set : var code
  // ------------------------------------------------

  function Subscribe($email,$confirm=false) {

    
    // is already exist?
    $query = "select email from $this->table_name where status=1 and email = '$email'";
    $result = $this->db_connect->Execute($query);
    if($result->RecordCount()>0)  return 2;
    else {
      if(!$confirm) {
        $query = "insert into $this->table_name (email,code,status) values
          ('$email','',1)";
        $result = $this->db_connect->Execute($query);

        return 0;
      }
      
      else {
      
        // generate code
        mt_srand((double)microtime()*1000000);
        $code = mt_rand();
        $code = substr($code, -4, 4);
        
        $this->code = $code;

        $query = "insert into $this->table_name (email,code,status) values
          ('$email','$code',0)";
        $result = $this->db_connect->Execute($query);
        
        return 1;        
      }
    }
  }  



  // method to handle unsubscription
  // input :    $email = email address
  // return :   0: success
  //            1: email address does not exist
  // ------------------------------------------

  function Unsubscribe($email) {

    
    // is already exist?
    $query = "select email from $this->table_name where status=1 and email = '$email'";
    $result = $this->db_connect->Execute($query);
    if($result->RecordCount()==0)  return 1;
    else {
      $query = "delete from $this->table_name where status=1 and email = '$email'";
      $result = $this->db_connect->Execute($query);

      return 0;
    }
  }  


  // method to handle unsubscription
  // input :    $email = email address
  //            $code = validation code
  // return :   0: success
  //            1: invalid code
  // ------------------------------------------

  function Confirm($email,$code) {
   
    // is exist?
    $query = "select email from $this->table_name where status=0 and email = '$email' and code = $code";
    $result = $this->db_connect->Execute($query);
    if($result) {
      if($result->RecordCount()==0)  return 1;
    
      else {
        $query = "update $this->table_name set status = 1 where code = '$code' and email = '$email'";
        $result = $this->db_connect->Execute($query);

        $query = "delete from $this->table_name where status=0 and email = '$email'";
        $result = $this->db_connect->Execute($query);
        
        return 0;
      }
    }
    else return 1;
  }  


  // method to create new message
  // input :    $subject = message subject
  //            $body = message subject
  // return :   0: success
  //            1: sql error
  // ------------------------------------------

  function CreateMessage($subject,$body) {
  
    $date = $this->db_connect->DBDate(time()); 
  
    $query = "insert into $this->message_table_name (subject,body,date)
      values ('$subject','$body',$date)";
    $result = $this->db_connect->Execute($query);
  
    if($result) return 0;
    else return 1;
  }



  // method to view message
  // return :   html
  // ------------------------------------------

  function ViewMessage() {
  
    $query = "select date, message_id, subject from $this->message_table_name
      order by subject";
    $result = $this->db_connect->Execute($query);
    $total = $result->RecordCount();   
    
    $i=0;
    while($i<$total) {
      $result->Move($i);
      $subject = $result->Fields("subject");
      $message_id = $result->Fields("message_id");
      $date = $result->Fields("date");
      
      $date = date($this->date_format,$result->UnixDate($date));
            
      $line .= implode(file($this->template_file), "");
      $line = str_replace("<%subject%>",$subject,$line);
      $line = str_replace("<%message_id%>",$message_id,$line);
      $line = str_replace("<%date%>",$date,$line);
      
      $i++;
    }
    return $line;    
  }
  


  // method to view subscriber
  // return :   html
  // set : $this->num_rows
  // ------------------------------------------

  function ViewSubscriber() {
  
    $query = "select email from $this->table_name
      where status = 1";
    $result = $this->db_connect->Execute($query);
    $total = $result->RecordCount();   
    $this->num_rows = $total;    

    $i=0;
    while($i<$total) {
      $result->Move($i);
      $email = $result->Fields("email");
      
      $line .= implode(file($this->template_file), "");
      $line = str_replace("<%email%>",$email,$line);
      
      $i++;
    }
    return $line;    
  }


  
  
  // method to edit message
  // input :    $message_id
  //            $status : "display_form"
  //                      "process_form"
  //            $subject
  //            $body
  // return :   0: success
  //            1: sql error
  // ------------------------------------------

  function EditMessage($status,$message_id,$subject="",$body="") {
  
    if($status=='display_form') {
      $query = "select * from $this->message_table_name where message_id = $message_id";
      $result = $this->db_connect->Execute($query);
      
      $subject = $result->Fields("subject");
      $body = $result->Fields("body");
      
      $line .= implode(file($this->template_file), "");
      $line = str_replace("<%message_id%>",$message_id,$line);
      $line = str_replace("<%subject%>",$subject,$line);
      $line = str_replace("<%body%>",$body,$line);
      
      return $line;
    }
    
    elseif($status=='process_form') {

      $date = $this->db_connect->DBDate(time()); 

      $query = "update $this->message_table_name set 
        subject = '$subject',
        body = '$body',
        date = $date
        where message_id = $message_id";
      $result = $this->db_connect->Execute($query);
  
      if($result) return 0;
      else return 1;
    }  
  }
  


  // method to delete message
  // input :    $message_id
  // return :   0: success
  //            1: sql error
  // ------------------------------------------

  function DeleteMessage($message_id) {
  
    $query = "delete from $this->message_table_name where message_id = $message_id";
    $result = $this->db_connect->Execute($query);
    
    if($result) return 0;
    else return 1;
  }
  

  // method to send message
  // input :    $message_id
  //            $status : "confirm_form"
  //                      "process_form"
  // return :   0: success
  //            1: sql error
  // ------------------------------------------

  function SendMessage($status,$message_id,$send_to="") {
  
    
    $query = "select * from $this->message_table_name where message_id = $message_id";
    $result = $this->db_connect->Execute($query);
      
    $subject = $result->Fields("subject");
    $body = $result->Fields("body");

    if($status=='confirm_form') {
      
      $line .= implode(file($this->template_file), "");
      $line = str_replace("<%message_id%>",$message_id,$line);
      $line = str_replace("<%subject%>",$subject,$line);
      $line = str_replace("<%body%>",$body,$line);
      
      return $line;
    }
    
    elseif($status=='process_form') {
    
      // gel all subscribers
      $emails = $send_to;
      
      $i=0;
      while($i<count($emails)) {
        
        $from = $this->email_from;
        @mail($emails[$i],$subject,$body,
           "From: $from \nX-Mailer: INDEXU_X-Mailer/1.0");

        $i++;
      }
    }
  }
  

  // method to get all subscriber
  // return :   array
  // ------------------------------------------

  function GetAllSubscriber() {
  
    $query = "select email from $this->table_name
      where status = 1";
    $result = $this->db_connect->Execute($query);
    $total = $result->RecordCount();   
    $this->num_rows = $total;    

    $i=0;
    while($i<$total) {
      $result->Move($i);
      $emails[] = $result->Fields("email");
      $i++;
    }     
    
    return $emails; 
  }


  // method to delete subscriber
  // input :    $message_id
  // return :   0: success
  //            1: sql error
  // ------------------------------------------

  function DeleteSubscriber($email) {
  
    $query = "delete from $this->table_name where email = '$email' and status = 1";
    $result = $this->db_connect->Execute($query);
    
    if($result) return 0;
    else return 1;
  }


  
}

?>
