<?php 

// --------------------------------------------------------------------------
//
// Sentraweb Application Framework 2.0
// 
// File name   : misc.lib.php 
// Description : Various useful function
// Requirement : PHP4 (http://www.php.net)
//
//
// Copyright(C), Sentraweb, 2001, All Rights Reserved.
//
// This library is not free. Unauthorized use or distribution of  is strictly 
// prohibited, violators will be prosecuted. To obtain permission for using 
// this library, please contact us at Sentraweb (support@sentraweb.com)
//
// Author: Dody Rachmat Wicaksono (dody@sentraweb.com) 
// Oct, 2001
//
// --------------------------------------------------------------------------



// ----- database function -----


function ConnectDB($db=-1,$user=-1,$pwd=-1,$host=-1) {

  global $dbServer;

  if($host!=-1) { $dbHostname = $host; }
  else { global $dbHostname; } 
   
  if($user!=-1) { $dbUsername = $user; }
  else { global $dbUsername; }
  
  if($pwd!=-1) { $dbPassword = $pwd; }
  else { global $dbPassword; }  
  
  if($db!=-1) { $dbName = $db; }
  else { global $dbName; }  
  
  ADOLoadCode($dbServer);         // load MySQL code
  $conn = &ADONewConnection();    // create a connection
  $conn->PConnect($dbHostname,$dbUsername,$dbPassword,$dbName);  // connect to MySQL, agora db
  return $conn;
}



// ----- Use user theme -----

function GetTheme($username) {
  global $conn;
  
  $query = "select theme from idx_users where username = '$username'";
  $result = $conn->Execute($query);
  return $result->Fields("theme");
}


// ----- Get number of links in category -----

function GetNOLCategory($username) {
  global $conn, $max_rows;

  $query = "select nol_category from idx_users where username = '$username'";
  $result = $conn->Execute($query);
  
  $val = $result->Fields("nol_category");
  
  if($val!="") return $val;
  else return $max_rows;
}


// ----- Get number of links in search result -----

function GetNOLSearch($username) {
  global $conn, $max_rows;

  $query = "select nol_search from idx_users where username = '$username'";
  $result = $conn->Execute($query);
  
  $val = $result->Fields("nol_search");
  
  if($val!="") return $val;
  else return $max_rows;
}


// ----- generate 4 digit random code -----

function GenerateRandomCode() {
  mt_srand((double)microtime()*1000000);
  $code = mt_rand();
  $code = substr($code, -4, 4);
  return $code;
}


// ----- date format function -----

function DateFormat($format,$date) { 

    $year     = substr($date,0,4);
    $month    = substr($date,5,2);
    $day 	    = substr($date,8,2);
    $hour	    = substr($date,11,2); 
  	$minute   = substr($date,14,2);
   	$second   = substr($date,17,2);
    
//    return date($format, mktime($hour,$minute,$second,$month,$day,$year));
}

// ----- administrator authentication -----

function AdminAuthenticated() {
  global $cookie_admin_authenticated,$cookie_admin_username,
    $cookie_admin_password,$admin_username,$admin_password;
  
  if($cookie_admin_authenticated && 
    $admin_username==$cookie_admin_username &&
    $admin_password==$cookie_admin_password) return true;
  else return false;
}




// ----- grab news from xml -----

function GrabNews($xml_url) {

  // read and parse 
  $file = fopen($xml_url,"r");
  if (!$file) {
    print "<p>Unable to data file.\n";
    exit;
  }
  while (!feof($file)) {
    $line = fgets($file, 1024);
    if(eregi("<title>(.*)</title>", $line, $t)) $title[] = $t[1];
    if(eregi("<link>(.*)</link>", $line, $u)) $url[] = $u[1]; 
  }
  fclose($file);
  
  // give an output
  $i=1; 
  while($i<count($title)) {
    $nuke_html .= "<a href=$url[$i] target=_blank>$title[$i]</a><br>\n";
    $i++;
  } 

  return $nuke_html; 
}






// ----- show radio button -----
// $var_name = the name of form field
// $list_text = comma delimited string of text that will be displayed
// $list_value = comma delimited string of value associated with $list_text
// $checked = one of item that in $list_value that will be checked


function ShowRadioButton($var_name,$list_text,$list_value,$checked) {

  $array_text = explode(",", $list_text);
  $array_value = explode(",", $list_value);

  $i=0;
  while($i<count($array_value)) {
    $value = $array_value[$i];
    $text = $array_text[$i];
    if($value==$checked) $output .= "\n $text <input type=radio name='$var_name' value='$value' checked> ";
    else $output .= "\n $text <input type=radio name='$var_name' value='$value'> ";
    $i++;
  }
  
  return $output;
}



// ----- show drop down -----
// $var_name = the name of form field
// $list_text = comma delimited string of text that will be displayed
// $list_value = comma delimited string of value associated with $list_text
// $selected = one of item that in $list_value that will be checked


function ShowDropDown($var_name,$list_text,$list_value,$selected) {

  $array_text = explode(",", $list_text);
  $array_value = explode(",", $list_value);

  $output = "\n<select name=$var_name>";
  $i=0;
  while($i<count($array_value)) {
    $value = $array_value[$i];
    $text = $array_text[$i];
    if($value==$selected) $output .= "\n <option value=$value selected>$text</option>";
    else $output .= "\n <option value=$value>$text</option>";
    $i++;
  }
  $output .= "\n</select>";

  return $output;
}

?>
