<?php 

// --------------------------------------------------------------------------
//
// Sentraweb Application Framework 2.0
// 
// File name   : pagination.class.php 
// Description : Split query result to multiple pages and chapters
// Requirement : PHP4 (http://www.php.net)
//
//
// Copyright(C), Sentraweb, 2001, All Rights Reserved.
//
// This library is not free. Unauthorized use or distribution of  is strictly 
// prohibited, violators will be prosecuted. To obtain permission for using 
// this library, please contact us at Sentraweb (support@sentraweb.com)
//
// Author: - Muhammad Zuber (zuber@sentraweb.com) 
//         - Dody Rachmat Wicaksono (dody@sentraweb.com)
//
// Oct, 2001
//
// --------------------------------------------------------------------------



class navigator {

  // ----------
  // attributes
  // ----------

  var $rec_count="";
	var $rec_start="";
	var $rec_end="";
	var $pg_size=5;
	var $pg_count="";
	var $pg_which="";
	var $pg_start="";
	var $pg_end="";
	var $pg_cur="";
	var $cp_size=5;
	var $cp_count="";
	var $cp_cur;
	var $cp_more=2;
	var $w_first="<<";
	var $w_last=">>";
	var $href="";
	var $more_param="";
  var $active_link_color = "";
  var $disable_link_color = "gray";
	

  // -------
  // methods
  // -------

  // init()
  // first()
  // prev()
  // current()
  // next()
  // last()
  // print_item()
  // print_all()
  // printme()
  
  
  

  function init(){
		$this->pg_count=ceil($this->rec_count/$this->pg_size);
		$this->cp_count=ceil($this->pg_count/$this->cp_size);
		$this->pg_cur=$this->pg_which;
		$this->cp_cur=ceil($this->pg_which/$this->cp_size);
		$this->pg_start=($this->cp_cur-1)*$this->cp_size+1;
		$this->pg_end=$this->pg_start+$this->cp_size-1;
		if ($this->pg_end>$this->pg_count) $this->pg_end=$this->pg_count;
		$this->rec_start=($this->pg_cur-1)*$this->pg_size;
		$this->rec_end=$this->rec_start+$this->pg_size-1;
		if ($this->rec_end>=$this->rec_count) $this->rec_end=$this->rec_count-1;
	}
	
	function first(){
		if ($this->cp_cur>1){
		$ref="<a href=\"$this->href?pg_which=1$this->more_param\">$this->w_first</a>&nbsp;";
		return $ref;
		}
	}
	
	function prev(){
		$i=1;
		for ($i=1;$i<=$this->cp_more;$i++){
			$cp_temp=$this->cp_cur-$i;
			if ($cp_temp==0) break;
			$prev_start=($cp_temp-1)*$this->cp_size+1;
			$ref="<a href=\"$this->href?pg_which=$prev_start$this->more_param\">[$prev_start..]</a>&nbsp;".$ref;
		}
		return $ref;
	}
	
	function current(){
		$i=$this->pg_start;
		for ($i=$this->pg_start;$i<=$this->pg_end;$i++){
			if ($i==$this->pg_cur){
				$ref.="<font color=$this->disable_link_color><b>$i</b></font>&nbsp;";
			} else {
				$ref.="<a href=\"$this->href?pg_which=$i$this->more_param\" style='color: $this->active_link_color'>$i</a>&nbsp;";
			}
		}
		return $ref;
	}
	
	function next(){
		$i=1;
		for ($i=1;$i<=$this->cp_more;$i++){
			$cp_temp=$this->cp_cur+$i;
			if ($cp_temp>$this->cp_count) break;
			$next_start=($cp_temp-1)*$this->cp_size+1;
			$ref=$ref."<a href=\"$this->href?pg_which=$next_start$this->more_param\" style='color: $this->active_link_color'>[$next_start..]</a>&nbsp;";
		}
		return $ref;
	}
	
	function last(){
	  if ($this->cp_cur<$this->cp_count){
		$ref="<a href=\"$this->href?pg_which=$this->pg_count$this->more_param\" style='color: $this->active_link_color'>$this->w_last</a>&nbsp;";
		return $ref;
		}
	}
	
	function print_item(){
		echo "<br><br><br>";
		$i=$this->rec_start;
		for ($i=$this->rec_start;$i<=$this->rec_end;$i++){
			echo $i,"<br>";
		}
	}
	
	function print_all(){
    $this->init();
		$ref=$this->first().$this->prev().$this->current().$this->next().$this->last();		
    if($this->pg_count!=1) return $ref;     
	}

	function printme(){
		echo $this->pg_cur,"<br>";
		echo $this->cp_cur,"<br>";
		echo $this->pg_start,"<br>";
		echo $this->pg_end,"<br>";
		echo $this->rec_start,"<br>";
		echo $this->rec_end,"<br>";				
	}
}

?>