<?php 

// --------------------------------------------------------------------------
//
// Sentraweb Application Framework 2.0
// 
// File name   : users.class.php 
// Description : Class to handle membership management
// Requirement : - PHP4 (http://www.php.net)
//               - ADODB Library (http://php.weblogs.com)
//                 by John Lim (jlim@natsoft.com.my)
//               - pagination.class.php (Sentraweb Application Framework 2.0)
//
//
// Cookie variables : $COOKIE_USER_AUTHENTICATED 
//                    $COOKIE_USERNAME
//                    $COOKIE_PASSWORD
//
//
// Copyright(C), Sentraweb, 2001, All Rights Reserved.
//
// This library is not free. Unauthorized use or distribution of  is strictly 
// prohibited, violators will be prosecuted. To obtain permission for using 
// this library, please contact us at Sentraweb (support@sentraweb.com)
//
// Author: Dody Rachmat Wicaksono (dody@sentraweb.com) 
// Oct, 2001
//
// --------------------------------------------------------------------------





class clsUsers {



  // ----------
  // attributes
  // ----------
  
  var $table_name = "members";
  var $query = "";
  var $date_format = "d-M-Y";
  var $max_rows = "";
  var $header = "";
  var $paging = false;
  var $show_number = true;
      
  var $pg_size = "10";
  var $cp_size = "10";
  var $cp_more = "10";
  var $href = "";
  var $more_param = "";
  
  var $enable_validation = true;  
  var $date_format;
    
  var $email_register_subject;  
  var $email_register_from;  
  var $email_register_template_file;

  var $login_box_with_form_template = "";  
  var $login_box_with_username_template = "";

  var $template_file = "";

  // output only  
  var $pagination;
  var $num_rows;
  
  // internal use only  

  var $db_server = "mysql";
  var $db_hostname = "localhost";
  var $db_username = "";
  var $db_password = "";
  var $db_name = "";
  var $db_connect = "";
  
  

  // -------
  // methods
  // -------
  
  // InitDB($server,$host,$username,$pwd,$db)
  
  // GetFields()
  
  // Register($username,$email,$password)
  // ConfirmRegister($username,$vcode)
  
  // Login($username,$password)
  // Logout()
  
  // DisplayLoginBox()
  
  // GetGroupId($username)  
  // GetEmailAddress($username)
  // GetUserAuthentication($group_id)
  
  // ChangeProfile($status,$username)
  // ChangePassword($username,$present_pwd,$new_pwd)
  // ChangePreference($status,$username)
  
  // DisplayUsers()
  
  // Delete($username)
  
  // CheckUsername($username)
  // ChangeEmailAddress($username,$email)
  // GetUserDetail($username)
  
  
  
  
  // method to initialize database connection
  // return :   nothing
  // ----------------------------------------

  function InitDB($server,$host,$username,$pwd,$db) {
  
    $this->db_server = $server;
    $this->db_hostname = $host;
    $this->db_username = $username;
    $this->db_password = $pwd;
    $this->db_name = $db;
    
    ADOLoadCode($this->db_server);    
    $this->db_connect = &ADONewConnection();    
    $this->db_connect->PConnect($this->db_hostname,$this->db_username,$this->db_password,$this->db_name);  
    //$this->db_connect->debug=true;
  }


  
  // method to get fields name
  // return :   array of field name
  // ------------------------------

  function GetFields() {

    // get link fields information 

    $query = "select * from $this->table_name where username = ''";
    $result = $this->db_connect->Execute($query);

    $num_fields = $result->FieldCount();      

    if($result) {
      $i=0;
      while($i<$num_fields) {
        $fld = $result->FetchField($i);
        $fields[] = $fld->name;
        $i++;
      }
    }
    // return array 
    
    return $fields;
  }
  

  // method to add new user
  // return :   0: success
  //            1: user already exist
  //            2: sql error
  // --------------------------------

  function Register($username,$email,$password) {
  
    $username = strtolower($username);

    // check for existing user
    
    $query = "select username from $this->table_name where username='$username'";       
    $result = $this->db_connect->Execute($query);
    
    if($result->RecordCount()==0) $return_value = 0;
    else $return_value = 1;
    
    if($return_value==0) {
    
      // insert into datababase    
    
      $date = $this->db_connect->DBDate(time());
      
      mt_srand((double)microtime()*1000000);
      $vcode = mt_rand();
      $vcode = substr($vcode, -4, 4);
      
      if($this->enable_user_validation) {
        $query = "insert into $this->table_name (username, email, password, theme, date, status, vcode, group_id)
          values ('$username','$email','$password','',$date,0,$vcode,2)";
      }
      else {
        $query = "insert into $this->table_name (username, email, password, theme, date, status, vcode, group_id)
          values ('$username','$email','$password','',$date,1,$vcode,2)";
      }    
      $result = $this->db_connect->Execute($query);
      if(!$result) $return_value = 2;    


      if(!empty($this->email_register_template_file)) {
        // send email
      
        $fields = $this->GetFields();
        $line = implode(file($this->email_register_template_file), "");

        $j=0;
        while($j<sizeof($fields)) {
          $line = str_replace("<%$fields[$j]%>",$$fields[$j],$line);
          $j++;
        }
      
        mail($email,$this->email_register_subject,$line,
          "From: $this->email_register_from\nX-Mailer: INDEXU_X-Mailer/1.0");
      }
    }
    
    return $return_value;
  }

  

  // method to confirm new user
  // return :   0: success
  //            1: sql error
  // --------------------------------

  function ConfirmRegister($username,$v) {

    // get vcode
    
    $query = "select vcode from $this->table_name where username='$username' and status = 0";       
    $result = $this->db_connect->Execute($query);    
    $vcode = $result->Fields("vcode");
    
    if($v==$vcode)  {
      $query = "update $this->table_name set status = 1 where username='$username'";       
      $result = $this->db_connect->Execute($query);    
      
      return 0;
    }
    else return 1;    
  }

  

  // method to handle user login
  // return :   0: success
  //            1: sql error
  // --------------------------------

  function Login($username,$password,$expire) {

    // get password
    
    $query = "select password from $this->table_name where username='$username' and status = 1";       
    $result = $this->db_connect->Execute($query);    
    $pwd = $result->Fields("password");

    if($password==$pwd) {
  
      setcookie(      
        "COOKIE_USER_AUTHENTICATED", //string name
        "1",             //string value
        $expire,         //int expire
        "",              //string path
        "",              //string domain
        0                //int secure
      );      
      
      $username = strtolower($username);
      setcookie(
        "COOKIE_USERNAME", //string name
        "$username",     //string value
        $expire,         //int expire
        "",              //string path
        "",              //string domain
        0                //int secure
      );  

      setcookie(
        "COOKIE_PASSWORD", //string name
        "$pwd",          //string value
        $expire,         //int expire
        "",              //string path
        "",              //string domain
        0                //int secure
      );  

      return 0;
    }
    else return 1;  
  }


  
  // method to handle user logout
  // return :   nothing
  // ----------------------------

  function Logout() {
  
    // delete all cookies

    setcookie(
      "COOKIE_USER_AUTHENTICATED", //string name
      "",             //string value
      0,               //int expire
      "",              //string path
      "",              //string domain
      0                //int secure
    );      

    setcookie(
      "COOKIE_USERNAME", //string name
      "",             //string value
      0,               //int expire
      "",              //string path
      "",              //string domain
      0                //int secure
    );  

    setcookie(
      "COOKIE_PASSWORD", //string name
      "",             //string value
      0,               //int expire
      "",              //string path
      "",              //string domain
      0                //int secure
    );  
  }


  
  // method to display login box in main page
  // return :   html 
  // ----------------------------------------

  function DisplayLoginBox() {
  
    global $COOKIE_USER_AUTHENTICATED,$COOKIE_USERNAME;
  
    // is the user logged in?
    
    if(!$COOKIE_USER_AUTHENTICATED) {
      // display login form
      return $this->login_box_with_form_template;      
    }
    else {
      // display username and logout link      
      return  str_replace("<%username%>",$COOKIE_USERNAME,$this->login_box_with_username_template);      
    }
  }  



  // method to get group_id
  // return :   group_id
  // ----------------------

  function GetGroupId($username) {

    $query = "select group_id from $this->table_name where username='$username' and status = 1";       
    $result = $this->db_connect->Execute($query);    
    if($result)  return $result->Fields("group_id"); 
    else return "";
  }
  


  // method to get email address
  // return :   email
  // ---------------------------

  function GetEmailAddress($username) {
    
    $query = "select email from $this->table_name where username='$username' and status = 1";       
    $result = $this->db_connect->Execute($query);    
    if($result)  return $result->Fields("email"); 
    else return "";
  }




  // method to get user authentication
  // return :   0 : success
  //            1 : failed
  // ----------------------------------

  function GetUserAuthentication($group_id = 100) {

    global $COOKIE_USER_AUTHENTICATED, $COOKIE_USERNAME, $COOKIE_PASSWORD;

    if(empty($COOKIE_USER_AUTHENTICATED) or empty($COOKIE_USERNAME) or empty($COOKIE_PASSWORD))
      return 1; 
      
    else {

      $query = "select password, group_id from $this->table_name where username='$COOKIE_USERNAME' and status = 1";
      $result = $this->db_connect->Execute($query);    
      if($result)  { 
        $pwd = $result->Fields("password"); 
        $gid = $result->Fields("group_id"); 

         if ($group_id == 100) {
          if($COOKIE_USER_AUTHENTICATED && $COOKIE_PASSWORD == $pwd) return 0;
          else return 1;
        }
        else {
          if($COOKIE_USER_AUTHENTICATED && $COOKIE_PASSWORD == $pwd && $group_id == $gid) return 0;
          else return 1;
        }
      }
      else return 1;
    }
  }



  // method to change user profile
  // input :    $status = "display_form"
  //                      "process_form"
  //            $username
  // ------------------------------------------

  function ChangeProfile($status,$username,$admin=false) {

    global $error_msg, $name, $email, $homepage, $icq, $yahoo, $aol, $biography,
      $interest, $location, $occupation, $pflag, $password;
    
    if($status=='display_form') {

      if($pflag!="change") {
        $query = "select * from $this->table_name where username='$username' and status = 1";
        $result = $this->db_connect->Execute($query);
        if($result)  {
          $name = $result->Fields("name");
          $email = $result->Fields("email");
          $homepage = $result->Fields("homepage");
          $icq = $result->Fields("icq");
          $yahoo = $result->Fields("yahoo");
          $aol = $result->Fields("aol");
          $biography = $result->Fields("biography");
          $interest = $result->Fields("interest");
          $location = $result->Fields("location");
          $occupation = $result->Fields("occupation");

          $biography = htmlspecialchars($biography);
          
          if($admin) $password = $result->Fields("password");
        }
      }

      // replace strings

      $line = implode(file($this->template_file), "");

      $line = str_replace("<%error_msg%>",$error_msg,$line);
      $line = str_replace("<%name%>",$name,$line);
      $line = str_replace("<%email%>",$email,$line);
      $line = str_replace("<%homepage%>",$homepage,$line);
      $line = str_replace("<%icq%>",$icq,$line);
      $line = str_replace("<%yahoo%>",$yahoo,$line);
      $line = str_replace("<%aol%>",$aol,$line);
      $line = str_replace("<%biography%>",$biography,$line);
      $line = str_replace("<%interest%>",$interest,$line);
      $line = str_replace("<%location%>",$location,$line);
      $line = str_replace("<%occupation%>",$occupation,$line);
      
      if($admin) {
        $line = str_replace("<%username%>",$username,$line);
        $line = str_replace("<%password%>",$password,$line);
      }

      print $line;
    }

    elseif($status=='process_form') {

      $biography = addslashes($biography);
      $biography = str_replace("\r","",$biography);


      $query = "update $this->table_name set
        name = '$name',
        email = '$email',
        homepage = '$homepage',
        icq = '$icq',
        yahoo = '$yahoo',
        aol = '$aol',
        biography = '$biography',
        interest = '$interest',
        location = '$location',
        occupation = '$occupation'
      ";
        
      if($admin) $query .= ", password = '$password' ";

      $query .= "where username='$username' and status = 1";
      $result = $this->db_connect->Execute($query);
      
      if(!empty($this->template_file)) {
        $line = implode(file($this->template_file), "");
        
        global $message;
        $line = str_replace("<%message%>",$message,$line);
        
        print $line;
      }
    }
  }



  // method to change password
  // input :    $username
  //            $present_pwd
  //            $new_pwd
  //
  // return :   0: success
  //            1: incorect password
  // ------------------------------------------

  function ChangePassword($username,$present_pwd,$new_pwd) {

    // get present pwd
    $query = "select password from $this->table_name where username='$username' and status = 1";
    $result = $this->db_connect->Execute($query);
    $pwd = $result->Fields("password");

    if($present_pwd==$pwd) {
      $query = "update $this->table_name set password = '$new_pwd' where username='$username' and status = 1";
      $result = $this->db_connect->Execute($query);

      return 0;
    }
    else return 1;
  }



  // method to change user preference
  // input :    $status = "display_form"
  //                      "process_form"
  //            $username
  // ------------------------------------------

  function ChangePreference($status,$username) {

  global $error_msg, $pflag, $theme, $nol_category, $nol_search, $theme_path;

    if($status=='display_form') {

      if($pflag!="change") {
        $query = "select * from $this->table_name where username='$username' and status = 1";
        $result = $this->db_connect->Execute($query);
        if($result)  {
          $theme = $result->Fields("theme");
          $nol_category = $result->Fields("nol_category");
          $nol_search = $result->Fields("nol_search");
        }
      }
      
      // make drop down
      
      // read theme directory
      
      $org_theme_path = $theme_path . "../";

      $handle=opendir($org_theme_path);
      while ($file = readdir($handle)) {
        if($file==".") { }
        elseif($file=="..") { }
        elseif($file=="indexu_theme.idf") { }
        else $themes[] = $file;
      }
      closedir($handle);

      sort($themes);

      $theme_sel = "<select name=theme>";
      $i=0;
      while($i<count($themes)) {
        $theme_name = $themes[$i];
        if(empty($theme) && $theme_name=='default') $selected = "selected";
        elseif($theme_name==$theme) $selected = "selected";
        $theme_sel .= "<option value='$theme_name' $selected>$theme_name</option>\n";
        $selected = "";
        $i++;
      }
      $theme_sel .= "</select>";
      $theme = $theme_sel;

      // replace strings

      $line = implode(file($this->template_file), "");

      $line = str_replace("<%error_msg%>",$error_msg,$line);
      $line = str_replace("<%theme%>",$theme,$line);
      $line = str_replace("<%nol_category%>",$nol_category,$line);
      $line = str_replace("<%nol_search%>",$nol_search,$line);

      print $line;
    }

    elseif($status=='process_form') {
      $query = "update $this->table_name set
        theme = '$theme',
        nol_category = '$nol_category',
        nol_search = '$nol_search'
        where username='$username' and status = 1";
      $result = $this->db_connect->Execute($query);

      $line = implode(file($this->template_file), "");

      print $line;
    }
  }



  // method to display userlist
  // ------------------------------------------

  function DisplayUsers() {

    $result = $this->db_connect->Execute($this->query);
    $num_rows = $result->RecordCount();
     
    $fields = $this->GetFields();

    // prepare pagination

    if($this->paging) {
      global $pg_which;

      if (empty($pg_which)) { $pg_which=1; }

      $nav = new navigator;
      $nav->pg_size = $this->pg_size;
      $nav->cp_size = $this->cp_size;
      $nav->cp_more = $this->cp_more;
      $nav->href = $this->href;
      $nav->more_param = $this->more_param;

      $nav->pg_which=$pg_which;
      $nav->rec_count=$num_rows;
      $nav->init();

      $this->pagination = $nav->print_all();

      $i = $nav->rec_start;
      $stop_loop = $nav->rec_end+1;
      $this->max_rows = 100000;
    }
    else {
      $i = 0;
      $stop_loop = $num_rows;
    }

    $number=1;
    $this->num_rows = 0;
    while($i<$stop_loop && $i<$this->max_rows) {

      // get field's value

      $result->Move($i);
      $j=0;
      while($j<count($fields)) {
        $$fields[$j] = $result->Fields("$fields[$j]");
        $j++;
      }

      if($homepage=='http://') $homepage='';
      $date = date($this->date_format,$result->UnixDate($date));
      
      // write template

      // -- template function

      if (empty($this->template_file)) $line = $this->template;
      else $line = implode(file($this->template_file), "");

      $j=0;
      while($j<sizeof($fields)) {
        $line = str_replace("<%$fields[$j]%>",$$fields[$j],$line);
        $j++;
      }

      $chk_box = "<input type=checkbox name=chkbox_$number value=$username>";

      $line = str_replace("<%chk_box%>",$chk_box,$line);

      $user .= $line;

      $number++;
      $this->num_rows++;
      $i++;
    }
    return $user;
  }


  // method to delete user
  // ------------------------------------------

  function Delete($username) {

    $query = "delete from $this->table_name where username = '$username'";
    $result = $this->db_connect->Execute($query);
  }
  


  // method to check if username is exist
  // return :   0 : exist
  //            1 : does not exist
  // ------------------------------------

  function CheckUsername($username) {

    $query = "select username from $this->table_name where username='$username' and status = 1";
    $result = $this->db_connect->Execute($query);

    $username = $result->Fields("username");
    if(empty($username)) return 1;
    else return 0;
  }


  // method to change email address
  // return :   0 : success
  //            1 : sql error
  // ------------------------------------

  function ChangeEmailAddress($username,$email) {

    $query = "update $this->table_name set email = '$email' where username='$username' and status = 1";
    $result = $this->db_connect->Execute($query);

    if($result) return 0;
    else return 1;
  }


  
  // method to get user detail
  // return :   0 : does not exist
  //            associative array of user detail 
  // -------------------------------------------

  function GetUserDetail($username) {

    $query = "select * from $this->table_name where username='$username' and status = 1";
    $result = $this->db_connect->Execute($query);

    if($result) {
      $detail["username"] = $result->Fields("username");
      $detail["name"] = $result->Fields("name");
      $detail["email"] = $result->Fields("email");
      $detail["homepage"] = $result->Fields("homepage");
      $detail["icq"] = $result->Fields("icq");
      $detail["aol"] = $result->Fields("aol");
      $detail["yahoo"] = $result->Fields("yahoo");
      $detail["biography"] = $result->Fields("biography");
      $detail["location"] = $result->Fields("location");
      $detail["interest"] = $result->Fields("interest");
      $detail["occupation"] = $result->Fields("occupation");
      $detail["date"] = $result->Fields("date");

      $detail["date"] = date($this->date_format,$result->UnixDate($detail["date"]));
      
      return $detail;
    }
    else return 0;
  }
  
  
}

?>
