<?php

include("application.php");

// ---------------
//  functions
// ---------------

function SelectModifyUrlMethod() {

  // vars global configuration
  global $theme_path;

  DisplayTemplate($theme_path."modify_select.html",
    "\$novar");
}


function ShowFormModifyUrlSearch() {

  // vars global configuration
  global $dbServer, $dbHostname, $dbUsername, $dbPassword, $dbName,
    $theme_path, $max_rows, $max_pages, $max_chapters;

  // vars url & form
  global $query;
  
  // vars messages
  global $msg;

  // vars template
  global $link, $num_links, $pagination, $error_msg, $keyword;

  $keyword = $query;
  $query = "select * from idx_link where title like '%$query%'";

  $links_obj = new clsLink;
  $links_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);

  $links_obj->query = $query;
  $links_obj->table_name = "idx_link";
  $links_obj->category_table_name = "idx_category";
  $links_obj->template_file = $theme_path."modify_search_rows.html";
  $links_obj->date_format = $msg["10142"];

  $links_obj->paging = true;
  $links_obj->pg_size = 25; //$max_rows;
  $links_obj->cp_size = $max_pages;
  $links_obj->cp_more = $max_chapters;
  $links_obj->href = "modify.php";
  $links_obj->more_param = "&pflag=search&query=$keyword";

  $link = $links_obj->Display();
  $pagination = $links_obj->pagination;
  $num_links = $links_obj->record_count_of_display;
  

  if($num_links==0) {
    $error_msg = str_replace("<%keyword%>",$keyword,$msg["10141"]);
    DisplayTemplate($theme_path."search_error.html","\$error_msg");
  }
  else DisplayTemplate($theme_path."modify_search.html","\$link,\$num_links,\$pagination,\$keyword");
}


function ShowFormModifyUrl() {

  // vars global configuration
  global $dbServer, $dbHostname, $dbUsername, $dbPassword, $dbName,
    $category_separator, $theme_path, $HTTP_POST_VARS;

  // vars url & form
  global $id;  

  // vars messages
  global $msg;

  // vars template
  global $error_msg, $link_id, $title, $url, $description, $category, $contact_name, $email, $custom_field_form;
  
  $title = $HTTP_POST_VARS['title'];
  if(empty($link_id)) $link_id = $id;
  
  $title = stripslashes($title);
  $url = stripslashes($url);
  $description = stripslashes($description);
  $contact_name = stripslashes($contact_name);
  $email = stripslashes($email);
  
  // generate custom field

  $links_obj = new clsLink;
  $links_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
  $links_obj->table_name = "idx_link";
  $links_obj->category_table_name = "idx_category";
  
  $links_obj->autogenerate_form_text = $msg["00001"];
  $links_obj->autogenerate_form_textarea = $msg["00002"];
  $links_obj->autogenerate_form_upload = $msg["00004"];
  $links_obj->autogenerate_form_template = $theme_path."custom_field_form_rows.html";

  $links_obj->upload_html = $msg["10143"];
  $links_obj->remove_img_html = $msg["10144"];

  $links_obj->template_file = $theme_path."modify_form.html";
  $links_obj->Modify("display_form",$link_id);  
}


function ProcessFormModifyUrl() {

  // vars global configuration
  global $site_url, $dbServer, $dbHostname, $dbUsername, $dbPassword, $dbName,
    $theme_path, $category_separator, $HTTP_POST_VARS;      
  
  // vars url & form
  global $id;
      
  // vars messages
  global $msg;
  
  // vars template
  global $error_msg, $link_id, $cat, $title, $url, $description, $contact_name, $email, $bid, $category,
    $password;
  

  $title = $HTTP_POST_VARS['title'];
  if(empty($link_id)) $link_id = $id;
    
  // verify input
  
  if(empty($title)) $error_msg = $msg["10121"];
  elseif(empty($url) || $url == 'http://') $error_msg = $msg["10122"];
  elseif(empty($description)) $error_msg = $msg["10123"];
  elseif(empty($contact_name)) $error_msg = $msg["10124"];
  elseif(empty($email)) $error_msg = $msg["10125"];
  elseif (!IsEmailAddress($email)) $error_msg = $msg["10126"];
  elseif (!empty($bid) && !Ismoney($bid)) $error_msg = $msg["10127"];
  elseif(empty($password)) $error_msg = $msg["10128"];

  if(empty($error_msg)) {
    
    // get field
    $links_obj = new clsLink;
    $links_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
    $links_obj->table_name = "idx_link";
    $links_obj->category_table_name = "idx_category";
    $links_obj->editor_table_name = "idx_editor";
    $links_obj->user_table_name = "idx_users";
    
    $modify_result = $links_obj->Modify("process_form",$link_id);

    $category_obj = new clsCategory;
    $category_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
    $category_obj->table_name = "idx_category";
    $category_obj->separator = $category_separator;
    $category = $category_obj->GetCategoryPath($cat);
    
    
    $title = stripslashes($title);
    $description = stripslashes($description);
    $contact_name = stripslashes($contact_name);

    // successfully modified
    
    if($modify_result==0) {

      // send email submitter

      $body = EvalTemplate($theme_path."mail/modify_ok.mail",$links_obj->email_template_fields);
      $from = $msg["10132"];
      mail($email,$msg["10131"],$body,
         "From: $from \nX-Mailer: INDEXU_X-Mailer/1.0");

      // send email to all editors

      $emails = $links_obj->GetEditorEmail($cat);
      $i=0;
      while($i<count($emails)) {

        $body = EvalTemplate($theme_path."mail/add_ok_editor.mail",$links_obj->email_template_fields);
        $from = $msg["10134"];
        mail($emails[$i],$msg["10133"],$body,
           "From: $from \nX-Mailer: INDEXU_X-Mailer/1.0");
        $i++;
      }
 
      DisplayTemplate($theme_path."modify_ok.html","\$novar");
    }
    
    // pending
    
    elseif($modify_result==1) {

       // send email submitter
      $body = EvalTemplate($theme_path."mail/add_pending.mail",$links_obj->email_template_fields);
      $from = $msg["10136"];
      mail($email,$msg["10135"],$body,
         "From: $from \nX-Mailer: INDEXU_X-Mailer/1.0");

      // send email to all editors

      $emails = $links_obj->GetEditorEmail($cat);
      $i=0;
      while($i<count($emails)) {

        $body = EvalTemplate($theme_path."mail/add_pending_editor.mail",$links_obj->email_template_fields.",\$site_url");
        $from = $msg["10138"];
        mail($emails[$i],$msg["10137"],$body,
           "From: $from \nX-Mailer: INDEXU_X-Mailer/1.0");
        $i++;
      }

      DisplayTemplate($theme_path."modify_pending.html","\$novar");
    }
    
    elseif($modify_result==2) {
      $error_msg = $msg["10129"];
      ShowFormModifyUrl();
    }
  }
  else ShowFormModifyUrl();
}



// --------------
//  main program
// --------------

$conn = ConnectDB();
$title = $titles["1105"];

$theme_name = GetTheme($COOKIE_USERNAME);
if(empty($theme_name)) $theme_name = "default";

$theme_path = $theme_path.$theme_name."/";
include($theme_path."msg.php");



DisplayTemplate($theme_path."header.html","\$title,\$cat");

if (empty($pflag)) {  
  SelectModifyUrlMethod();    
}
elseif($pflag=='search') {
  ShowFormModifyUrlSearch();    
}
elseif($pflag=='retrieve') {
  ShowFormModifyUrl();    
}
elseif($pflag=='modify') {
  ProcessFormModifyUrl(); 
}

DisplayTemplate($theme_path."footer.html","\$novar");

?>

