<?php

include("application.php");

// ---------------
//  functions
// ---------------

function ShowFormSearch() {

  // vars global configuration
  global $dbServer, $dbHostname, $dbUsername, $dbPassword, $dbName,
    $category_separator, $theme_path, $HTTP_POST_VARS;

  // vars url & form
  global $cat;  

  // vars messages
  global $msg;

  // vars template
  global $error_msg, $title, $url, $description, $category, $contact_name, $email, $custom_field_form;
  
  $title = $HTTP_POST_VARS['title'];

  
  // get category path
  
  $category_obj = new clsCategory;
  $category_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
  $category_obj->table_name = "idx_category";
  $category_obj->link_table_name = "idx_link";
  $category_obj->separator = $category_separator;
  $category = $category_obj->DisplayCategoryListBox(-1);

  // generate custom field
  
  $links_obj = new clsLink;
  $links_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
  $links_obj->table_name = "idx_link";
  $links_obj->category_table_name = "idx_category";
  
  $links_obj->autogenerate_form_text = $msg["00001"];
  $links_obj->autogenerate_form_textarea = $msg["00002"];
  $links_obj->autogenerate_form_template = $theme_path."custom_field_form_rows.html";
  $custom_field_form = $links_obj->GenerateCustomFieldForm();
  
  DisplayTemplate($theme_path."power_search_form.html",
    "\$error_msg,\$title,\$url,\$description,\$category,\$contact_name,\$email,\$custom_field_form");
}


function ProcessFormSearch() {

  // vars global configuration
  global $dbServer, $dbHostname, $dbUsername, $dbPassword, $dbName,
    $theme_path, $category_separator, $HTTP_POST_VARS, $HTTP_GET_VARS,
    $max_rows, $max_pages, $max_chapters;
  
  // vars url & form
  global $cat;
      
  // vars messages
  global $msg;
  
  // vars template
  global $link,$num_links,$pagination;
  


  
  // get field
  $links_obj = new clsLink;
  $links_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
  $links_obj->table_name = "idx_link";
  $links_obj->category_table_name = "idx_category";

  $fields = $links_obj->GetFields();


  // ----- querying -----

  $query = "select * from idx_link where 0=0 ";
  $i=0;
  while($i<count($fields)) {
    $field = $fields[$i];

    global $$field;

    if(!empty($HTTP_POST_VARS["title"])) $title = $HTTP_POST_VARS["title"];
    else $title = $HTTP_GET_VARS["title"];

    if(!empty($HTTP_POST_VARS["cat"])) $cat = $HTTP_POST_VARS["cat"];
    else $cat = $HTTP_GET_VARS["cat"];

    if($field=='category_id' && !empty($cat))
      $query .= "and $field = $cat ";

    elseif(!empty($$field))
      $query .= "and $field like '%".$$field."%' ";

    $i++;
  }
  $query .= " order by bid desc";
  
  $links_obj->query = $query;
  $links_obj->template_file = $theme_path."rows.html";
  $links_obj->date_format = $msg["10023"];

  $links_obj->header = $msg["10022"];
  $links_obj->paging = true;
  $links_obj->pg_size = $max_rows;
  $links_obj->cp_size = $max_pages;
  $links_obj->cp_more = $max_chapters;
  $links_obj->href = "power_search.php";


  // get more param for custom fields

  $i=$links_obj->custom_field_offset;
  while($i<count($fields)) {
    $field = $fields[$i];

    global $$field;

    $custom_field_param .= "&".$field."=".$$field;
    $i++;
  }

  $links_obj->more_param = "&pflag=search&title=$title&url=$url&description=$description&cat=$cat&contact_name=$contact_name&email=$email".$custom_field_param;

  $link = $links_obj->Display();
  $num_links = $links_obj->record_count_of_display;
  $pagination = $links_obj->pagination;



  DisplayTemplate($theme_path."power_search_result.html","\$link,\$num_links,\$pagination");
}



// --------------
//  main program
// --------------

$conn = ConnectDB();
$title = $titles["1120"];

$theme_name = GetTheme($COOKIE_USERNAME);
if(empty($theme_name)) $theme_name = "default";

$theme_path = $theme_path.$theme_name."/";
include($theme_path."msg.php");

if(!empty($COOKIE_USERNAME)) $max_rows = GetNOLSearch($COOKIE_USERNAME);


DisplayTemplate($theme_path."header.html","\$title,\$cat");

if (empty($pflag)) {  
  ShowFormSearch();
}
elseif($pflag=='search') {
  ProcessFormSearch();
}

DisplayTemplate($theme_path."footer.html","\$novar");

?>

