<?php

include("application.php");

// ---------------
//  functions
// ---------------

function ShowFormRegister() {

  // vars global configuration
  global $theme_path;

  // vars template
  global $error_msg;

  DisplayTemplate($theme_path."register_form.html","\$error_msg,\$username,\$password,\$password2,\$email");
}


function ProcessFormRegister() {

  // vars global configuration
  global $conn, $dbServer, $dbHostname, $dbUsername, $dbPassword, $dbName,
    $enable_user_validation, $theme_path;      
  
  // vars url & form
  global $username, $password, $password2, $email;  
    
  // vars messages
  global $msg;
  
  // vars template
  global $error_msg;
  
  // verify input
  
  if(empty($username)) $error_msg = $msg["10071"];
  elseif(strlen($username)<3) $error_msg = $msg["10072"];
  elseif(empty($password)) $error_msg = $msg["10073"];
  elseif(empty($password2)) $error_msg = $msg["10074"];
  elseif($password!=$password2) $error_msg = $msg["10075"];
  elseif(empty($email)) $error_msg = $msg["10076"];
  elseif(!IsEmailAddress($email)) $error_msg = $msg["10077"];
  elseif(!IsAlphanumeric($username)) $error_msg = $msg["10080"];
  
  if(empty($error_msg)) {
  
    // register user
    $users_obj = new clsUsers;
    $users_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
  
    $users_obj->table_name = "idx_users";
    $users_obj->enable_user_validation = $enable_user_validation;
    $users_obj->email_register_subject = $msg["10081"];
    $users_obj->email_register_from = $msg["10082"];
    $users_obj->email_register_template_file = $theme_path."mail/register.mail";
    $register = $users_obj->Register($username,$email,$password);
  
    if($register=='1') {    
      $error_msg = $msg["10078"];
      ShowFormRegister();    
    }  
    else { 

      if($enable_user_validation) 
        DisplayTemplate($theme_path."register_confirm.html",
          "\$novar");    
      
      else 
        DisplayTemplate($theme_path."register_ok.html",
          "\$novar");    
    }
  }
  else {
    ShowFormRegister();    
  }
}


function ConfirmRegister() {

  // vars global configuration
  global $conn, $dbServer, $dbHostname, $dbUsername, $dbPassword, $dbName,
    $enable_user_validation, $theme_path;      
  
  // vars url & form
  global $u, $v;  
    
  // vars messages
  global $msg;
  
  // vars template
  global $error_msg;

  $users_obj = new clsUsers;
  $users_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
  $users_obj->table_name = "idx_users";
  
  $confirm = $users_obj->ConfirmRegister($u,$v);
  
  if($confirm==0) {
    DisplayTemplate($theme_path."register_ok.html",
      "\$novar");

    // create My Favorites

    $date = $conn->DBDate(time());
    
    $query = "insert into idx_favorites (username,date,title)
      values ('$u',$date,'My Favorites')";
    $result = $conn->Execute($query);
    
  }
  else {
    DisplayTemplate($theme_path."register_confirm_error.html",
      "\$novar");    
  }
}




// --------------
//  main program
// --------------

$conn = ConnectDB();
$title = $titles["1114"];

$theme_name = GetTheme($COOKIE_USERNAME);
if(empty($theme_name)) $theme_name = "default";

$theme_path = $theme_path.$theme_name."/";
include($theme_path."msg.php");



DisplayTemplate($theme_path."header.html","\$title,\$cat");

if (empty($pflag)) {  
  ShowFormRegister();    
}
  elseif($pflag=='register') {
  ProcessFormRegister(); 
}
  elseif($pflag=='cf') {
  ConfirmRegister(); 
}

DisplayTemplate($theme_path."footer.html","\$novar");

?>

