<?php

include("application.php");

// ---------------
//  functions
// ---------------

function ShowFormReview() {

  // vars global configuration

  global $dbServer, $dbHostname, $dbUsername, $dbPassword, $dbName,
    $theme_path, $COOKIE_USERNAME;
  
  // vars url & form
  global $id;
    
  // vars messages
  global $msg;
  
  // vars template
  global $username, $rev_subject, $rev_rating, $rev_review, $error_msg;

  $links_obj = new clsLink;
  $links_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);

  $links_obj->query = "select * from idx_link where link_id = $id";
  $links_obj->table_name = "idx_link";
  $links_obj->category_table_name = "idx_category";
  $links_obj->category_separator = $category_separator;
  $links_obj->max_rows = 1;
  $links_obj->date_format = $msg["10161"];
  $links_obj->template_file = $theme_path."review_form.html";

  $review_form = $links_obj->Display();
  $review_form = str_replace("<%username%>",$COOKIE_USERNAME,$review_form);
  $review_form = str_replace("<%rev_subject%>",$rev_subject,$review_form);
  $review_form = str_replace("<%rev_rating%>",$rev_rating,$review_form);
  $review_form = str_replace("<%rev_review%>",$rev_review,$review_form);
  $review_form = str_replace("<%id%>",$id,$review_form);
  $review_form = str_replace("<%error_msg%>",$error_msg,$review_form);

  print $review_form;
}


function ProcessFormReview() {

  // vars global configuration
  global $dbServer, $dbHostname, $dbUsername, $dbPassword, $dbName,
    $theme_path, $category_separator;

  // vars url & form
  global $username, $rev_subject, $rev_rating, $rev_review, $id;

  // vars messages
  global $msg;

  // vars template
  global $error_msg, $category;



  // verify input

  if(empty($rev_subject)) $error_msg = $msg["10181"];
  elseif(empty($rev_rating)) $error_msg = $msg["10182"];
  elseif(empty($rev_review)) $error_msg = $msg["10183"];

  if(empty($error_msg)) {

    // get field
    $links_obj = new clsLink;
    $links_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
    $links_obj->table_name = "idx_link";
    $links_obj->category_table_name = "idx_category";
    $links_obj->editor_table_name = "idx_editor";
    $links_obj->user_table_name = "idx_users";
    $links_obj->review_table_name = "idx_review";

    $review_result = $links_obj->Review("process_form",$id,$username,$rev_subject,$rev_rating,$rev_review);

    $cat = $links_obj->GetLinkCategoryId($id);

    $category_obj = new clsCategory;
    $category_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
    $category_obj->table_name = "idx_category";
    $category_obj->separator = $category_separator;
    $category = $category_obj->GetCategoryPath($cat);

    // successfully added

    if($review_result==0) {

      // send email to all editors

      $emails = $links_obj->GetEditorEmail($cat);
      $i=0;
      while($i<count($emails)) {

        $body = EvalTemplate($theme_path."mail/review_pending_editor.mail",$links_obj->email_template_fields);
        $from = $msg["10192"];
        mail($emails[$i],$msg["10191"],$body,
           "From: $from \nX-Mailer: INDEXU_X-Mailer/1.0");
        $i++;
      }

      DisplayTemplate($theme_path."review_ok.html","\$novar");
    }
 }
  else {
    ShowFormReview();
  }
}



// --------------
//  main program
// --------------

$conn = ConnectDB();

$title = $titles["1116"];

$theme_name = GetTheme($COOKIE_USERNAME);
if(empty($theme_name)) $theme_name = "default";

$theme_path = $theme_path.$theme_name."/";
include($theme_path."msg.php");


$conn = ConnectDB();
$query = "select title from idx_link where link_id = '$id'";
$result = $conn->Execute($query);
$link_title = $result->Fields("title");

$title = str_replace("<%link_title%>",$link_title,$title);

if (empty($COOKIE_USERNAME)) {
  $url = urlencode('http://'.$HTTP_ENV_VARS["HTTP_HOST"].$HTTP_ENV_VARS["REQUEST_URI"]);
  header("Location: login.php?b=$url&f=1");
}

DisplayTemplate($theme_path."header.html","\$title,\$cat");

if (empty($pflag)) {
  ShowFormReview();
}
  elseif($pflag=='review') {
  ProcessFormReview();
}

DisplayTemplate($theme_path."footer.html","\$cat,\$ma");

?>

