<?php

include("application.php");

// ---------------
//  functions
// ---------------

function ShowSearchResult() {

  // vars global configuration

  global $conn, $dbServer, $dbHostname, $dbUsername, $dbPassword, $dbName,
    $theme_path, $category_separator, $HTTP_SERVER_VARS,      
    $max_rows, $max_pages, $max_chapters, $number_of_links_format,
    $bold_keyword, $bold_format; 
  
  // vars url & form
  global $pg_which;
    
  // vars messages
  global $msg;
  
  // vars template
  global $keyword, $category, $link, $pagination, $error_msg, $num_categories, $num_links;

 
      
  if(empty($keyword) || strlen($keyword)<3) {
    $error_msg = $msg["10024"];
    DisplayTemplate($theme_path."search_error.html","\$error_msg");
    DisplayTemplate($theme_path."footer.html","\$novar");
    exit();
  }
 

  $keyword_org = $keyword;
  $keywords = explode(" ", $keyword);
  $keywords_org = $keywords;
  
  
  // query category //

  if(empty($pg_which)||$pg_which==1) { 
  
    if(empty($pg_which)) $record_log = true;   

    // build query
    
    $query = "select * from idx_category where 0=0";	

    $i=0;
    while($i<count($keywords)) {
      if(substr($keywords[$i],0,1)=="+") {
	      $keywords[$i] = substr($keywords[$i],1);
		    $query .= " and (name like '%$keywords[$i]%')";
        $eval = 1;
	    }
      if(substr($keywords[$i],0,1)=="-") {
	      $keywords[$i] = substr($keywords[$i],1);
		    $query .= " and (name not like '%$keywords[$i]%')";
        $eval = 1;
	    }
      if(substr($keywords[$i],0,1)=="|") {
	      $keywords[$i] = substr($keywords[$i],1);
		    if($i==0) { $query .= " and (name like '%$keywords[$i]%')"; }
        else  { $query .= " or (name like '%$keywords[$i]%')"; }      
        $eval = 1;
	    }
      else {
		    if($eval != 1) {
          $query .= " and (name like '%$keywords[$i]%')";
	      }
      }
	    $i++;
    }
    $query .= " and visible = 1";
  }
    
  $result = $conn->Execute($query);
  if($result) $num_categories = $result->RecordCount(); 

  
  $category_obj = new clsCategory;
  $category_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);

  $category_obj->table_name = "idx_category";
  $category_obj->link_table_name = "idx_link";
  $category_obj->separator = $category_separator; 
  $category_obj->header = $msg["10021"];

  $category_obj->bold_format = $bold_format;
  $category_obj->bold = $bold_keyword;
  $category_obj->keywords = $keywords;
  
  $category_obj->number_of_columns = 1;
  $category_obj->number_of_links_format = $number_of_links_format;
  $category_obj->show_subcat = false;
  $category_obj->query = $query;
  $category_obj->type_of_list = "SEARCH_RESULT";
  
  $category = $category_obj->Display();
  


  // query links //

  $keywords = $keywords_org;

  $query = "select * from idx_link where 0=0";	

  $i=0;
  while($i<count($keywords)) { 
    if(substr($keywords[$i],0,1)=="+") {
	    $keywords[$i] = substr($keywords[$i],1);
		  $query .= " and (title like '%$keywords[$i]%' or description like '%$keywords[$i]%')";
      $eval = 1;
	  }
    if(substr($keywords[$i],0,1)=="-") {
	    $keywords[$i] = substr($keywords[$i],1);
		  $query .= " and (title not like '%$keywords[$i]%' and description not like '%$keywords[$i]%')";
      $eval = 1;
	  }
    if(substr($keywords[$i],0,1)=="|") {
	    $keywords[$i] = substr($keywords[$i],1);
		  if ($i==0) { $query .= " and (title like '%$keywords[$i]%' or description like '%$keywords[$i]%')"; }
      else { $query .= " or (title like '%$keywords[$i]%' or description like '%$keywords[$i]%')"; }
      $eval = 1;
	  }
    else {
		  if($eval != 1) {
        $query .= " and (title like '%$keywords[$i]%' or description like '%$keywords[$i]%')";
	    }
    }
	  $i++;
  }

  $query .= " order by bid desc"; 

  
  $result = $conn->Execute($query);
  if($result) $num_links = $result->RecordCount(); 


  $keyword = stripslashes($keyword_org);
  
  if($num_categories==0 && $num_links==0) {
    $error_msg = $msg["10025"];
    DisplayTemplate($theme_path."search_error.html","\$error_msg");
    DisplayTemplate($theme_path."footer.html","\$novar");
    exit();
  }
  
  

  $links_obj = new clsLink;
  $links_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
  
  $links_obj->query = $query;
  $links_obj->table_name = "idx_link";
  $links_obj->category_table_name = "idx_category";
  $links_obj->template_file = $theme_path."rows.html";
  $links_obj->date_format = $msg["10023"];
    
  $links_obj->header = $msg["10022"];
  $links_obj->paging = true;
  $links_obj->pg_size = $max_rows;
  $links_obj->cp_size = $max_pages;
  $links_obj->cp_more = $max_chapters;
  $links_obj->href = "search.php";
  $links_obj->more_param = "&keyword=$keyword";  
  
  $links_obj->bold_format = $bold_format;
  $links_obj->bold = $bold_keyword;
  $links_obj->keywords = $keywords;

  $link = $links_obj->Display();
  $pagination = $links_obj->pagination;


  // insert keyword to searchlog table

  if($record_log) {
    $date = date("Y-m-d h:i:s");
    $ip = $HTTP_SERVER_VARS["REMOTE_ADDR"];
    $query = "insert into idx_searchlog (keyword,time,ip,result) values ('$keyword','$date','$ip','$num_links')";
    $result = $conn->Execute($query);
  }

  DisplayTemplate($theme_path."search.html","\$keyword,\$category,\$link,\$num_links,\$num_categories,\$pagination");    
}
    
  



// ---------------
//  main program
// ---------------

$conn = ConnectDB();
$title = $titles["1110"];

$theme_name = GetTheme($COOKIE_USERNAME);
if(empty($theme_name)) $theme_name = "default";

$theme_path = $theme_path.$theme_name."/";
include($theme_path."msg.php");

if(!empty($COOKIE_USERNAME)) $max_rows = GetNOLSearch($COOKIE_USERNAME);

DisplayTemplate($theme_path."header.html","\$title,\$cat");
ShowSearchResult();
DisplayTemplate($theme_path."footer.html","\$novar");
?>
