<?php

include("application.php");

// ---------------
//  functions
// ---------------

function ShowFormTellFriend() {

  // vars global configuration
  global $theme_path;

  // vars url & form
  global $id,$fav;
  
  // vars messages
  global $msg;
  
  // vars template
  global $error_msg, $my_name, $my_email, $friend_name, $friend_email;

  DisplayTemplate($theme_path."tell_friend_form.html","\$fav,\$id,\$error_msg,\$my_name,\$my_email,\$friend_name,\$friend_email");
}


function ProcessFormTellFriend() {

  // vars global configuration
  global $dbServer, $dbHostname, $dbUsername, $dbPassword, $dbName,
    $theme_path;      
  
  // vars url & form
  global $id, $username, $my_name, $my_email, $friend_name, $friend_email;
    
  // vars messages
  global $msg;
  
  // vars template
  global $error_msg;
  

  $my_name = stripslashes($my_name);
  $my_email = stripslashes($my_email);
  $friend_name = stripslashes($friend_name);
  $friend_email = stripslashes($friend_email);

  if(empty($my_name)) { $error_msg = $msg["10201"]; }
  elseif(empty($my_email)) { $error_msg = $msg["10202"]; }
  elseif (!IsEmailAddress($my_email)) {  $error_msg = $msg["10203"]; }
  elseif(empty($friend_name)) { $error_msg = $msg["10204"]; }
  elseif(empty($friend_email)) { $error_msg = $msg["10205"]; }
  elseif (!IsEmailAddress($friend_email)) {  $error_msg = $msg["10203"]; }


  if(empty($error_msg)) {
    if(empty($id)) {

      // tell friend about website
      $body = EvalTemplate($theme_path."mail/tell_friend_website.mail",
	     "\$my_name,\$my_email,\$friend_name,\$friend_email");
     
     $from = $msg["10212"];

      mail("$friend_email",$msg["10213"],$body,
        "From: $from\nX-Mailer: INDEXU_X-Mailer/1.0");
    }

    else {

      // tell friend about a link

      $links_obj = new clsLink;
      $links_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);

      $links_obj->query = "select * from idx_link where link_id = $id";
      $links_obj->table_name = "idx_link";
      $links_obj->category_table_name = "idx_category";
      $links_obj->category_separator = $category_separator;
      $links_obj->max_rows = 1;
      $links_obj->template_file = $theme_path."mail/tell_friend_link.mail";

      $body = $links_obj->Display();

      $body = str_replace("<%friend_name%>",$friend_name,$body);
      $body = str_replace("<%friend_email%>",$friend_email,$body);
      $body = str_replace("<%my_name%>",$my_name,$body);
      $body = str_replace("<%my_email%>",$my_email,$body);


      $from = $msg["10212"];
      mail("$friend_email",$msg["10211"],$body,
        "From: $from\nX-Mailer: INDEXU_X-Mailer/1.0");
    }
    DisplayTemplate($theme_path."tell_friend_ok.html","\$id,\$error_msg,\$my_name,\$my_email,\$friend_name,\$friend_email");
  }
  
  else ShowFormTellFriend();
}


function ProcessFormTellFriendFavorite() {
  // vars global configuration
  global $dbServer, $dbHostname, $dbUsername, $dbPassword, $dbName,
    $theme_path;

  // vars url & form
  global $id, $username, $my_name, $my_email, $friend_name, $friend_email;

  // vars messages
  global $msg;

  // vars template
  global $error_msg, $fav_item;


  $my_name = stripslashes($my_name);
  $my_email = stripslashes($my_email);
  $friend_name = stripslashes($friend_name);
  $friend_email = stripslashes($friend_email);

  if(empty($my_name)) { $error_msg = $msg["10201"]; }
  elseif(empty($my_email)) { $error_msg = $msg["10202"]; }
  elseif (!IsEmailAddress($my_email)) {  $error_msg = $msg["10203"]; }
  elseif(empty($friend_name)) { $error_msg = $msg["10204"]; }
  elseif(empty($friend_email)) { $error_msg = $msg["10205"]; }
  elseif (!IsEmailAddress($friend_email)) {  $error_msg = $msg["10203"]; }


  if(empty($error_msg)) {

    $links_obj = new clsLink;
    $links_obj->InitDB($dbServer,$dbHostname,$dbUsername,$dbPassword,$dbName);
    $links_obj->table_name = "idx_link";
    $links_obj->favorite_table_name = "idx_favorites";
    $links_obj->favorite_detail_table_name = "idx_favorites_detail";
    $links_obj->category_table_name = "idx_category";
    $links_obj->category_separator = $category_separator;
    $links_obj->template_file = $theme_path."mail/tell_friend_favorite_rows.mail";

    $fav_item = $links_obj->ViewFavorite($id);

    $body = EvalTemplate($theme_path."mail/tell_friend_favorite.mail",
      "\$my_name,\$my_email,\$friend_name,\$friend_email,\$fav_item");

/*
    $body = str_replace("<%friend_name%>",$friend_name,$body);
    $body = str_replace("<%friend_email%>",$friend_email,$body);
    $body = str_replace("<%my_name%>",$my_name,$body);
    $body = str_replace("<%my_email%>",$my_email,$body);
    $body = str_replace("<%fav_item%>",$fav_item,$body);
*/

    $from = $msg["10212"];
    mail("$friend_email",$msg["10214"],$body,
      "From: $from\nX-Mailer: INDEXU_X-Mailer/1.0");

    DisplayTemplate($theme_path."tell_friend_ok.html","\$id,\$error_msg,\$my_name,\$my_email,\$friend_name,\$friend_email");
  }

  else ShowFormTellFriend();
}





// --------------
//  main program
// --------------

$conn = ConnectDB();
$title = $titles["1118"];

$theme_name = GetTheme($COOKIE_USERNAME);
if(empty($theme_name)) $theme_name = "default";

$theme_path = $theme_path.$theme_name."/";
include($theme_path."msg.php");


DisplayTemplate($theme_path."header.html","\$title");

if (empty($pflag)) {
  ShowFormTellFriend();
}
elseif($pflag=='tf' && empty($fav)) {
  ProcessFormTellFriend();
}
elseif($pflag=='tf' && $fav==1) {
  ProcessFormTellFriendFavorite();
}

DisplayTemplate($theme_path."footer.html","\$novar");

?>

